#include <hush/source.h>
#include <vip.h>

//#include <scene/character.h>
#include <scene/character.h>


#include <scene/dossier.h>
#include <scene/party.h>
#include <scene/display.h>
#include <scene/game.h>

#include <dx/dossier/try.h>
#include <dx/dossier/dossier.h>
#include <dx/dossier/morph.h>
#include <dx/dossier/scene-x.h>
#include <dx/dossier/game.h>

#include <dx/dossier/panorama.h>




#include <hush/io.h>


static int initialized = 0;


extern "C" {

int HUSH_API load_dossier() {

	
	if (initialized) return 1;
	initialized = 1;
	//scene* sc;



	scene::declare("dossier/try",new vip_try());
	scene::declare("dossier/sample",new vip_dossier());
	scene::declare("dossier/morph",new vip_morph());
	scene::declare("scene/x",new scene_x());
	scene::declare("dossier/game",new vip_game());

	scene::declare("dossier",new dossier());
	scene::declare("party/sebas",new party());
	scene::declare("vip/display",new display());
	scene::declare("vip/game",new game());
    scene::declare("dossier/sample",new dossier());
	scene::declare("dossier/0",new dossier());
	scene::declare("dossier/1",new panorama());
	
	
	//if (session::_trace)
		cerr << "Loading (vip) dossier " << endl;
	return 1;
	}

};
