#include <hush/source.h>
#include <vip.h>

#include <scene/character.h>
#include <scene/dossier.h>
#include <scene/display.h>
#include <scene/game.h>


#include <hush/io.h>


static int initialized = 0;


extern "C" {

int HUSH_API load_scene() {

	
	if (initialized) return 1;
	initialized = 1;

	scene::declare("vip/dossier",new dossier());
	scene::declare("vip/display",new display());
	scene::declare("vip/game",new game());
	
	
	//if (session::_trace)
		cerr << "Loading (vip) scene " << endl;
	return 1;
	}

};
