
#ifndef find_h
#define find_h

#include <hush/export.h>

#include <dshow.h>

struct IDirect3DDevice9;
struct IDirect3DTexture9;
struct ID3DXEffect;
//typedef ID3DXEffect ieffect;
//struct ieffect;
class dxscene;

//char* xfm(char* sz,...);

class HUSH_API machine {
public:
	static int _x;
	static int _y;
	int x(int v = 0);
	int y(int v = 0);
	static char* _cmd;
	char* cmd(char* v = 0);
public:
	machine(char* type=0, int embed=0, char* opt = 0);
	//init(IDirect3DDevice9*  device);
	//render(IDirect3DDevice9*  device, IDirect3DTexture9* texture );

	
	char* svalq(char* x);
	int ivalq(char* x);
	void eval(char* x);
	char* result();

	static char* fm(char* sz,...);

	int width();
	int height();
	int shift(int x = -1);
	int get_shift();
	int ctrl(int x = -1);
	void set_total(int k);
	dxscene* _main();
	int project();
	IDirect3DTexture9* get_capture(int k);
	void set_capture(int k, IDirect3DTexture9* x);
	void set_active(int k);
	int get_active();
	int get_select();

	void debug(char* x, int m = 1);
	ID3DXEffect* fx(char* k, ID3DXEffect* x = 0);


//};



 void handle(char* s1, char* s2);

 static char*  find_video(int type, char* name, IBaseFilter** pSource, wchar_t* match = 0, int idx = 0, char* display = "????");

 static HRESULT  find_capture(IBaseFilter** gottaFilter, wchar_t* matchName = 0, int idx = 0, char* display = "????");
 static HRESULT  find_capture0(IBaseFilter** gottaFilter, wchar_t* matchName = 0);

 static void* scene_create();
 static IDirect3DTexture9*  find_texture(int i);
 static IDirect3DTexture9*  find_capture(int k);
};
 //HRESULT xdevice_create();

 extern "C" {
 void HUSH_API set_window(HWND x);

 
 HRESULT  HUSH_API scene_init(IDirect3DDevice9*  device);
 HRESULT HUSH_API scene_render(IDirect3DDevice9*  device, IDirect3DTexture9* texture );

 HRESULT HUSH_API set_texture0(IDirect3DTexture9* texture);
 HRESULT HUSH_API set_texture(int k, IDirect3DTexture9* texture);

}
 
 

#endif