#include <hush/source.h>

#include "dossier.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/basic.h>
#include <scene/background.h>
//#include <scene/character.h>
//#include "mesh.h"
#include "scene/character.h"


//#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>
#include <scene/slides.h>
#include <scene/video.h>

//#include <ch/extern/embedch.h>
//#include "sampclass.h"

//static CCharacter* _tiny = 0;






static char* _help = "dossier";
//static char* _help = "abramovic";

static scene* dolphin;

void vip_dossier::toggle_ds(char* k) {
	char* s = eq(k);
	int v = scene::ds(s);
	scene::ds(s,v?0:1);
}

void vip_dossier::toggle_opt(char* k) {
	char* s = eq(k);
	int v = iopt(s);
	iopt(s,v?0:1);
}

void vip_dossier::toggle_lst(char* k) {
	char* s = eq(k);
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) lst(s)->exclude(0);
	else lst(s)->exclude(1);
	}
}

void vip_dossier::toggle_text(char* k) {
	char* s = eq(k);
	//if (_text) _text->exclude(1);
	//_text = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) {
		if (_text) _text->exclude(1);
		lst(s)->exclude(0);
		_text = lst(s); 
	} else {	
		lst(s)->exclude(1);
		_text = 0;
	}
	}
}

void vip_dossier::toggle_game(char* k) {
	char* s = eq(k);
	//if (_text) _text->exclude(1);
	//_text = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) {
		if (_game) _game->exclude(1);
		lst(s)->exclude(0);	
		_game = lst(s); 
	} else {	
		lst(s)->exclude(1);
		_game = 0;
	}
	}
}

void vip_dossier::toggle_slides(char* k) {
	char* s = eq(k);
	//if (_slides) _slides->exclude(1);
	//_slides = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x) {
		lst(s)->exclude(0);
		if (_slides) _slides->exclude(1);
		_slides = lst(s); 
	} else { 
		lst(s)->exclude(1);
		_slides = 0;
	}
	if (_slides) _slides->interval(now(),5);
	}
}

void vip_dossier::toggle_lecture(char* k) {
	char* s = eq(k);
	//if (_lecture) _lecture->exclude(1);
	//_lecture = 0;
	if (lst(s)) {
	int x = lst(s)->exclude();
	if (x)  {
		lst(s)->exclude(0);
		if (_lecture) _lecture->exclude(1);
		_lecture = lst(s); 
	} else { 		
		lst(s)->exclude(1);
		_lecture = 0;
	}
	//if (_lecture) _lecture->handle("key","return");
	//if (_lecture) _lecture->handle("key","return");

	}
}





int vip_dossier::exec(char* sx) {
int status = 0;
if (sx)  {
int x = iopt("exec");
iopt("exec",x+1);
//_inexec++;
char* cx = eq(sx);
//char *cmx; if (cmx = cm(cx)) cx = cmx;
char* p = cx;
char c = '\0';
if (p && (p[1] && (p[1] != ':'))) while ((c = *p++) && (c != '\0')) {
	char b[2];
	b[0] = c; b[1] = '\0';
	handle("key",b);
    }
//_inexec--;
if (!x) opt("exec","0");
else iopt("exec",x-1);
}
return status;
}

int vip_dossier::ch(char* x) {
int status = 0;
if (!x) {
ds("z",1);
eq("e:w","wall");

eq("start","nranblcwz1zna12345kxshvbuwfnf1nvanc");


eq("b:a","alternate");
eq("b:w","wall");
eq("b:f","floor");
eq("b:l","frame");
eq("b:m","movie");
eq("b:c","character");
eq("b:p","");

eq("c:s","nranf0nblwnxtrnttnc");
eq("c:x","nranbclwnf0nvanc");
eq("c:0","nranf0nvanc");
eq("c:r","nranc");
eq("c:g","ncxngx");


//eq("c:0","nranbwlnc");
eq("c:1","nranbclwn3uvnxunc");
eq("c:2","nranbcn7bvnxrbunc");
eq("c:3","nranx13tni1n213hnbmcnc");
eq("c:4","nranx13ni1n413hnbmcnc");
eq("c:5","nranf8nx23n8123nc");
eq("c:6","nranx3n813hnbmcnc");
eq("c:7","nrana12345hnbmhnx5nc");
eq("c:8","nranxu32n83n8hnc");
eq("c:9","nranxunc");

eq("d:d","display");
eq("d:m","message");

eq("l:c","lecture/casus");
eq("l:d","lecture/design");
eq("l:v","lecture/vip");

eq("l:i","lecture/imm");
eq("l:m","lecture/imm");
eq("l:1","lecture/convergence");
eq("l:2","lecture/standards");
eq("l:3","lecture/retrieval");
eq("l:4","lecture/eca");


eq("l:a","lecture/awc");
eq("l:e","lecture/eca");
eq("l:s","lecture/step");
eq("l:t","lecture/tam");


eq("s:c","slides/casus");
eq("s:d","slides/design");


eq("s:i","slides/imm");

eq("s:1","slides/convergence");
eq("s:2","slides/standards");
eq("s:3","slides/retrieval");
eq("s:4","slides/eca");

eq("s:a","slides/awc");
eq("s:s","slides/step");
eq("s:t","slides/tam");

eq("s:e","slides/eca");


opt("text","text/design");
opt("help","help");


eq("t:x","display:off");
eq("t:m","message:off");

eq("t:h","help");
eq("t:t",opt("text"));


eq("t:h","text/help");

eq("t:a","text/awc");
eq("t:3","text/step");

eq("t:c","text/casus");
eq("t:d","text/design");
eq("t:v","text/vip");

eq("t:t","text/tam");

eq("t:i","text/imm");
eq("t:1","text/convergence");
eq("t:2","text/standards");
eq("t:3","text/retrieval");
eq("t:4","text/eca");

eq("t:e","text/eca");





eq("v:1","1");
eq("v:2","2");
eq("v:0","0");
eq("v:3","3");
eq("v:4","4");
eq("v:5","5");
eq("v:6","6");
eq("v:7","7");
eq("v:8","8");
eq("v:9","9");

eq("v:b","back");
eq("v:u","under");
eq("v:v","video");

eq("x:0","scene:0");
eq("x:1","scene:1");
eq("x:2","scene:2");
eq("x:3","scene:3");
eq("x:4","scene:4");
eq("x:5","scene:5");
eq("x:6","scene:6");
eq("x:7","scene:7");
eq("x:8","scene:8");
eq("x:9","scene:9");




eq("x:b","back");
eq("x:c","circle");
eq("x:d","dolphin");
eq("x:f","flag");
eq("x:g","game");
eq("x:k","knot");
eq("x:m","morph");
eq("x:s","spectrum");
eq("x:t","trio");
eq("x:r","running");
eq("x:u","under");
eq("x:v","video");
eq("x:w","water");
eq("x:x","x");
eq("x:z","text");

eq("w:e","water:env:off");
eq("w:w","water:off");


//eq("s:x","x");
//cm("x","r67aut");
} else return exec(x); 
return status;
}

#define sclst ((dictionary<scene>*)_sclst)

int vip_dossier::handle(char* type, char* ev) {
    
	if (!strcmp(type,"key") && !iopt("exec")) {
		_command[_pcm++] = _lastc = ev[0];
		_command[_pcm] = '\0';
	}

    int newmode = 1;

	if (_cmode == 'm') cm("meta:m","-");
	else cm("meta:m",fm("%c",_metac));
	cm("meta:o",fm("%c",ev[0]));
	if (_cmode == 'n') cm("meta:c",":");
	else cm("meta:c",fm("%c",_cmode));
	

	//if (_game) _game->handle(type,ev);

	if (check(type,ev,"arrow","up")) {
		if (_game) { moving = 1; sprintf(moved,"w"); }
	} else if (check(type,ev,"arrow","down")) {
		if (_game) { moving = 1; sprintf(moved,"z"); }
	} else if (check(type,ev,"arrow","left")) {
		if (_game) { moving = 1; sprintf(moved,"a"); }
		if (!_game || _ctrl()) scene::handle(type,ev);
	} else if (check(type,ev,"arrow","right")) {
		if (_game) { moving = 1; sprintf(moved,"d"); }
	} else if (!strcmp(type,"stop")) {
		moving = 0;
	
	} else if (check(type,ev,"key","space")) {
		_cmode = 'n';
		cm("meta:c",":");
		moving = 0;
		if (_game) ds("shoot",1);
		if (_lecture) _lecture->handle(type,ev);
		if (_slides) {
			_slides->next(1);
			if (_ctrl()) _slides->interval(now(),5);
		}
	} else if (check(type,ev,"key","back")) {
		if (_slides) _slides->next(-1);
		if (_lecture) _lecture->handle(type,ev);
	} else if (check(type,ev,"key","return")) {
		if (_slides) _slides->next(1);
		if (_lecture) _lecture->handle(type,ev);
	} else if (check(type,ev,"key","tab")) {
		if (_slides) {
			int x = _slides->exclude();
			_slides->exclude(x?0:1);
		}
		if (_lecture) _lecture->handle(type,ev);
	} else
	if (newmode && !strcmp(type,"key") ) {
		char buf[64];
		char c = ev[0];
		if (c == 'n' || c == ':' || c == ';') { _cmode = 'n'; cm("meta:c","-"); }
		else if (_cmode == 'n') switch(c) {
			case 'b':
				_cmode = c; break;;
			default: _cmode = c;  break;;
		
		} else if (_cmode == 'b') switch (c) {
			case 'w': toggle_ds("b:w"); break;;
			case 'a': toggle_ds("displace:a"); break;
			case 'z': toggle_ds("displace:z"); break;
			default: {
				if (instring(c,"0123456789")) {
				sprintf(buf,"%c",c);
				if (ds("displace:a")) ds("a",atoi(buf));
				if (ds("displace:z")) ds("z",atoi(buf));
				} else
				sprintf(buf,"b:%c",c); toggle_ds(buf);
		   } break;;
		} else if (_cmode == 'c') switch (c) {
			//case 's': exec("start"); break;;
			default: sprintf(buf,"c:%c",c); exec(buf); break;;
		} else if (_cmode == 'd') switch (c) {
			case 'b':
				eq("ffect","color-blue");
				lst("scene:5")->process("fx=color-blue"); break;;
			case 'c':
				eq("ffect","color-color");
				lst("scene:5")->propagate("fx=color-color"); break;;
			case 'i':
				eq("ffect","color-id");
				lst("scene:5")->propagate("fx=color-id"); break;;
			case 'x':
				eq("ffect","color-mix");
				lst("scene:5")->propagate("fx=color-mix"); break;;
			case 'r':
				eq("ffect","color-red");
				lst("scene:5")->propagate("fx=color-red"); break;;
			case 'e':
				lst("scene:5")->propagate(fm("fx=%s",eq("ffect"))); break;;
			//case 's': exec("start"); break;;
			default: 
				if (instring(c,"0123456789")) {
				sprintf(buf,"scene:%c",c);
				if (lst(buf)) lst(buf)->process(fm("fx=%s",eq("ffect"))); break;;
				} break;;
		} else if (_cmode == 'f') switch (c) {
			//case 's': exec("start"); break;;
			   case 'r': toggle_ds("focus:stop"); break;;
			   case 's': toggle_ds("focus:stop"); break;
			default:
				if (instring(c,"0123456789")) {
				sprintf(buf,"%c",c);int i; sscanf(buf,"%d",&i);
				scene::ds("flip",1);
				scene::ds("focus",i); 
				} break;;
		} else if (_cmode == 'g') switch (c) {
			case 's': ds("shoot",1); break;;
			case 'x': toggle_game("game"); break;;
			case 'r': toggle_ds("radar"); break;;
			case 'c': exec("f:0"); break;;
			case 'a': moving = moving?0:1; sprintf(moved,"a"); break;;
			case 'z': moving = moving?0:1; sprintf(moved,"z"); break;;
			case 'd': moving = moving?0:1; sprintf(moved,"d"); break;;
			case 'w': moving = moving?0:1; sprintf(moved,"w"); break;;
			case 'q': moving = moving?0:1; sprintf(moved,"q"); break;;
			case 'e': moving = moving?0:1; sprintf(moved,"e"); break;;
			default:
				if (_game) _game->handle(type,ev);
				break;;
		} else if (_cmode == 'i') switch (c) {
	
			default: if (instring(c,"0123456789")) {
				sprintf(buf,"scene:%c",c);
				int i; sscanf(buf,"%d",&i);
				if (lst(buf)) lst(buf)->interval(now(),10);
				} break;;
		} else if (_cmode == 'l') switch (c) {
			default: sprintf(buf,"l:%c",c); toggle_lecture(buf); break;;
		} else if (_cmode == 'o') switch (c) {
			case 'f': scene::cm("overlay:floor",cm("overlay"));
			case 'w': scene::cm("overlay:wall",cm("overlay"));
			default: if (instring(c,"a0123456789")) {
				sprintf(buf,"%c",c);
				char* f = "color-blue";
				if (c != '0') scene::cm("overlay",buf);
				else scene::cm("overlay","nil");
				//if (lst(buf)) lst(buf)->interval(now(),10);
				} break;;
		} else if (_cmode == 'p') switch (c) {
			case 'b': eq("effect","color-blue"); break;;
			case 'c': eq("effect","color-color"); break;;
			case '0':
			case 'i': eq("effect","color-id"); break;;
			case 'x': eq("effect","color-mix"); break;;
			case 'r': eq("effect","color-red"); break;;
			case 'd': scene::cm("wall:fx",eq("effect")); break;;
			case 'w': scene::cm("wall:fx",eq("effect")); break;;
			case 'f': scene::cm("floor:fx",eq("effect")); break;;
			case 'm': scene::cm("walk:fx",eq("effect")); break;;

			default: 
				if (instring(c,"0123456789")) {
				sprintf(buf,"scene:%c",c);
				if (lst(buf)) lst(buf)->process(fm("fx=%s",eq("ffect"))); break;;
				} break;;
		} else if (_cmode == 's') switch (c) {
			default: sprintf(buf,"s:%c",c); toggle_slides(buf); break;;	
		} else if (_cmode == 't') switch (c) {
			case 'x': toggle_ds("t:x"); break;;
			case 'm': toggle_ds("t:m"); break;;
			default: sprintf(buf,"t:%c",c); toggle_text(buf); break;;
		} else if (_cmode == 'v') switch (c) {
			case 'a': 
				scene::ds("flip",1);
			    //scene::ds("focus",0);
				break;;
			case 'p':
				scene::ds("flip",1);
			    scene::ds("focus",4);
				break;;
			case 's': toggle_ds("mode:shift"); break; // toggle_opt
			//case 'w': toggle_ds("b:w"); break;;
			default: 
				sprintf(buf,"v:%c",c); toggle_ds(buf); 
				if (ds("mode:shift")) { sprintf(buf,"shift:%c",c); toggle_ds(buf); }
				     break;;

			//toggle_ds("1");
		    //toggle_ds("shift:1");
		} else if (_cmode == 'x') switch (c) {
			case 'v': sc("slides")->interval(now(),5); toggle_lst("x:v"); break;;
			case 'w': toggle_lst("x:w"); break;;
			default: sprintf(buf,"x:%c",c); toggle_lst(buf); break;;
		} else if (instring(_cmode,"az0123456789")) switch (c) {
			//case 'a':
			case '0': 
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9': {
				char buf[64];
				sprintf(buf,"scene:%c",c);
				scene* sx = lst(buf);
				if (sx) sx->opt("tx",fm("%c",_cmode));
				} break;;
			case 'b': scene::cm("floor:tx",fm("%c",_cmode)); break;;
			case 'u': scene::cm("wall:tx",fm("%c",_cmode)); break;;
			case 'h': scene::cm("hall",fm("%c",_cmode)); break;;
			//case 'l': scene::cm("hall",fm("%c",_cmode)); break;;

			//case 't': sc("lecture/tam")->opt("tx",fm("%c",_cmode)); break;;
			//case 't': sc("lecture/tam")->opt("tx",fm("%c",_cmode)); break;;

			//case 's':
			case 'e': sc("lecture/eca")->opt("tx",fm("%c",_cmode)); break;;
			//case 't': sc("lecture/tam")->opt("tx",fm("%c",_cmode)); break;;
			case 'v': sc("lecture/vip")->opt("tx",fm("%c",_cmode)); break;;
			//case 'l': scene::cm("hall",fm("%c",_cmode)); break;;
			case 'f': lst("flag")->opt("tx",fm("%c",_cmode)); break;;
			case 'm': lst("morph")->opt("tx",fm("%c",_cmode)); break;;
			case 'k': lst("knot")->opt("tx",fm("%c",_cmode)); break;;
			case 's': lst("spectrum")->opt("tx",fm("%c",_cmode)); break;;
			case 'w': lst("water")->opt("tx",fm("%c",_cmode)); break;;
			case 'x': lst("x")->opt("tx",fm("%c",_cmode)); break;;
			default: /*sprintf(buf,"x:%c",c); toggle_lst(buf);*/
				break;;
		} else if (_cmode == 'r') switch (c) {
			case 'a': { 
        int s = 0;
		if (!iopt("exec")) {
		cm("last",_command);
		_pcm = 0; _command[_pcm] = '\0';
		}
		char* ds[] = { "character","hall","floor","wall","movie","frame", 0 };
		
		for (int i = 0; i <= 10; i++) _exclude[i] = 1;	
		iter<string>& it = *sclst;
			scene* sc = 0;
			string* p = 0;
			while (p = it()) {
				sc = (*sclst)[p];
				sc->exclude(1);
			}
		
		char* pds = 0; int k = 0;
		scene::ds("alternate",0);
		while (pds = ds[k]) {
			scene::ds(pds,1);
			k++;
		} };
		break;;
			default: {
				if (instring(c,"123456789")) {
					toggle_ds(fm("run:%c",c));
				}
					 } break;;
		} else if (_cmode == 'w') switch (c) {
			case 'b': exec("npbwfmnw"); break;;
			case 'r': exec("nprwfmnw"); break;;
			case 'i': exec("npiwfmnw"); break;;
			case 'm': exec("npmwfnw"); break;;
			case 'x': exec("nprmnpbfnwenxwnw"); break;;
			case 'z': exec(":pxmbf:we:xw:w"); break;;
			//case 'w': toggle_lst("x:w"); break;;
			default: sprintf(buf,"w:%c",c); toggle_ds(buf); break;;
	   
	
		} else 	return scene::handle(type,ev);

	 
	  
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_dossier::operator()()
{
  

//state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_dossier::vip_dossier(char* opts) 
{
	_metac = '-';
	_slides = 0;
	_text = 0;
	_game = 0;
	_lecture = 0;
	alternate = 0;
	txdur = 15;
	count = 12;
	_inexec = 0;
	_cmode = 'n';
	_lastc = 'n';
	//state = 2;

	_pcm = 0;
	_command[_pcm]='\0';

	ch();

	//char* cs = _tk->strvalue("X:dossier(start(X)))");
	

_size = 20; //size;
wsprintf(_type,"scene");
_display = "sample dossier";

_sim->passivate(this);
_sim -> schedule(this,0.0);


end(20);
loop = 1;

//_tiny = new CCharacter();



//scenes[1] = new satelite();
//scenes[0] = new shader(new background(),"fx=back");
//scenes[0]->opt("shaders","material");
sprintf(moved,"x");
moving = 0;


//scenes[1] = new basic(new satelite("mesh=knot"),"fx=plain");
//scenes[1]->propagate("distort=1");
scene* scx = new mesh("knot");
scx->propagate("distort=1");
//sc->_shader = "red";
scenes[1] = scx;
//scenes[1] = new shader(sc,"fx=red"); 
//scenes[1] = new shader(scx,"fx=red"); 
scene::declare("dossier/knot",scenes[1]);

//scenes[1]->rotation(0.1,-0.1,0,1.0);
scenes[1]->translation(-3,-2,0);
scenes[1]->scale(5,5,5);

scenes[2] = new mesh("yt");
scenes[2] = new shader(new mesh("raven"),"fx=blue");
//scenes[2] = new shader(new mesh("poser-ae"),"fx=blue");
scenes[2]->translation(2.5,-2,-2);
scenes[2]->rotation(0,-2.57,0.2,1);
scenes[2]->scale(0.9,0.9,0.9);


//scenes[3] = new mesh("nana");
scenes[3] = new mesh("nana");
//scenes[3] = new vip_mesh();
scenes[3]->translation(2,-2,0);
scenes[3]->scale(1.5,1.5,1.5);
scenes[3]->rotation(0.0,1,0,0.5 * 3.14);

scenes[4] = sc("vip/morph"); //->create("text=text/dossier");
scenes[5] = sc("lecture/casus");

scenes[11] = 0;


lst("text",sc("text/casus")->create());
_sim->schedule(lst("text"),0);



_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1;
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 1;
_exclude[7] = 1;
_exclude[8] = 1;
_exclude[9] = 1;
_exclude[10] = 1;



//scenes[2]->scale(0.3,0.3,0.3);




//scale(0.8,0.8,0.8);



 

 
  
}




vip_dossier::~vip_dossier()
{
//delete scenes[];
}

int 
vip_dossier::_load()
{
    int hr = S_OK;

	
    if (cm("dossier(start)")) { eq("start",cm("dossier(start)")); }
    //debug(eq("start"),1);
    //scenes[0] = sc("lecture/dossier");
	scenes[6] = sc("vip/trio");
	scenes[7] = sc("anim/trio");
    scenes[8] = sc("effect/spectrum");
	scenes[8]->_blend = 1;
    scenes[10] = sc("vip/water");
	scenes[9] = sc("vip/flag");

	iopt("start",1);

	scene* scx = new mesh("sphere");
    lst("circle",new shader(scx,"fx=project-color"));
    lst("circle")->translation(1.5,0,0);
    lst("circle")->scale(0.3,0.3,0.3);
	lst("circle1",new shader(scx,"fx=color-blue"));
	lst("circle2",new shader(scx,"fx=color-red"));
	lst("circle3",new shader(scx,"fx=color-color"));
	lst("circle4",new shader(scx,"fx=color-mix"));

    /*
	scx = new mesh("sphere");
    lst("circle1",new shader(scx,"fx=color-blue"));
    lst("circle1")->translation(1.5,0,0);
    lst("circle1")->scale(0.3,0.3,0.3);

	scx = new mesh("sphere");
    scx = new mesh("sphere");
    lst("circle1",new shader(scx,"fx=color-blue"));
    lst("circle1")->translation(1.5,0,0);
    lst("circle1")->scale(0.3,0.3,0.3);
    lst("circle2")->translation(1.5,0,0);
    lst("circle2")->scale(0.3,0.3,0.3);
*/
	/*
	scene* x;
    x = new object_flag();
//x->rotation(0,1,0,0.5 * 3.14);
    x->scale(2.3,0.9,0.5);
    x->translation(0,-16.2,10); // no op
    x->_lights = 1;
    */

	scene* s = lst("text")->sc("slides");
	popt("slides",s);
	//scene* v = new video(s);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("video",s);
	s->iopt("tx",5);

    scene* x = sc("lecture/wave");//->create();
	x->iopt("tx",5);
	//v = new video(x);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("under",x);

	x = sc("scene/3")->create();
	//v = new video(x);
	//v->opt("type","2");
	//v->opt("name","..\\media\\isabelle.avi");
	//v->opt("name","d:\\video\\clockwork.avi");
	lst("back",x);
	x->iopt("tx",5);

	lst("trio", sc("vip/trio"));
	lst("running", sc("anim/trio"));

	lst("help",sc("text/help"));
	lst("knot",sc("dossier/knot"));
	lst("flag",sc("vip/flag"));
	lst("morph",sc("vip/morph"));
	lst("water",sc("vip/water"));
	lst("spectrum",sc("effect/spectrum"));
	lst("spectrum")->_blend = 1;
	lst("x",sc("x/seafloor"));
	lst("dolphin",sc("vip/dolphin"));
	lst("game",sc("dossier/game"));

	
	char* pls[] = {
		"imm", "convergence", "standards", "retrieval", "environments", 
		"casus", "design",
        "eca", "awc", "step",
		"tam", "vip", 
		0 };
    int i = 0; char* p = 0;
	while (p = pls[i]) {
		i++;
		char* pl = fm("lecture/%s",p);
		char* pt = fm("text/%s",p);
		char* ps = fm("slides/%s",p);
        if (sc(pl)) lst(pl,sc(pl));
	    if (sc(pt)) lst(pt,sc(pt)->create());
		if (lst(pt)) _sim->schedule(lst(pt),0);
		if (lst(pt)) lst(ps,lst(pt)->sc("slides"));
		//if (lst(pl)) lst(pl)->opt("tx","active");
		if (lst(ps)) lst(ps)->opt("tx","a");
		//if (lst(ps)) lst(ps)->opt("tx","z");
	}
	

	lst("scene:0",sc("scene/0"));
	lst("scene:1",sc("scene/1"));
	lst("scene:2",sc("scene/2"));
	//lst("scene:2")->opt("fx","color-red");
	lst("scene:3",sc("scene/3"));
	lst("scene:4",sc("scene/3x"));
	lst("scene:5",sc("scene/x")->create());

	/*
    lst("morph")->exclude(1);
	lst("morph")->exclude(1);
	lst("flag")->exclude(1);
	lst("water")->exclude(1);
	lst("spectrum")->exclude(1);
	lst("knot")->exclude(1);
	lst("x")->exclude(1);
	//lst("dolphin")->exclude(1);
	*/
	_lst = 1;
	//lst("morph")->exclude(1);
    
	dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];
	lst("dolphin",dolphin);
	//handle("key","n");
	//handle("key","r");
	//handle("key","a");
	//handle("key","n");

    //lst("slides")->exclude(0);
    //_cmode = 'n';
	exec("nran");

	hr = scene::init(_device); // loops through scenes

	//exec("nran");

	
    return hr;
}

int
vip_dossier::_restore()
{
    HRESULT hr = S_OK;
    float txtime = txdur;
	if (ds("alternate")) {
	static float tm = dxtime();
	if ((dxtime() - tm) > txtime) { tm = dxtime(); scene::ds("flip",1); } //_main()->iopt("flip",2);  }
	}

	if (iopt("start")) { opt("start","0"); exec("start"); }

	if (0 && scenes[0]) {
		_handler(scenes[0]);
	} else {
		//_handler(this);
    }
	


    return hr;
}


int
vip_dossier::_render( ) 
{
HRESULT hr = S_OK;

    if (_game && moving) _game->handle("key",moved);
   
   
    dolphin->state = 1;
	
	//_tiny->Compose((DWORD) 1000 * fraction());
	scenes[1]->rotation(sin(dxtime()),sin(dxtime()),cos(dxtime()),1);
   

	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
  
	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		if (!ds("message:off")) message(100,_y-200,argb(255,255,120,120),fm("%s [%d] (%c) ",_help,state,_cmode)); //,_command));
	} 
	
	

	if (!ds("display:off")) display(_display);
    //dolphin->state = hold;
	render_end(_device);

 

    return hr;
}

