
#include <hush/source.h>
#include <hush/query.h>
#include "menu-create.h"

// sub scenes

//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
#include "lectures/lecture-eca.h"
#include "lectures/lecture-imm.h"
#include "lectures/lecture-vip.h"
#include "lectures/lecture-effects.h"
//#include "odyssee/scene-test.h"
#include "objects/background-scene.h"
#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"
#include "extra/object-dolphin.h"
#include "extra/object-spectrum.h"
#include "extra/object-grab.h"
#include "scene/video.h"
#include "extra/object-water.h"
#include "extra/object-flag.h"


#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 2;
static int enable = 0;

static int testmode = 0;
static msg_array msg;

menu_create::menu_create() 
{

_msg = &msg;

_selection = preset;
_enabled = enable;

_stack = 1;
set_mode(1);

scene::declare("create", this);

//scenes[0] = (dxscene*) dvscene::lookup("background");
//scenes[0]->opt("tx","camera");
//_exclude[0] = 1;

clear(&msg);

//debug("create 1",1);

msg[1][2] = "creative technology";
msg[1][3] = "make a difference ...";
msg[1][4] = "new media literacy";
msg[1][7] = "gaming is a waste of time";
//msg[1][3] = "codecs and standards";
//msg[1][4] = "information retrieval";

_states = 8;
state = 1;

_display = "creative technology / new media";
//opt("head",  _tk->strvalue("X:head(_,create = X)"));
//_display = opt("head");
opt("preset",  _tk->strvalue("X:preset(_,create = X)"));
preset = iopt("preset");
preset = 3;

int _camera = _tk->intvalue("X:camera(video:mode = X)");

cm("video:name",_tk->strvalue("X:camera(video:name = X)"));
cm("video:grab",_tk->strvalue("X:camera(video:grab = X)"));

/*
if (_camera) {
ds("video:device",_tk->intvalue("X:camera(video:device = X)"));
ds("video:type",_tk->intvalue("X:camera(video:type = X)"));
ds("video:show",_tk->intvalue("X:camera(video:show = X)"));
ds("video:debug",_tk->intvalue("X:camera(video:debug = X)"));
ds("video:map",_tk->intvalue("X:camera(video:map = X)"));
ds("video:distort",_tk->intvalue("X:camera(video:distort = X)"));
ds("video:overlay",_tk->intvalue("X:camera(video:overlay = X)"));

//lst("grab",new video( new object_grab()));
//_lst = 0;
//_scene = new video( new object_grab());
_scene = new video( (scene*) lookup(cm("video:grab")));
_scene->iopt("ds",ds("video:map"));
//_exclude[0] = 0;
} else {
	
	_scene = (scene*) lookup(cm("video:grab")); //new object_grab();
	iopt("tx",1);
	//_scene->iopt("tx",1);
}
*/

//_scene = new scene(); //sc("background");

_exclusive = 1;
//count =  states + 2;
if (!_tk) {
	_tk =  new query("kit=pl");
}

char* _test = "sim";
if ( _tk) {

//char args[]="kit=pl src=file:/vip/scripts/scene.pl";
  
  
	
	//debug("create tk",1);

/*	
	_tk->load("x");
	_tk->load("donuts");
	_tk->load("shader");
	_tk->load("anim");
	_tk->load("dossier");

	//debug("create test",1);
	_test = "vip/morph"; //"vip/morph";
*/
}

//debug("create begin",3);
/*
scenes[2] =  (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,create:2 = X)"));
scenes[3] =  (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,create:3 = X)"));
*/
scenes[2] =  (dxscene*) dvscene::lookup("lecture/create/inspire");
scenes[3] =  (dxscene*) dvscene::lookup("lecture/create/announce");
scenes[4] =  (dxscene*) dvscene::lookup("lecture/create/aesthetics");

scenes[7] =  (dxscene*) dvscene::lookup("lecture/create/game");




scenes[10] = (dxscene*) dvscene::lookup("object/dolphin/1");
//debug("create dolph",3);


_stack = 1;


//debug("create end",3);

}

HRESULT menu_create::init(IDirect3DDevice9* device) {
HRESULT hr = S_OK;
menu::init(device);
scenes[2] =  (dxscene*) dvscene::lookup("create/announce");
scenes[3] =  (dxscene*) dvscene::lookup("lecture/create/announce");
scenes[4] =  (dxscene*) dvscene::lookup("lecture/create/inspire");

scenes[7] =  (dxscene*) dvscene::lookup("lecture/create/game");
ds("nopreview",0);
return S_OK;
}

menu_create::~menu_create()
{
//delete scenes[];
}


HRESULT menu_create::compose(IDirect3DDevice9* device, DWORD t){
	HRESULT hr = S_OK;
	//count = 12;
	_exclude[10] = 1;
	scenes[10]->state = 1;
	_exclude[11] = 0;
	if (_enabled) _exclude[11] = 1;
	//_exclude[11] = 0;
	_project(_active());
	_effect = 0;
	_lst = 0;
	scenes[0] = lst("grab");
	_exclude[0] = 0;
	//_scene->exclude(1); // AE
	if (!_enabled) {
	//fx("walk",(ieffect*)_main());
	_exclude[0] = 0;
    cm("bgcolor","(100,100,100)");
	scene::ds("video:show",1);
    scene::ds("video:nobg",0);
	scene::ds("nopreview",1);
	ds("noenv",1);
	
	} else { 
		//ds("camera:mode",0);
		ds("noenv",0);
		_exclude[0] = 0;
		scene::ds("video:nobg",1);
		//scene::ds("video:nobg",1);
		//scene::ds("nopreview",0);
		//scene::ds("video:show",1);
		//scene::ds("video:nobg",0);
        //cm("bgcolor","(0,0,0)");
		//_scene->exclude(1);
	    }

    //_display = opt("head");
	//_texture = _scene->_texture;
	if (ds("camera:mode")) { 
		_texture = _scene->_texture;
		//tx("camera",_texture);
		//tx(1,_texture);
	}
    //_exclude[0] = 1;

	ds("nopreview",0);
	//_scene->exclude(1);
	return hr;
}
/*
HRESULT 
menu_create::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

	//restore(device);

    for (int i = 1; i < count; i++) _exclude[i] = 1;
	//_handler = _menu;
	//_menu->exclude(0);

    if (!_enabled || _selection == 0) {
		_handler = _menu;
		_exclude[count-1] = 0;
		_menu->state = state;
		//_menu->exclude(0);
	} else if (_enabled && _selection > 0) {
		//scenes[_selection]->exclude(0);
		_handler = scenes[_selection];
		_exclude[_selection] = 0;
		_exclude[count-1] = 1;
		//_menu->exclude(1);
	}

	render_begin(device);


	hr = scene::render(device,texture); // calls restore, compose, render
   

	if (!_selection) display(_display);
	render_end(device);

 
    return hr;
}

*/
