#include <hush/source.h>
#include "menu-effects.h"

// sub scenes
//#include <d3d9.h>
//#include <d3dx9.h>
#define PTCHAR TCHAR*
//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
#include "lectures/lecture-eca.h"
#include "lectures/lecture-imm.h"
#include "lectures/lecture-vip.h"
#include "lectures/lecture-effects.h"
//#include "lectures/scene-test.h"
#include "objects/background-scene.h"
#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"

#include "extra/object-vsh.h"
#include "extra/object-dolphin.h"
#include "extra/object-spectrum.h"
#include "extra/object-water.h"

#include "extra/object-flag.h"
#include "scene/video.h"

#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 1;
static int enable = 0;

static int testmode = 0;
static msg_array msg;

menu_effects::menu_effects() 
{


_msg = &msg;

_selection = preset;
_enabled = enable;
_exclusive = 1;

clear(&msg);



msg[1][1] = "...";
msg[1][2] = "shader";
msg[1][3] = "dolphin";
msg[1][4] = "water";
msg[1][5] = "spectrum";
msg[1][6] = "wave";
//msg[1][3] = "codecs and standards";
//msg[1][4] = "information retrieval";

_states = 9;
state = 1;

_display = "effects";

//count =  states + 2;


_tk->load("shader");
scenes[1] = 0; //new lecture_effects();
scenes[2] = sc("vip/morph");
scenes[3] = new object_dolphin();
scenes[4] = new object_water();
scenes[5] = new object_spectrum();
scene::declare("effect/spectrum",scenes[5]);
//scenes[2] = new object_vsh();
//scenes[2] = new lecture_imm();
//scenes[3] = new lecture_eca();
//scenes[4] = new scene_odyssee();
scene* x;
x = new object_flag();
//x->rotation(0,1,0,0.5 * 3.14);
x->scale(2.3,0.9,0.5);
x->translation(0,-16.2,10); // no op
x->_lights = 1;

scenes[6] = x;


}

menu_effects::~menu_effects()
{
//delete scenes[];
}

/*
HRESULT 
menu_effects::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

	//restore(device);

    for (int i = 1; i < count; i++) _exclude[i] = 1;
	//_handler = _menu;
	//_menu->exclude(0);

    if (!_enabled || _selection == 0) {
		_handler = _menu;
		_exclude[count-1] = 0;
		_menu->state = 1;
		//_menu->exclude(0);
	} else if (_enabled && _selection > 0) {
		//scenes[_selection]->exclude(0);
		_handler = scenes[_selection];
		_exclude[_selection] = 0;
		_exclude[count-1] = 1;
		//_menu->exclude(1);
	}

	render_begin(device);


	hr = scene::render(device,texture); // calls restore, compose, render
   

	if (!_selection) display(_display);
	render_end(device);

 
    return hr;
}

*/
