#include <hush/source.h>
#include "menu-tutorial.h"

// sub scenes

//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
#include "lectures/lecture-eca.h"
#include "lectures/lecture-imm.h"
//#include "lectures/lecture-tutorial.h"
#include "lectures/lecture-effects.h"
//#include "lectures/scene-test.h"
#include "objects/background-scene.h"
#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"
#include "main/menu-objects.h"
#include "main/menu-models.h"
#include "main/menu-scenes.h"
#include "main/menu-effects.h"
#include "main/menu-aux.h"
#include "extra/object-dolphin.h"


#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 2;
static int enable = 0;

static int testmode = 0;
static msg_array msg;

menu_tutorial::menu_tutorial() 
{

_msg = &msg;

_selection = preset;
_enabled = enable;
_exclusive = 1;

clear(&msg);

//msg[1][1] = "promotion";
msg[1][1] = "...";
//msg[1][3] = "codecs and standards";

msg[1][2] = "objects";
msg[1][3] = "models";
msg[1][4] = "scenes";
msg[1][5] = "effects";
msg[1][7] = "media";

scenes[11] = new object_dolphin();
_exclude[11] = 1;

_states = 9;
state = 1;

_display = "tutorial";

//count =  states + 2;





//scenes[2] = new lecture_tutorial();
//scenes[1] = new lecture_tutorial();
//scenes[3] = new lecture_eca();
//scenes[2] = new scene_odyssee();
scenes[1] = 0; //new lecture_effects();
scenes[2] = new menu_objects();
scenes[3] = new menu_models();
scenes[4] = new menu_scenes();
scenes[5] = new menu_effects();

scenes[7] = new menu_aux();
//scenes[5] = new menu_effects();


}

menu_tutorial::~menu_tutorial()
{
//delete scenes[];
}


/*
HRESULT 
menu_tutorial::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

	//restore(device);

    for (int i = 1; i < count; i++) _exclude[i] = 1;
	_handler = _menu;
	_menu->exclude(0);

    if (!_enabled || _selection == 0) {
		_handler = _menu;
		_exclude[count-1] = 0;
		//_menu->state = state;
		//_menu->exclude(0);
	} else if (_enabled && _selection > 0) {
		//scenes[_selection]->exclude(0);
		_handler = scenes[_selection];
		_exclude[_selection] = 0;
		_exclude[count-1] = 1;
		//_menu->exclude(1);
	} else _enabled = 0;

	render_begin(device);


	hr = scene::render(device,texture); // calls restore, compose, render
   

	if (!_selection) display(_display);
	render_end(device);

 
    return hr;
}

*/
