

#include "scene-1.h"

// sub scenes

#include "objects/cylinder-scene.h"
#include "objects/plane-scene.h"
#include "objects/background-scene.h"
#include "objects/image-scene.h"
#include "objects/sub-scene.h"



//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


scene_1::scene_1() 
{


//scale(1.5f,1.5f,1.5f);
//translation(100,100,0);

	translation(0,1.5,-2.5);
	_end = 10;
	loop = 0;

count = 6;
_exclude[0] = 1;
_exclude[1] = 0;
_exclude[2] = 1;
_exclude[3] = 1; 
_exclude[4] = 0;
_exclude[5] = 1;


scenes[0] = new cylinder_scene();
//scenes[3] = new cylinder_scene(1);
//scenes[2] = new cylinder_scene(2);
scenes[1] = new plane_scene();
//scenes[2] = new background_scene(_T("media/soutine.jpg"));
scenes[2] = new background_scene();

scenes[3] = new sub_scene();
//scenes[3]->scale(1.2f,1.2f,1.2f);
//scenes[4] = new image_scene(_T("soutine.jpg"));
scenes[4] = new image_scene();
//scenes[4]->scale(1.35f,1.35f,1.35f);
//scenes[4]->translation(-3.0f,0.0f,3.0f);
//scenes[4]->rotation(0.0f,0.5f,0.5f,1); // this is naive rotation
//scenes[4]->mode(0); // 0 = absolute


//scenes[5] = new image_scene(_T("C:/AE/media/soutine.jpg"));
scenes[5] = new image_scene();
scenes[5]->scale(1.0f,1.0f,1.0f);
scenes[5]->translation(0.0f,0.0f,3.0f);
//scenes[5]->rotation(0.0f,0.5f,0.5f,1); // this is naive rotation

_shader = "scene";
opt("nofx","1");
iopt("overlay",1);

}

scene_1::~scene_1()
{
//delete scenes[];
}

HRESULT 
scene_1::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	// anything else ?

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
scene_1::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    return hr;
}


HRESULT 
scene_1::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

if (opt("tx")) _texture = tx(opt("tx"));
if (_texture) texture = _texture;
 
	float f = fraction();

    scale(0.2+f*1.2f,0.2+f*1.5f,0.2+f*1.0);
	translation(0,0.5,-1.2);


	render_begin(device);

    // begin the scene_1


	hr = scene::render(device,texture); // calls compose, restore,  render

    
	render_end(device);

 

    return hr;
}

