

#include "particles/text.h"
#include "util/d3dUtility.h"
// sub scenes




//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


scene* x_text::create(char* opts) { return new x_text(opts); }

x_text::x_text(char* txt) 
{

	lstrcpy( m_strFont, _T("Arial") );
    m_nFontSize  = 12;
    m_pFont       = NULL;
    m_pFont2      = NULL;
    m_pStatsFont  = NULL;
    m_pD3DXSprite = NULL;
    m_strTextBuffer = NULL;



if (txt) sprintf(_txt,"%s",txt);
else sprintf(_txt,"Odyssee");
scale(0.9f,0.9f,0.9f);
//translation(100,100,0);



count = 1;
_exclude[0] = 1;
_exclude[1] = 0;
_exclude[2] = 1;
_exclude[3] = 0; 
_exclude[1] = 0;
_exclude[5] = 0;

//scenes[0] = new background_scene();
end(8);
loop = 0;

scale(0.5,0.5,0.5);
translation(-0.8,1.5,-2.5);

}

x_text::~x_text()
{
//delete scenes[];
	
}

HRESULT 
x_text::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

		//
	// Get a handle to a device context.
	//
	int nHeight;

    HDC hDC = GetDC( NULL );
    int nLogPixelsY = GetDeviceCaps(hDC, LOGPIXELSY);
    ReleaseDC( NULL, hDC );

    nHeight = -m_nFontSize * nLogPixelsY / 72;
    hr = D3DXCreateFont( device,          // D3D device
                         nHeight,               // Height
                         0,                     // Width
                         FW_BOLD,               // Weight
                         0,                     // MipLevels, 0 = autogen mipmaps
                         FALSE,                 // Italic
                         DEFAULT_CHARSET,       // CharSet
                         OUT_DEFAULT_PRECIS,    // OutputPrecision
                         DEFAULT_QUALITY,       // Quality
                         DEFAULT_PITCH | FF_DONTCARE, // PitchAndFamily
                         m_strFont,              // pFaceName
                         &m_pFont);              // ppFont

    nHeight = -9 * nLogPixelsY / 72;
    if( FAILED( hr = D3DXCreateFont( device, nHeight, 0, FW_BOLD, 0, FALSE, DEFAULT_CHARSET, 
                         OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, 
                         TEXT("System"), &m_pFont2 ) ) )
        return hr;

    nHeight = -9 * nLogPixelsY / 72;
    if( FAILED( hr = D3DXCreateFont( device, nHeight, 0, FW_BOLD, 0, FALSE, DEFAULT_CHARSET, 
                         OUT_DEFAULT_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH | FF_DONTCARE, 
                         TEXT("Arial"), &m_pStatsFont ) ) )
        return hr;

    if( FAILED( hr = D3DXCreateSprite( device, &m_pD3DXSprite ) ) )
        return hr;

	
	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
x_text::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

    

    return hr;
}


HRESULT 
x_text::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;
if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
if(_texture) texture = _texture;
  
	float f = fraction();

	//scale(3-f*3,3-f*3,3-f*3);
	//translation(-10*f,-3*f,2*f);
    //rotation(0,0,1,3.14 * f);

	render_begin(device);

	RECT rc;
    D3DMATERIAL9 mtrl;
    D3DXMATRIXA16 matWorld;
    //debug("x_text",1);

    SetRect( &rc, 150, 200, 0, 0 );        
        m_pFont->DrawText( NULL, _T("Federico, thanks for your contribution, advice and support"), 
			-1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 0.0f, 0.0f, 1.0f ));

/*
		m_pD3DXSprite->Begin( D3DXSPRITE_ALPHABLEND | D3DXSPRITE_SORT_TEXTURE );
        SetRect( &rc, 10, m_d3dpp.BackBufferHeight - 15*6, 0, 0 );        
        m_pFont2->DrawText( m_pD3DXSprite, _T("These multiple calls to ID3DXFont::DrawText() using the same ID3DXSprite."), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
        SetRect( &rc, 10, m_d3dpp.BackBufferHeight - 15*5, 0, 0 );        
        m_pFont2->DrawText( m_pD3DXSprite, _T("ID3DXFont now caches letters on one or more textures."), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
        SetRect( &rc, 10, m_d3dpp.BackBufferHeight - 15*4, 0, 0 );        
        m_pFont2->DrawText( m_pD3DXSprite, _T("In order to sort by texture state changes on muliple"), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
        SetRect( &rc, 10, m_d3dpp.BackBufferHeight - 15*3, 0, 0 );        
        m_pFont2->DrawText( m_pD3DXSprite, _T("draw calls to DrawText() pass a ID3DXSprite and use"), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
        SetRect( &rc, 10, m_d3dpp.BackBufferHeight - 15*2, 0, 0 );        
        m_pFont2->DrawText( m_pD3DXSprite, _T("flags D3DXSPRITE_ALPHABLEND | D3DXSPRITE_SORT_TEXTURE"), -1, &rc, DT_NOCLIP, D3DXCOLOR( 1.0f, 1.0f, 1.0f, 1.0f ));
        m_pD3DXSprite->End();
*/

        rc.left = 10;
        rc.top = 60;
        rc.right = 1026 - 10;
        rc.bottom = 726 - 10;
        //m_pFont2->DrawTextW( NULL, m_strTextBuffer, -1, &rc, DT_LEFT | DT_WORDBREAK | DT_EXPANDTABS, D3DXCOLOR( 1.0f, 0.0f, 1.0f, 1.0f ));
		WCHAR ae_strTextBuffer[200];
		//strcpy((char*)ae_strTextBuffer,  _TEXT("??"));
		//TCHAR* ae_strTextBuffer;
		//wsprintf((TCHAR*)ae_strTextBuffer,"%s",_TEXT("??"));
		//= _TEXT("??");
		//m_pFont2->DrawTextW( NULL, ae_strTextBuffer, -1, &rc, DT_LEFT | DT_WORDBREAK | DT_EXPANDTABS, D3DXCOLOR( 1.0f, 0.0f, 1.0f, 1.0f ));



	hr = scene::render(device,texture); // calls compose, restore,  render
	//if (current() < 12) {
	//device->SetTexture( 0, texture);
	device->SetTexture( 0, _texture);
    //Text->DrawSubset(0);
	//}
    //char buf[256];
	//sprintf(buf,"fraction: %1.2f (%2.1f) %2.1f",fraction(), time(), current());
	message(300,400,D3DXCOLOR( 0.5f, 0.0f, 0.0f, 1.0f ),"visual design 2006"); 
	render_end(device);

 

    return hr;
}

