
#ifndef x_text_h
#define x_text_h

#include "scene/scene.h"

#include <d3dx9.h>

class x_text : public scene  
{
public:

    x_text(char* txt = 0);
	scene* create(char* opts = 0);
    virtual ~x_text();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );


protected:

ID3DXMesh* Text;
char _txt[256];

    LPD3DXFONT    m_pFont;
    LPD3DXFONT    m_pFont2;
    LPD3DXFONT    m_pStatsFont;
    LPD3DXMESH    m_pMesh3DText;
    WCHAR*        m_strTextBuffer;

    ID3DXSprite*  m_pD3DXSprite;

//    CFirstPersonCamera m_Camera;

    TCHAR         m_strFont[LF_FACESIZE];
    int           m_nFontSize;

//private:
//	int count;
//	scene* scenes[1];
};
#endif 
