
#ifndef background_h
#define background_h
#include <hush/export.h>

#include "scene/scene.h"

// const DWORD FVF = (D3DFVF_XYZRHW | D3DFVF_TEX1);

class HUSH_API background : public scene  
{
public:

    background(TCHAR* = 0); // capture or image(string)
    virtual ~background();
    virtual HRESULT init(IDirect3DDevice9* device);
	virtual HRESULT restore(IDirect3DDevice9* device);
    

    virtual HRESULT render(  IDirect3DDevice9* device,
                        IDirect3DTexture9* texture );


private:
	TCHAR* image;

    struct BACKGROUNDVERTEX
	{
		FLOAT x, y, z, rhw; // The transformed position for the vertex
		FLOAT tu, tv;
	};

    BACKGROUNDVERTEX                m_vertices[4];
    LPDIRECT3DVERTEXBUFFER9		    m_vertexBuffer;;
	DWORD							m_sizeofVertices;
	
	LPDIRECT3DTEXTURE9				g_pBackgroundTexture;
	

    DWORD  m_time;
	int initialized;

};
#endif 
