
#ifndef shader_h
#define shader_h

#include <hush/export.h>
#include "scene/scene.h"
#include <hush/dictionary.h>


#include "common90/d3d-util.h"

class HUSH_API shader : public scene  
{
public:

   
	shader(scene* x, char* opts = 0);
	//shader(char* opts = 0);

	
    virtual ~shader();
    virtual int _load();
	virtual int _restore();
    

    virtual _render();

	//LPD3DXEFFECT            m_pEffect; 

	dictionary<D3DXHANDLE> efx;

    D3DXHANDLE              m_hTime;                        // Handle to var in the effect 
    D3DXHANDLE              m_hWorld;                       // Handle to var in the effect 
    D3DXHANDLE              m_hMeshTexture;                 // Handle to var in the effect 
    D3DXHANDLE              m_hWorldViewProjection;         // Handle to var in the effect 
    D3DXHANDLE              m_hTechniqueRenderScene;        // Handle to technique in the effect 


};
#endif 
