#include <hush/source.h>
#include <scene/text.h>

#include "vip.h"



scene* text_vip::create(char* opts) { return new text_vip(opts); }


text_vip::text_vip(char* opts) 
{
  
	clear(&msg);

    opt("display","ViP 2004");
	opt("text(title)","   ViP 2004 ");
	opt("text(sub)","webcams           video             images");

	opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","virtual");
	opt("logo(3ds)","poetry");
	opt("logo(vip)","ViP");



	// ----------------------------------------------------------------------------------

    msg[0][0] = "this is";
	msg[0][2] = "a first";
	msg[0][4] = "demonstration";
	msg[0][6] = "of the ViP system";
	msg[0][8] = "to enhance your party";
	msg[0][10] = "with";
	






	msg[2][0] = "it supports";
	msg[2][1] = " multiple webcams";
	msg[2][2] = "mixed with";
	msg[2][3] = " video";
	msg[2][4] = "and";
	msg[2][5] = " images";
	msg[2][6] = "enhanced by";
	msg[2][7] = " 3D animations";
	msg[2][8] = "and";
	msg[2][9] = " text";
	msg[2][10] = "in an integrated fashion";

		
	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];

	msg[3][0] = "for your party ";

	msg[3][3] = " we create a";
	msg[3][4] = "ViP presentation";

	msg[3][7] = " with your content";
	msg[3][8] = "and special effects";

	msg[3][11] = " to entertain your audience";


	msg[4][1] = "       ViP 2004";


	msg[4][6] = "information and licenses";
	
	msg[4][8] = " info@virtualpoetry.tv";
	msg[4][9] = " www.virtualpoetry.tv";



}

text_vip::~text_vip()
{
//delete scenes[];
}

HRESULT 
text_vip::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
text_vip::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
text_vip::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


    _text->state = state;

	render_begin(device);

    
   

	hr = scene::render(device,texture); // calls compose, restore,  render

	
    
	render_end(device);

 

    return hr;
}

