#include <hush/source.h>
#include "x.h"
#include <scene/mesh.h>
//#include <atlbase.h>
#include <streams.h>

//#define _UNICODE
//#include <tchar.h>
//#include <comutil.h>

#include <hush/sim/sim.h>

#include "common/d3dfile.h"
#include "common/dxutil.h"


#define BUFFERSIZE 20
static int g_inc = 0;
static int g_outc = 0;
//static int g_ev = 0;

const DWORD vip_x::D3DVERTEX::FVF = D3DFVF_XYZ | D3DFVF_NORMAL| D3DFVF_TEX1;

// enum {NOLEFT,QUIT,END,COUNT,REALTIME};

enum {ARRIVAL,DEPARTURE};

static simulation* x_sim;


generator* g1 = 0,*g2 = 0;
resource* servicepoint;
queue* q;

class customer : public entity
{ 
  public :
    customer(int ph);
    virtual int operator()();
};

static customer* g_c;

class server : public entity
{
  public :
    server();
    virtual int operator()();
};


customer::customer(int ph) : entity(ph)
{

}


// actions of the customer.
int customer::operator()()
{
  customer *c;
  //queuingpriority(2);        // adjust queuing priority
 //schedulingpriority(2);    
  x_sim->passivate(this);
  x_sim -> schedule(this,4); //(g1 -> exponential(20.0)));
  g_inc++;
  return 0;
  switch (phase())
  {
    case ARRIVAL :
      // schedule next customer
      c = new customer(ARRIVAL);
      x_sim -> schedule(c,(g1 -> exponential(20.0)));
      g_inc++;
      //
      q -> append(this);
      return OK;
    case DEPARTURE :
      // release servicepoint and leave it
      servicepoint -> release();
      x_sim -> terminate(this);
	  //dvscene::_log("departure");
      g_outc++;
	  return OK;
  }
  return false;
}


server::server() : entity()
{
}

// the server takes customers, if possible and serves them.
int server::operator()()
{
	x_sim->passivate(this);
  x_sim -> schedule(this,2); //(g1 -> exponential(20.0)));
  g_outc++;
  return 0;
  while ( (!(q -> empty())) && (servicepoint -> available()) )
  {
    entity* c = (entity *)q -> removefront();

    // acquire servicepoint and schedule departure
    servicepoint -> acquire();
    c -> phase(DEPARTURE);
    x_sim -> schedule(c,(g2 -> exponential(21.2)));
	//dvscene::_log("server");
  }
  return OK;
}
    



static char* _help = "x";
//static msg_array msg;
static char* msg[12][12];
static char _hold[12][512];





int vip_x::operator()()
{
  //customer *c;
	check_cs();
    CAutoLock lock(_cs);
	static int toggle = 0;
	//if (!toggle) { toggle = 1; return OK; }
	//toggle = 0;
    state = (rand() % 3) + 1;
	//_sim->factor(1);
	if (0 && g_ev == 10) {
		static char buf[512];
		_tk->source(loc("/vip/bin/scene.pl"));
		
	  _help = _tk->strvalue("X:x(X)");
	  strcpy(buf,_help);
	  _help = (char*) buf;
	}
	  if (1) {
	  toggle++;
	  if (toggle == 2) toggle = 0;
  g_ev++;;
  //_sim->withdraw(this);
  _sim->passivate(this);
  if (g1) _sim->schedule(this,g1->exponential(5.0));
  else _sim->schedule(this,5);
  }
  // _sim ->wait(1.0);
 // _help = (char*) _hold[0];
//	strcpy(_hold[0],  _tk->strvalue("X:scene(X)"));
  return 1;
  
}

vip_x::vip_x(int size) 
{
	
	if (0) {
	char* _mesh; // = "circle.x";

	//_mesh = "circle.x";
	float _scale = 0.2;
	float _distance = 7;
	int _state = 2;
	float _factor = 1.0;

	scale(0.2,0.2,0.2);

	_mesh = "tiger.x";
	_scale = 0.8; _distance = 2.0; 
	scale(_scale * _factor,_scale * _factor,_scale * _factor);

	count = 8;


	scenes[1] = new mesh(_mesh);
	scenes[1]->state = 2;
	//scenes[1]->scale(0.2,0.2,0.2);

	scenes[2] = new mesh(_mesh);
	scenes[2]->scale(_scale,_scale,_scale);
	scenes[2]->translation(-_distance,0,0);
	scenes[2]->state = _state;
	scenes[3] = new mesh(_mesh);
	scenes[3]->scale(_scale,_scale,_scale);
	scenes[3]->translation(+_distance,0,0);
	scenes[3]->state = _state;
	scenes[4] = new mesh(_mesh);
	scenes[4]->scale(_scale,_scale,_scale);
	scenes[4]->translation(0,0,-_distance);
	scenes[4]->state = _state;
	scenes[5] = new mesh(_mesh);
	scenes[5]->scale(_scale,_scale,_scale);
	scenes[5]->translation(0,0,_distance);
	scenes[5]->state = _state;
	scenes[6] = new mesh(_mesh);
	scenes[6]->scale(_scale,_scale,_scale);
	scenes[6]->translation(0,-_distance,0);
	scenes[6]->state = _state;
	scenes[7] = new mesh(_mesh);
	scenes[7]->scale(_scale,_scale,_scale);
	scenes[7]->translation(0,_distance,0);
	scenes[7]->state = _state;
	}

_size = 20; //size;
wsprintf(_type,"vip_x");
_letterset = "Times New Roman";
_display = _type;

    m_pMeshSysMem     = NULL;
    m_pMeshEnhanced   = NULL;
    m_pMaterials      = NULL;
    m_ppTextures      = NULL;
    m_dwNumMaterials  = NULL;
    m_pbufMaterials   = NULL;
    m_pbufAdjacency   = NULL;
    m_dwNumSegs       = 2;
    m_bUseHWNPatches  = FALSE;
    m_bWireframe      = FALSE;
    m_bShowHelp       = FALSE;


//_letterset = "Monotype Corsiva";
//_letterset = "MS Mincho";
clear(&msg);

end(20);
loop = 1;

g_ev = 0;

if (1) {
_tk->source(loc("/vip/bin/scene.pl"));
_tk->evaluate("_:s(1)");
_tk->evaluate("_:s(2)");
//_help = _tk->strvalue("X:run(X)");
if (1) {
_tk->eval("X:run(X)");
char* p = 0;
int i = 0;
while (p = _tk->result()) {
  wsprintf(_hold[i],p);
  msg[0][i++] = (char*) _hold[i];
}
_help = _tk->strvalue("X:x(X)");
}
}




_msg = &msg;


 x_sim = _sim;
 
  servicepoint = new resource(1);
 // _sim->factor(1);
 // _sim->speed(1);

  _sim->passivate(this);
  _sim -> schedule(this,0.0); //1000.0/5.0); //(g1 -> exponential(100.00)));

  // initially a customer arrives and the server is conditional
 customer* c = new customer(ARRIVAL);
 g_c = c;
 
 // phase(ARRIVAL);
 _sim -> schedule(c,0.0);
 // _sim->realtime(10.0);

  server* sr = new server();
  //_sim -> hold(sr);
  _sim -> schedule(sr,0.0);
  
  
  //_sim->realtime(1.0);

 //queuingpriority(1);        // adjust queuing priority
 schedulingpriority(10);     // adjust scheduling priority

  
}



vip_x::~vip_x()
{
//delete scenes[];
}

HRESULT 
vip_x::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;






	 LPDIRECT3DVERTEXBUFFER9 pVB = NULL;
    void*      pVertices = NULL;
    LPD3DXMESH pTempMesh;
	TCHAR strPath[1024];

	dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];

    if (1) {
	char* _mesh; // = "circle.x";

	_mesh = "circle.x";
	float _scale = 0.2;
	float _distance = 7;
	int _state = 2;
	float _factor = 1.0;

	//scale(0.2,0.2,0.2);

	//_mesh = "tiger.x"; _scale = 0.8; _distance = 2.0;

	scale(_scale * _factor,_scale * _factor,_scale * _factor);

	count = 8;

    
	scenes[1] = new mesh(_mesh);
	scenes[1]->state = 2;
	
	//scenes[1]->scale(0.2,0.2,0.2);

	scenes[2] = new mesh(_mesh);
	scenes[2]->scale(_scale,_scale,_scale);
	scenes[2]->translation(-_distance,0,0);
	scenes[2]->state = _state;
	scenes[3] = new mesh(_mesh);
	scenes[3]->scale(_scale,_scale,_scale);
	scenes[3]->translation(+_distance,0,0);
	scenes[3]->state = _state;
	scenes[4] = new mesh(_mesh);
	scenes[4]->scale(_scale,_scale,_scale);
	scenes[4]->translation(0,0,-_distance);
	scenes[4]->state = _state;
	scenes[5] = new mesh(_mesh);
	scenes[5]->scale(_scale,_scale,_scale);
	scenes[5]->translation(0,0,_distance);
	scenes[5]->state = _state;
	scenes[6] = new mesh(_mesh);
	scenes[6]->scale(_scale,_scale,_scale);
	scenes[6]->translation(0,-_distance,0);
	scenes[6]->state = _state;
	scenes[7] = new mesh(_mesh);
	scenes[7]->scale(_scale,_scale,_scale);
	scenes[7]->translation(0,_distance,0);
	scenes[7]->state = _state;
	
	for (int i = 1; i < 8; i++) scenes[i]->rectangle(_tu,_tv);
	
	}




    D3DVERTEX*              pSrc;
    D3DVERTEX*              pDst;

	

	DXUtil_FindMediaFileCb( strPath, sizeof(strPath), _T(loc("\\vip\\models\\circle.x")) );

	hr = D3DXLoadMeshFromX( strPath, D3DXMESH_SYSTEMMEM, device, 
                            &m_pbufAdjacency, &m_pbufMaterials, NULL, &m_dwNumMaterials, 
                            &m_pMeshSysMem );

	if (1) {
	hr = m_pMeshSysMem->GetVertexBuffer( &pVB );
    if( FAILED(hr) )
        return hr;

    hr = pVB->Lock( 0, 0, &pVertices, 0 );
    if( FAILED(hr) )
    {
        SAFE_RELEASE( pVB );
        return hr;
    }

    hr = D3DXComputeBoundingSphere( (D3DXVECTOR3*)pVertices, m_pMeshSysMem->GetNumVertices(), 
                                    D3DXGetFVFVertexSize(m_pMeshSysMem->GetFVF()), &m_vObjectCenter, 
                                    &m_fObjectRadius );
    if( FAILED(hr) )
    {
        pVB->Unlock();
        SAFE_RELEASE( pVB );
        return hr;
    }
	}

    if( 0 == m_dwNumMaterials )
    {
        pVB->Unlock();
        SAFE_RELEASE( pVB );
        return E_INVALIDARG;
    }

    // Get the array of materials out of the returned buffer, allocate a
    // texture array, and load the textures
    m_pMaterials = (D3DXMATERIAL*)m_pbufMaterials->GetBufferPointer();
    m_ppTextures = new LPDIRECT3DTEXTURE9[m_dwNumMaterials];

    for( UINT i=0; i<m_dwNumMaterials; i++ )
    {
        TCHAR strTexturePath[512] = _T("");
        TCHAR *tszName;
#ifdef UNICODE
        TCHAR tszBuf[MAX_PATH];
        tszName = tszBuf;
        MultiByteToWideChar( CP_ACP, 0, m_pMaterials[i].pTextureFilename, -1, tszBuf, MAX_PATH );
        tszBuf[MAX_PATH - 1] = _T('\0');
#else
        tszName = m_pMaterials[i].pTextureFilename;
#endif
        DXUtil_FindMediaFileCb( strTexturePath, sizeof(strTexturePath), tszName );
        if( FAILED( D3DXCreateTextureFromFile( device, strTexturePath, 
                                               &m_ppTextures[i] ) ) )
            m_ppTextures[i] = NULL;
    }

    pVB->Unlock();
    SAFE_RELEASE( pVB );

    // Make sure there are normals, which are required for the tesselation
    // enhancement
    if( !(m_pMeshSysMem->GetFVF() & D3DFVF_NORMAL) )
    {
        hr = m_pMeshSysMem->CloneMeshFVF( m_pMeshSysMem->GetOptions(), 
			                              D3DVERTEX::FVF,
                                          // m_pMeshSysMem->GetFVF() | D3DFVF_NORMAL | D3DFVF_TEX1 , 
                                          device, &pTempMesh );
        if( FAILED(hr) )
            return hr;

        D3DXComputeNormals( pTempMesh, NULL );

        SAFE_RELEASE( m_pMeshSysMem );
        m_pMeshSysMem = pTempMesh;
    }

	//DWORD GetNumBytesPerVertex(VOID);
	if (1) {
	  hr = m_pMeshSysMem->GetVertexBuffer( &pVB);
    if( FAILED(hr) )
        return hr;

    hr = pVB->Lock( 0, 0, (void**) &pSrc, 0 );
    if( FAILED(hr) )
    {
        SAFE_RELEASE( pVB );
        return hr;
    }
	if (1) {
	int n = m_pMeshSysMem->GetNumVertices();
    //memcpy( pDst, pSrc, n * sizeof(D3DVERTEX) );
    srand(5);
    if (1) for( DWORD i=0; i<n; i++ )
    {
        //((D3DVERTEX*)pDst)[i].p.y += (rand()/(FLOAT)RAND_MAX);
        //((D3DVERTEX*)pDst)[i].p.y += (rand()/(FLOAT)RAND_MAX);
        //((D3DVERTEX*)pDst)[i].p.y += (rand()/(FLOAT)RAND_MAX);
        ((D3DVERTEX*)pSrc)[i].tu  *= _tu;
       ((D3DVERTEX*)pSrc)[i].tv  *= _tv; 
    }
    //pVB->Unlock();
    //pMeshSourceVB->Unlock();
    //pMeshSourceVB->Release();
	}   
        pVB->Unlock();
        SAFE_RELEASE( pVB );
      
	}

	
	
	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
vip_x::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
vip_x::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

    //state = 1;
    //dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];
    dolphin->state = 1;
	//((dxscene*) dvscene::lookup("menu/dots"))->_exclude[10] = 1;
   
	//scale(0.2,0.2,0.2);
	//rotation(0,1,0,3.14*0.8);

	//int b = get_buffer();

	render_begin(device);

	D3DXMATRIXA16 matWorld;
    
	D3DXMatrixIdentity( &matWorld );
    //D3DXMatrixRotationX( &matWorld, timeGetTime()/1000.0f );
	if (state >= 2) {
		D3DXMatrixRotationX( &matWorld, -_sim->realtime());
		device->MultiplyTransform( D3DTS_WORLD, &matWorld );
	}
	if (state >= 1) {
			D3DXMatrixRotationY( &matWorld, -_sim->realtime());
			device->MultiplyTransform( D3DTS_WORLD, &matWorld );
		}
	if (state > 2) {
		D3DXMatrixRotationZ( &matWorld, -_sim->realtime());
		device->MultiplyTransform( D3DTS_WORLD, &matWorld );
			}
	//if (option > 1) D3DXMatrixRotationZ( &matWorld, -timeGetTime()/1000.0f );
    //matWorld._43 = -1.50f;
	//matWorld._42 = 1.00f;
    //device->MultiplyTransform( D3DTS_WORLD, &matWorld );  // relative

	   device->SetTexture( 0, texture );
       //int i = 0;

   static int toggle = 0;
	  if (0)  for( UINT i = 0; i < m_dwNumMaterials; i++ )
        {
            device->SetMaterial( &m_pMaterials[i].MatD3D );
            if (0) device->SetTexture( 0, m_ppTextures[i] );

           // m_pMeshEnhanced->DrawSubset( i );
			m_pMeshSysMem->DrawSubset( i );
        }
	   // m_pMeshEnhanced->DrawSubset( i );
	  
    
    _cmi = 0; // state;//state+1;
    

	if(_idx >= _max) _idx = 0;
	

	hr = scene::render(device,texture); // calls compose, restore,  render


    
    //_selection = 0;

	if (1) for (int i=1; i <= 12; i++) { 
		if ((*_msg)[_cmi][i-1]) {
			if (i == _idx) {
				message(_x,_y + (i-1)*_inc,_alt,(*_msg)[_cmi][i-1]);
				if (_enabled) _selection = i-1;
			}
			else 
				message(_x,_y + (i-1)*_inc,_color,(*_msg)[_cmi][i-1]);
		}

	}
    //TCHAR
	if (1) {

		int nn = 0;
		char* p = _display;
		
		if (1) {
		char x[256];
	
		message(100,_y-100-nn*20,argb(180,133,197,235),fm("[%3.2f] %s:: %s [%d] (%d,%d) -- %3.2f [%3.2f,%3.2f]",_sim->realtime(),_help,
			p,g_ev, g_inc,g_outc,
			_sim->clock(),((entity*)this)->entity::time(),g_c->time()));  //dvscene::_log()));
		}

	display(_display);
	
	}
	
    
	render_end(device);

 

    return hr;
}

