#include <hush/source.h>

#include "try.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
#include "mesh.h"
#include "tiny.h"


#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>

#include <ch/extern/embedch.h>
#include "sampclass.h"

//#include "shader.h"

//#include "Character.h"

//static CCharacter* _tiny = 0;






static char* _help = "try";
static scene* dolphin;


int vip_try::ch(char* x) {
int status = 0;
	return status;

}


int vip_try::handle(char* type, char* ev) {
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","0")) {
		int s = 0;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","1")) {
		int s = 1;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","2")) {
		int s = 2;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_try::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_try::vip_try(char* opts) 
{
	
	count = 12;

	ch();

_size = 20; //size;
wsprintf(_type,"vip_try");
_display = _type;

_sim->passivate(this);
_sim -> schedule(this,0.0);


end(20);
loop = 1;

//_tiny = new CCharacter();



//scenes[1] = new satelite();
//scenes[0] = new shader(new background(),"fx=back");
//scenes[0]->opt("shaders","material");

scene* sc = new mesh("knot");
//sc->_shader = "red";
//scenes[1] = sc;
//scenes[1] = new shader(sc,"fx=red"); 
scenes[1] = new shader(sc,"fx=red"); 
//scenes[1]->rotation(0.1,-0.1,0,1.0);
scenes[1]->translation(-3,-2,0);
scenes[1]->scale(5,5,5);

scenes[2] = new mesh("yt");
scenes[2] = new shader(new mesh("raven"),"fx=blue");
//scenes[2] = new shader(new mesh("poser-ae"),"fx=blue");
scenes[2]->translation(2.5,-2,-2);
scenes[2]->rotation(0,-2.57,0.2,1);
scenes[2]->scale(0.9,0.9,0.9);


scenes[3] = new mesh("nana");
//scenes[3] = new vip_mesh();
scenes[3]->translation(0,-2,0);
scenes[3]->scale(0.15,0.15,0.15);
scenes[3]->rotation(0.0,1,0,0.5 * 3.14);

scenes[4] = new tiny();

_exclude[0] = 1;
_exclude[1] = 0;
_exclude[2] = 1;
_exclude[3] = 0;
_exclude[4] = 0;



//scenes[2]->scale(0.3,0.3,0.3);




//scale(0.8,0.8,0.8);



 

 
  
}




vip_try::~vip_try()
{
//delete scenes[];
}

int 
vip_try::_load()
{
    int hr = S_OK;

	dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];
	//_tiny->Initialize(_device);
	
	//scenes[0] -> load_effect("bg");
	//scenes[1] -> load_effect("material");
    
// HRESULT Initialize( IDirect3DDevice9 *pDevice );
 //   HRESULT RestoreDeviceObjects(IDirect3DDevice9* pDevice);
 //   HRESULT Compose(DWORD t);
 //   HRESULT Render(IDirect3DDevice9* pDevice);	

	
	//load_effect("bg");
	//scenes[0]->load_effect("material");


	hr = scene::init(_device); // loops through scenes

	//scenes[0]->effect("material",effect("material"));
	//scenes[1]->effect("bg");
    return hr;
}

int
vip_try::_restore()
{
    HRESULT hr = S_OK;

	//_tiny->Compose((DWORD) timeGetTime());
	//debug("tiny 1",1);
	//_tiny->RestoreDeviceObjects(_device);
	


    return hr;
}


int
vip_try::_render( ) 
{
HRESULT hr = S_OK;
   
   
    dolphin->state = 1;
	
	//_tiny->Compose((DWORD) 1000 * fraction());
	scenes[1]->rotation(sin(dxtime()),sin(dxtime()),cos(dxtime()),1);
   

	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
       //int i = 0;

   // _tiny->Render(_device);
	

	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		message(100,_y-200,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	display(_display);
    //dolphin->state = hold;
	render_end(_device);

 

    return hr;
}

