#include <hush/source.h>
#include <hush/api/dot.h>

#include <hush/iostream.h>
#include <stdio.h>

dot::dot(const char* kind) { 
	if (kind); //Wall
	}


::kit* dot::kit(const char* kind) { return new ::kit(kind); }




#ifndef CIAO
#define fac(button) \
::button* dot::button(const char* id) { \
      ::button* b = ::button::lookup(id); \
      if (!b && (id[0] == '.') && (strlen(id)>1)) { \
	b = ::button::lookup(id+1); \
	} \
      if (!b && (id[0] != '.')) { \
	char buf[1024]; \
	sprintf(buf,".%s",id); \
	b = ::button::lookup(buf); \
	} \
      if (!b) { \
	b = new ::button(id); \
	_register(b); \
	::button::declare(b->path(),b); \
	cerr << "Warning (dot): " << id << " created: " << b->path() << endl;\
	} \
      return b; \
      }

fac(button)
fac(checkbutton)
fac(radiobutton)

fac(menu)
fac(menubutton)
fac(menubar)

fac(message)
fac(entry)
fac(listbox)

fac(frame)
fac(toplevel)

fac(scrollbar)
fac(label)

fac(canvas)
fac(dvtext)

fac(filechooser)
fac(browser)

#endif
