#include <widgets/source.h>

#include <hush/widgets/check.h>


char* checkbutton::type() const { return "checkbutton"; }

#define ANCESTOR button
#define TYPE checkbutton
#define OPTS "*"
#include "hush/widgets/create.i"

void checkbutton::variable(const char* name) {
	if (_exists()) _this()->variable(name);
	else _error("variable");
	}

int checkbutton::value() {
	if (_exists()) return _this()->value();
	else return (int) _error("value");
	}


void checkbutton::toggle() {
	if (_exists()) _this()->toggle();
	else _error("toggle");
	}

void checkbutton::select() {
	if (_exists()) _this()->select();
	else  _error("select");
	}

void checkbutton::deselect() {
	if (_exists()) _this()->deselect();
	else  _error("deselect");
	}

