#include <widgets/source.h>

#include <hush/widgets/glwin.h>
#include <hush/sys/bind.h>

char* glwin::type() const { return "glwin"; }

#define TYPE glwin
#include "hush/widgets/create.i"

void glwin::draw() { 
	if (_exists()) _this()->draw(); 
	else _error("draw");
	}

void glwin::redraw() { 
	if (_exists()) _this()->redraw(); 
	else _error("redraw");
	}

void glwin::link() { 
	if (_exists()) _this()->link(); 
	else _error("link");
	}

void glwin::swap() { 
	if (_exists()) _this()->swap(); 
	else _error("swap");
	}

int glwin::file(const char* name) { 
	if (_exists()) _this()->file(name); 
	else return (int) _error("file");
	}


void glwin::loop(const char* name) { 
	if (_exists()) _this()->loop(name); 
	else  _error("loop");
	}

void glwin::restore() { 
	if (_exists()) _this()->restore(); 
	else _error("restore");
	}

void glwin::pan(float dx, float dy, float dz) { 
	if (_exists()) _this()->pan(dx,dy,dz); 
	else _error("pan");
	}


void glwin::zoom(int i) { 
	if (_exists()) _this()->zoom(i); 
	else _error("zoom");
	}



void glwin::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac, args);
	}
