#include <widgets/source.h>


#include <hush/widgets/menu.h>
#include <hush/sys/bind.h>

#ifndef menu
#define menu dvmenu
#endif


// AE static char* empty = "";

char* menu::type() const { return "menu"; }

#define TYPE menu

#include "hush/widgets/create.i"


menu* menu::oldadd(const char* s, const char* options) {
	if (_exists()) return _this()->oldadd(s,options);
	else return (menu*) _error("oldadd");
	}

menu* menu::entry(const char* s, binding* ac, const char* args,const char* options) {
	if (_exists()) return _this()->entry(s,ac,args,options);
	else return (menu*) _error("entry");
	}

menu* menu::entry(const char* s, const char* args, const char* options) {
	return add(s,args,options);
	}

menu* menu::add(const char* s, binding* ac, const char* args, const char* options) {
	if (_exists()) return _this()->add(s,ac,args,options);
	else return (menu*) _error("add");
	}

menu* menu::add(const char* s, const char* args, const char* options) {
	if (_exists()) return _this()->add(s,args,options);
	else return (menu*) _error("add");
	}

menu* menu::checkbutton(const char* s, const char* args, const char* options) {
	if (_exists()) return _this()->checkbutton(s,args,options);
	else return (menu*) _error("checkbutton");
	}

menu* menu::radiobutton(const char* s, const char* var, const char* args, const char* options) {
	if (_exists()) return _this()->radiobutton(s,var,args,options);
	else return (menu*) _error("radiobutton");
	}


menu* menu::cascade(const char* s, const char* m, const char* options) {
	if (_exists()) return _this()->cascade(s,m,options);
	else return (menu*) _error("cascade");
	}

menu* menu::cascade(const char* s, menu* m, const char* options) {
	if (_exists()) return _this()->cascade(s,m,options);
	else return (menu*) _error("cascade");
	}

menu* menu::separator(const char* options) {
	if (_exists()) return _this()->separator(options);
	else return (menu*) _error("separator");
	}


char* menu::entryconfigure(int i, const char* options) {
	if (_exists()) return _this()->entryconfigure(i,options);
	else return (char*) _error("entryconfigure");
	}

int menu::index(const char *s) const {
	if (_exists()) return _this()->index(s);
	else return (int) _error("index");
	}

int menu::active() const { return index("active"); }

void menu::del(int i) {
	if (_exists()) _this()->del(i);
	else _error("del");
	}

void menu::del(const char* s) {
	if (_exists()) _this()->del(s);
	else _error("del");
	}

void menu::invoke(int i) {
	if (_exists()) _this()->invoke(i);
	else _error("invoke");
	}

void menu::invoke(const char *s ) {
	if (_exists()) _this()->invoke(s);
	else _error("invoke");
	}

void menu::post(int x, int y) {
	if (_exists()) _this()->post(x,y);
	else _error("post");
	}

void menu::unpost() {
	if (_exists()) _this()->unpost();
	else _error("unpost");
	}

void menu::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac,args);
	else _error("install");
	}
