#include <widgets/source.h>

#include <hush/widgets/menu.h>

char* menubar::type() const { return "menubar"; }

#define TYPE menubar
#include "hush/widgets/create.i"



widget* menubar::append(const char* w, const char* options) {
	if (_exists()) return _this()->append(w,options);
	else return (widget*) _error("append");
	}

widget* menubar::append(widget* w, const char* options) {
	if (_exists()) return _this()->append(w,options);
	else return (widget*) _error("append");
	}

void menubar::init(const char* options) {
	if (_exists()) _this()->init(options);
	else _error("init");
	}
