#include <hush/java.h>
#include <hush/io.h>

#include <widgets/frame.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_frame.h>

#define method(X) Java_hush_dv_widgets_frame_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<frame>* vmp = new java_vm<frame>(env,obj,"Frame");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  frame* result = 0;
  cerr << "creating frame " <<  endl;
  if (r)
  	result =  new frame((widget*)r,path,opts);
  else {
	result = new frame(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}
