#include <hush/java.h>
#include <hush/io.h>

#include <widgets/message.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_message.h>

#define method(X) Java_hush_dv_widgets_message_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<message>* vmp = new java_vm<message>(env,obj,"Message");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  message* result = 0;
  cerr << "creating message " <<  endl;
  if (r)
  	result =  new message((widget*)r,path,opts);
  else {
	result = new message(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}


JNIEXPORT void JNICALL method(text)(JNIEnv *env, jobject obj, 
	   jstring txt)
{
  java_vm<message> vm(env,obj);
  char* s = vm.get(txt);
  vm->text(s);
  vm.release(txt);;
}
