#include <hush/java.h>
#include <hush/io.h>

#include <widgets/toplevel.h>
#include <hush/session.h>

#undef string

#include <native/hush_dv_widgets_toplevel.h>

#define method(X) Java_hush_dv_widgets_toplevel_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj, 
	   jint root, jstring name, jstring options)
{
  java_vm<toplevel>* vmp = new java_vm<toplevel>(env,obj,"Toplevel");
  char* path = vmp->get(name);
  char* opts = vmp->get(options);
  int r = (int) root;
  toplevel* result = 0;
  cerr << "creating toplevel " <<  endl;
  if (r)
  	result =  new toplevel((widget*)r,path,opts);
  else {
	result = new toplevel(path,opts);
        session::_default->_register(result);
  }
  result->_register(vmp);
  result->_vmp = vmp;
  vmp->release(name,path);
  vmp->release(options,opts);
  return (jint) result;
}
