#include <hush/source.h>


#include <hush/widgets/tk/entry.h>
#include <hush/hush.h>

#define TYPE entry
#define CLASS tk_entry
#include <hush/widgets/tk/create.i>

#include <stdio.h>
#include <stdlib.h>	/// for atoi


void CLASS::insert(const char* s) {
  sprintf(buf,"%s insert 0 \"%s\"",thepath(),s);
  tk->eval( buf );
}

void CLASS::insert(const char* s, const char* options) {
  sprintf(buf,"%s insert \"%s\" \"%s\"", thepath(), options, s);
  tk->eval( buf );
}
 
void CLASS::insert(const char* s, int i) {
  sprintf(buf,"%s insert %d \"%s\"", thepath(), i, s);
  tk->eval( buf );
}

void CLASS::del() {
  sprintf(buf,"%s delete 0 end",thepath());
  tk->eval( buf );
}

void CLASS::del(const char* options) {
  sprintf(buf,"%s delete \"%s\"",thepath(), options);
  tk->eval( buf );
}

void CLASS::del(int from, int to) {
  if (to == -1) to = from;
  sprintf(buf,"%s delete %d %d",thepath(), from, to);
  tk->eval( buf );
}

char* CLASS::get() const {
  sprintf(buf,"%s get",thepath());
  return tk->evaluate( buf );
}

int CLASS::index(const char* i) const {
  sprintf(buf, "%s index %s", thepath(), i);
  char *r=0;
  if ((r = tk->evaluate(buf))) return atoi(r);
  else return -1;
}

void CLASS::install(binding* ac, const char* args) {
  sprintf(buf," bind %s <Double-Button-1> {%s %s [%s get]}",thepath(),ac->name(), args, thepath());
  tk->eval( buf );
  bind("<Return>",ac,args);
}
