#include <hush/source.h>
#include <hush/widgets/tk/radio.h>


static char pname[1024]; // AE -- this will give problems !
#include <string.h>

#define TYPE radiobutton
#define OPTS 0
#define CLASS tk_radiobutton
#define CONSTRUCTOR strcpy(pname,p);
#include <hush/widgets/tk/create.i>

#include <stdio.h>




void CLASS::variable(const char* name) {
	_name = new char[strlen(name)+1];
	strcpy(_name,name);
	sprintf(buf,"%s configure -variable %s",path(), name);
	tk->eval( buf );
	}

char* CLASS::value() const {
	char* s = "";
	if (_name) {
		sprintf(buf,"set %s",(char*) _name);
		s = tk->evaluate( buf );
		}
	return s;
	}


void CLASS::toggle() {
	sprintf(buf,"%s toggle",path());
	tk->eval( buf );
	}

void CLASS::select() {
	sprintf(buf,"%s select",path());
	tk->eval( buf );
	}

void CLASS::deselect() {
	sprintf(buf,"%s deselect",path());
	tk->eval( buf );
	}

void CLASS::init(const char* options) {
	char* p = path(); if (*p == '.') p++; // p = pname AE ??
	sprintf(buf,"%s %s -value %s %s",type(),
	  path(), p, options);
	tk->eval( buf );
	_name = new char[ strlen(path()+1)];
	strcpy(_name,path()); 
	}
