##@ package.mk -- no longer obsolete

IMPORT = ..

import:                                   ## to get install.mk C
	if [ ! -d cfg ]; then mkdir cfg; fi
	cp $(IMPORT)/cfg/*.mk  cfg;
	cp -r $(IMPORT)/cfg/platform  cfg;
	cp $(IMPORT)/cfg/install.mk cfg/install.cfg;

## The imported definitions can be overridden by you own project.cfg

init:                                     ## to effect import
	@cp cfg/install.mk cfg/install.bak
	cp cfg/install.cfg cfg/install.mk
	if [ -f cfg/$(CFG).cfg ]; then \
		cat cfg/$(CFG).cfg >> cfg/install.mk; \
		fi;

##@ category.mk  -- toplevel directories

document = $(category-document)/$(category)
destination = $(category-destination)/$(category)

DELTA = hush-$(category)$(version)

kind = category
type = cc

config = category
install = category

##</>
