##@ template.mk -- to generate resource.mk

LDPATH = -L$(HUSH)/lib -R$(HUSH)/lib
LDHUSH = $(LDPATH) -lhush -lwidgets -ldv

## LDLIB and LDSYS are user-definable

CFLAGS = -I$(LOCAL)/include  -I$(HUSH)/include $(SUPPORTFLAGS) $(SYSTEMFLAGS)
LDFLAGS = $(LDPATH) $(LDLIB) $(LDHUSH) $(LDTK) $(LDPLATFORM) $(LDSYS)

##@ rules

.SUFFIXES: .c .cc .cpp .o .out 

.c.o:; $(CC) -c $*.c $(CFLAGS) 
.c.out: $(OBJECTS)
	$(CC) -o $*.out $*.c $(OBJECTS) $(CFLAGS) $(LDFLAGS) 

.cc.o:; $(CC) -c $*.cc $(CFLAGS) 
.cpp.out: $(OBJECTS)
	$(CC) -o $*.out $*.cc $(OBJECTS) $(CFLAGS) $(LDFLAGS) 

.cpp.o:; $(CC) -c $*.cpp $(CFLAGS) 
.cpp.out: $(OBJECTS)
	$(CC) -o $*.out $*.cpp $(OBJECTS) $(CFLAGS) $(LDFLAGS) 

##</>
