%% choice

start(choice(_),nra:a12345kxshvbuw:n).

eq(choice(_),c:s = n:sdm3ssh:n).
eq(choice(_),c:x = n:svm4ssh:n).
eq(choice(_),c:z = n:csx:e4:n).

eq(choice(_),c:0 = n:z0:bc:c).
eq(choice(_),c:1 = n:z1:x2:c).
eq(choice(_),c:2 = n:z2:xsr:c).
eq(choice(_),c:3 = n:z3:xst:c).
eq(choice(_),c:4 = n:z4:xm:c).
eq(choice(_),c:5 = n:z5:x135:c).
eq(choice(_),c:6 = n:z6:x21:c).
eq(choice(_),c:7 = n:z7:xvt:c).
eq(choice(_),c:8 = n:z8:xr:c).
eq(choice(_),c:9 = n:z9:x1:c).

eq(choice(_), choice = 'n:ld:ml2:2l:n').
eq(choice(_), command = 'n:sm3hs:n').
eq(choice(X), effects = 'n:sh:e3:za:n') :- X == 0.
eq(choice(X), effects = 'n:sh:e4:za:n') :- X > 0.
eq(choice(_), objects = ':xo:ao:').
eq(choice(_), meta = ntd).
eq(choice(_), cmd:meta = text). %% the display name

eq(choice(_), t:d = text/choice). 
eq(choice(_), l:d = lecture/choice/dj). 
eq(choice(_), s:d = slides/choice/dj). 
eq(choice(_), t:v = text/choice). 
eq(choice(_), l:v = lecture/choice/web). 
eq(choice(_), s:v = slides/choice/web). 

program(choice(0),3).
run(choice(0),X) :- member(X,[1]).
video(choice(0),1).
video(choice(0),X) :- X from [ sanguo(1), sanguo(0)].
video(choice(0),X) :- X from [ anim(balls), sonic(vegter) ].

program(choice(1),5).
run(choice(1),X) :- member(X,[1]).
video(choice(1),1).
video(choice(1),X) :- X from [ sanguo(1), sanguo(0) ].
video(choice(1),X) :- X from [ anim(balls), sonic(vegter) ].

program(choice(x),9).
run(choice(x),X) :- member(X,[1]).
video(choice(x),1).
video(choice(x),X) :- X from [ sanguo(1), anim(balls), sanguo(0) ].
video(choice(x),X):- member(N,[3,4]), clip(animatrix(N),X).
video(choice(x),X) :- X from [ anim(feet) ].
video(choice(x),X) :- clip(sonic(vegter),X).
video(choice(x),X) :- clip(oxygen,X).
