%% design

start(design(_),nra:mgce:a12345kxshvbuw:ms:p2:n).
%%start(design(_),nra:mgce:a12345kxshvbuw:n).

opt(design(_), speed:1 = 4).
opt(design(_), speed:2 = 7).

opt(design(_), text:head = 'multimedia @ VU / (AE)').
opt(design(_), text:scroll:1 = 'visual design in a rich media context       --   multimedia @ VU  --  amsterdam  --').
opt(design(_), text:scroll:2 = 'creativity  --   convergence  --   productivity  --  literacy  --   quality  --  immersion  -- ').

eq(design(_),l:c = lecture/create).
eq(design(_),l:f = lecture/create).

eq(design(_), choice = 'n:ld:2l:ml2:mbcwhf:b0:n').
eq(design(_), command = 'n:sm9hss:n').
eq(design(_), effects = ':ss:exz:').
eq(design(_), objects = ':xo:ao:').
eq(design(x), objects = ':p0:9p:tp:').
eq(design(_), meta = ntd).
eq(design(_), cmd:meta = text). %% the display name

eq(design(c), choice = 'n:lc:2l:ml2:mbcwhf:b0:n').

program(design(1),12).
run(design(1),X) :- member(X,[1]).
video(design(1),1).
video(design(1),X):- member(N,[1,2]), clip(tv(N),X).
%%video(design(1),2).
video(design(1),X):- clip(oxygen,X).
video(design(1),X):-
 member(N,[1,2,3,4,5,7,9,10,11,12,13,14,15,16,17]),
 clip(abramovic(N),X).


program(design(2),4).
run(design(2),X) :- member(X,[1,2,3,4]).
video(design(2),1).
video(design(2),X):- clip(oxygen,X).
video(design(2),X):- clip(oxygen,X).
video(design(2),X):- clip(oxygen,X).
%%video(design(2),'../media/video/nederlands-design.wmv').
%%video(design(2),'../media/video/visual-design.wmv').
video(design(2),X):-
        member(N,[1,2,3,4,5,6,7,8,9,0]),
	clip(animatrix(N),X).

lst(design(x),x/text = particle/text).
eq(design(x),x:t = particle/text).
eq(design(x),t:f = text/fed).
eq(design(x),t:p = particle/text).
eq(design(x),x:p = particle/try).
eq(design(x),s:d = slides/design).

program(design(x),9).
video(design(x),X) :- camera(video:clip = X).
video(design(x),X) :- X from [ tube(strings) ].
%%video(design(x),X) :- X from [ flash ].
video(design(x),X) :- X from [ sl(climb) ].
%%video(design(x),X) :- X from [ game(over) ].
%%video(design(x),X) :- X from [ tube(9/11) ].
video(design(x),X) :- X from [ tube(shark) ].
video(design(x),X) :- X from [ netzhammer ].
video(design(x),X) :- X from [ sonic(nano) ].
video(design(x),X) :- X from [ art(beautiful) ].
video(design(x),X) :- X from [ tube(fall) ].
video(design(x),X) :- X from [ oxygen ].

lst(design(c),x/text = particle/text).
eq(design(c),x:t = particle/text).
eq(design(c),t:f = text/fed).
eq(design(c),t:p = particle/text).
eq(design(c),x:p = particle/try).
eq(design(c),s:d = slides/design).

program(design(c),9).
video(design(c),X) :- camera(video:clip = X).
video(design(c),X) :- X from [ flash ].
video(design(c),X) :- X from [ game(over) ].
video(design(c),X) :- X from [ tube(9/11) ].
video(design(c),X) :- X from [ netzhammer ].
video(design(c),X) :- X from [ sonic(nano) ].
video(design(c),X) :- X from [ art(beautiful) ].
video(design(c),X) :- X from [ shout(strangest) ].
video(design(c),X) :- X from [ tube(content) ].
%%video(design(c),X) :- X from [ oxygen ].

lst(design(f),x/text = particle/text).
eq(design(f),l:d = lecture/final).
eq(design(f),s:f = slides/final).
eq(design(f), choice = 'n:ld:2l:ml2:mbcwhf:b0:n').
eq(design(f),x:t = particle/text).
eq(design(f),t:f = text/fed).
eq(design(f),t:p = particle/text).
eq(design(f),x:p = particle/try).
eq(design(f),s:d = slides/final).

program(design(f),9).
video(design(f),X) :- camera(video:clip = X).
%%video(design(f),X) :- X from [ sanguo(1) ].
%%video(design(f),X) :- X from [ flash ].
video(design(f),X) :- X from [ tube(strings) ].
video(design(f),X) :- X from [ game(over) ].
video(design(f),X) :- X from [ tube(9/11) ].
%%video(design(f),X) :- X from [ sanguo(1) ].
video(design(f),X) :- X from [ netzhammer ].
video(design(f),X) :- X from [ sonic(nano) ].
%%video(design(f),X) :- X from [ tube(strings) ].
%%video(design(f),X) :- X from [ flash ].
video(design(f),X) :- X from [ shout(strangest) ].
video(design(f),X) :- X from [ art(beautiful) ].
video(design(f),X) :- X from [ oxygen ].
