%% game

start(game(_),nra:mgce:ms:a12345kxshvbuw:p2:n).
%%start(game(_),nra:mgce:a12345kxshvbuw:bc:p2:n).
%%start(game(_),nra:mgce:a12345kxshvbuw:n).

opt(game(_), text:head = 'multimedia @ VU / (AE)').
opt(game(_), text:scroll:1 = 'ximpel interactive multimedia --  clip(s)  --  vrije universiteit -- amsterdam --  clima futura -- http://www.youtube.com/vumedia ').
opt(game(_), text:scroll:2 = 'digital  convergence -- challenge -- curiosity -- control -- literacy -- context -- immersion  ').


eq(game(_), choice = 'n:lg:8l:ml8:mbcwhf:b0:n').
eq(game(sl), choice = 'n:ls:4l:ml4:mbcwhf:b0:n').
eq(game(cf), choice = 'n:lf:2l:ml2:mbcwhf:b0:n').
eq(game(_), command = 'n:sm9hss:n').
eq(game(_), effects = ':ss:exz:').
eq(game(_), objects = ':xo:ao:').
eq(game(x), objects = ':p0:9p:tp:').
eq(game(_), meta = ntg).
eq(game(_), cmd:meta = text). %% the display name


lst(game(_),x/text = particle/text).
eq(game(_),x:t = particle/text).
eq(game(_),t:f = text/fed).
eq(game(_),t:p = particle/text).
eq(game(_),x:p = particle/try).
eq(game(_),t:g = text/game).
eq(game(_),s:g = slides/game).
eq(game(_),l:g = lecture/game).
eq(game(_),l:f = lecture/game).
eq(game(_),l:s = lecture/sl).
eq(game(_),s:l = slides/sl).

program(game(x),9).
video(game(x),X) :- camera(video:clip = X).
video(game(x),X) :- X from [ balls, game(over) ].
video(game(x),X):- member(N,[1]), clip(animatrix(N),X).
video(game(x),X) :- X from [ sl(climb) ].
video(game(x),X) :- X from [ sl(vu) ].
video(game(x),X) :- clip(vu(1),X).
video(game(x),X) :- clip(flash,X).
video(game(x),X) :- clip(trailer,X).

program(game(sl),9).
video(game(sl),X) :- camera(video:clip = X).
video(game(sl),X) :- X from [ balls, game(over) ].
video(game(sl),X) :- X from [ sl(promo) ].
video(game(sl),X) :- X from [ sl(climb) ].
video(game(sl),X) :- X from [ sl(vu) ].
video(game(sl),X) :- clip(tube(america),X).
video(game(sl),X) :- clip(flash,X).
video(game(sl),X) :- clip(tube(sl),X).

start(game(cf),nra:mgce:a12345kxshvbuw:bc:ms:p2:n).
%%start(game(cf),'nra:312345krxsch:2ch:srm2:bc:ts:ms:n').
program(game(cf),9).
video(game(cf),X) :- camera(video:clip = X).
video(game(cf),X) :- X from [ balls, game(over) ].
video(game(cf),X) :- X from [ cf(jaarprijs) ].
video(game(cf),X) :- X from [ cf(dijk) ].
video(game(cf),X) :- X from [ sl(vu) ].
video(game(cf),X) :- clip(cf(vu),X).
video(game(cf),X) :- clip(cf(short),X).
video(game(cf),X) :- clip(cf(journaal),X).

lst(game(m),x/text = particle/text).
eq(game(m),l:c = lecture/game).
eq(game(m),s:f = slides/final).
eq(game(m), choice = 'n:lc:2l:ml2:mbcwhf:b0:n').
eq(game(m),x:t = particle/text).
eq(game(m),t:f = text/fed).
eq(game(m),t:p = particle/text).
eq(game(m),x:p = particle/try).
eq(game(m),s:d = slides/final).

program(game(m),9).
video(game(m),X) :- camera(video:clip = X).
%%video(game(m),X) :- X from [ 1 ].
video(game(m),X) :- X from [ tube(strings) ].
%%video(game(m),X) :- X from [ flash ].
video(game(m),X) :- X from [ sl(climb) ].
%%video(game(m),X) :- X from [ game(over) ].
%%video(game(m),X) :- X from [ tube(9/11) ].
video(game(m),X) :- X from [ tube(shark) ].
%%video(game(m),X) :- X from [ netzhammer ].
video(game(m),X) :- X from [ tube(doll-face) ].
video(game(m),X) :- X from [ sonic(nano) ].
video(game(m),X) :- X from [ art(beautiful) ].
video(game(m),X) :- X from [ tube(fall) ].
video(game(m),X) :- X from [ tube(citroen) ].
