%% media 0 - 4

video(media(_),X) :- camera(video:clip = X).

opt(media(_), speed:1 = 4).
opt(media(_), speed:2 = 7).

opt(media(_), text:head = 'multimedia @ VU / (AE)').
opt(media(ct), text:head = 'creative technology / AE').
opt(media(create), text:head = 'creative technology / AE').
opt(media(_), text:scroll:1 = 'ximpel interactive multimedia --  clip(s)  --  serious game(s)  --  vrije universiteit -- amsterdam --  clima futura -- http://www.youtube.com/vumedia ').
opt(media(ct), text:scroll:1 = 'ximpel interactive multimedia --  clip(s)  --  serious game(s) -- new media --  clima futura -- http://www.youtube.com/vumedia ').
opt(media(o), text:scroll:1 = 'interactive multimedia --  clip(s)  --  ximpel  --  interactive video  --  clima futura ').
opt(media(create), text:scroll:1 = 'creative technology -- universiteit twente -- new media  -- smart technology -- netherlands').
opt(media(game), text:scroll:1 = 'interactive multimedia  --  ximpel --  1/2 life @ VU  --  game development  --  clima futura ').



opt(media(_), text:scroll:2 = 'digital  convergence  --   standards   --  literacy  --   retrieval   --  immersion  ').

opt(media(cf), text:scroll:2 = ' climate -- challenge(s) -- curiosity -- control -- literacy -- context(s) -- immersion  ').
opt(media(ct), text:scroll:2 = ' creative technology -- challenge(s) -- curiosity -- control -- literacy -- context(s) -- immersion  ').
opt(media(create), text:scroll:2 = ' creative technology -- challenge(s) -- curiosity -- control -- literacy -- context(s) -- immersion  ').
opt(media(game), text:scroll:2 = ' creative technology -- challenge(s) -- curiosity -- control -- literacy -- context(s) -- immersion  ').

program(media(x),2).
start(media(x),nra:r23:dm:e2z:a12345kxshvbuw:bc:xt:n).
run(media(x),X) :- member(X,[1,2]).
%%video(media(0),1).
video(media(x),X) :- X from [ clip-oxygen, clip-sonic, clip-stem ].

%%start(media(_),nra:mgce:a12345kxshvbuw:bc:p2:n).
start(media(_),nra:ms:mgce:a12345kxshvbuw:n).
%%start(media(_),nra:a12345kxshvbuw:n).
eq(media(_), choice = 'n:lr:ml3:3l:n').

lst(media(x),trio=anim/trio).
lst(media(_),text/roundup=text/roundup).  
%%lst(media(_),text/xhelp=xhelp).

eq(media(_),t:h = xtext/help).
eq(media(_),t:v = xtext/vip).
eq(media(_),t:r = text/roundup).
eq(media(_),t:s = text/media/roundup).
eq(media(_),t:v = text/sl).
eq(media(_),s:i = slides/imm).
eq(media(_),l:m = lecture/media).
eq(media(c),l:m = lecture/create).
eq(media(_),l:p = lecture/project).
eq(media(_),l:r = lecture/roundup).
eq(media(_),l:v = lecture/master).
eq(media(_),s:r = slides/roundup).
eq(media(_),s:g = slides/game).
eq(media(_),l:g = lecture/game).
eq(media(cf),l:g = lecture/cf).
eq(media(ct),l:g = lecture/create).

ds(media(x),debug:start=0).
ds(media(x),debug:eq=0).
ds(media(x),debug:sound=0).
ds(media(x),parser:debug=0).

eq(media(_), l:0 = lecture/imm).

eq(media(r), c:1 = n:f0:n).
eq(media(r), c:2 = n:f0:n).
eq(media(r), c:3 = n:f0:n).
eq(media(r), c:4 = n:f0:n).
eq(media(r), c:5 = n:f0:n).
eq(media(r), c:6 = n:f0:n).
eq(media(r), c:7 = n:f0:n).
eq(media(r), c:8 = n:f0:n).
eq(media(r), c:9 = n:f0:n).

eq(media(0), c:1 = n:z1:ti:n).
eq(media(1), c:1 = n:z1:t1:n).
eq(media(2), c:1 = n:z1:t2:n).
eq(media(3), c:1 = n:z1:t3:n).
eq(media(4), c:1 = n:z1:tr:n).

eq(media(0), choice = 'n:lm:ml2:2l:n').
eq(media(1), choice = 'ns1m9:n').
eq(media(2), choice = 'ns2m9:n').
eq(media(3), choice = 'ns3m9:n').
eq(media(4), choice = 'nsam9:n').
eq(media(_), command = 'n:nssh:n').
eq(media(_), effects = 'n:ss:exz:').
eq(media(_), objects = ':xo:ao:').
eq(media(_), meta = c:1).
eq(media(_), cmd:meta = text). %% the display name

program(media(0),9).
video(media(0),X) :- clip(coldplay,X).
video(media(0),X) :- clip(edgecodes,X).
video(media(0),X):- member(N,[art]), clip(anim(N),X).
video(media(0),X):-
  member(N,[nano,process(5),stripes,vegter]),
  clip(sonic(N),X).
video(media(0),X) :- clip(lips,X).
video(media(0),X) :- clip(stem,X).


program(media(1),9). %%20
video(media(1),X):- member(N,[time,objects]), clip(nomaps(N),X).
video(media(1),X):- member(N,[1,4]), clip(vasulka(N),X).
video(media(1),X):- member(N,[1,8]), clip(mul(N),X).
video(media(1),X) :- clip(sonic(vegter),X).
video(media(1),X) :- clip(oxygen,X).

program(media(2),9).
video(media(2),X) :- member(N,[1,2]), clip(animatrix(N),X).
video(media(2),X) :- clip(starwars,X).
video(media(2),X) :- clip(nodvd,X).
video(media(2),X):- member(N,[primetime,blendo]), clip(N,X).
video(media(2),X):- clip(oxygen,X).
video(media(2),X) :- clip(sonic(vegter),X).


program(media(3),9).
video(media(3), X) :- X from [ abramovic(7) ]. 
video(media(3),X):- %% 9 relation in time
 member(N,[9,1,19,3,5]), %%9,10,11,12,13,14,15,16,17]),
 clip(abramovic(N),X).
video(media(3),X) :- clip(stem,X).
video(media(3),X) :- clip(sonic(vegter),X).

program(media(4),9).
video(media(4),X) :- X from [ anim(balls), anim(feet) ].
video(media(4),X):- member(N,[3,4]), clip(animatrix(N),X).
video(media(4),X) :- X from [ design ].
video(media(4),X) :- clip(proposal,X).
video(media(4),X) :- clip(sonic(vegter),X).
video(media(4),X) :- clip(oxygen,X).



start(media(r),'nra:312345krxsch:2ch:srm2:b0:ts:n').
%%start(media(r),'nra:312345krxsch:3c:srm2:ts:n').
eq(media(r), choice = 'n:lr:ml3:3l:n').
eq(media(r), return = 'n:nsx:n').
eq(media(r), command = 'n:e4:n').
eq(media(r), effects = 'n:ssf:n').
eq(media(r), objects = 'n:p0:3p:n').
eq(media(r), meta = nts).
eq(media(r), cmd:meta = text). %% the display name
program(media(r),9).
run(media(r),X) :- member(X,[2,3,4,5,6,7,8,9]).
%% video(media(r),1).
video(media(r),X) :- X from [ balloon ].
video(media(r),X) :- X from [ im(08:103) ].
%%video(media(r),X) :- X from [ im(08:104) ].
video(media(r),X) :- X from [ im(08:107) ].
%%video(media(r),X) :- X from [ im(08:110) ].
%%video(media(r),X) :- X from [ im(08:111) ].
%%video(media(r),X) :- X from [ im(08:201) ].
%%video(media(r),X) :- X from [ im(08:204) ].
video(media(r),X) :- X from [ im(08:205) ].
%%video(media(r),X) :- X from [ im(08:206) ].
%%video(media(r),X) :- X from [ im(08:208) ].
%%video(media(r),X) :- X from [ im(08:210) ].
video(media(r),X) :- X from [ im(08:213) ].
%%video(media(r),X) :- X from [ im(08:301) ].
video(media(r),X) :- X from [ im(08:302) ].
video(media(r),X) :- X from [ im(08:304) ].
%%video(media(r),X) :- X from [ im(08:305) ].
%%video(media(r),X) :- X from [ im(08:306) ].
%%video(media(r),X) :- X from [ im(08:309) ].
video(media(r),X) :- X from [ im(08:313) ].
%%video(media(r),X) :- X from [ tube(wall) ].



start(media(v),'nra:312345krxsch:2ch:srm2:ts:n').
eq(media(v), choice = 'n:lv:ml2:2l:p1:1p:p2:1p:p4:1p:n').
eq(media(v), return = 'n:nsx;f2:n').
eq(media(v), command = 'n:e4:n').
eq(media(v), effects = 'n:ssf:n').
eq(media(v), objects = 'n:p0:3p:n').
eq(media(v), meta = nts).
eq(media(v), cmd:meta = text). %% the display name
program(media(v),9).
%%video(media(v),X) :- camera(video:clip = X).
video(media(v),X) :- X from [ tube(strings) ].
video(media(v),X) :- X from [ game(over) ].
video(media(v),X):- member(N,[doll-face, content]), clip(tube(N),X).
video(media(v),X) :- X from [ tube(cs) ].
video(media(v),X) :- X from [ sl(vu) ].
%%video(media(v),X) :- X from [ tube(science) ].
video(media(v),X) :- X from [ tube(shark) ].
video(media(v),X) :- clip(tube(hello-world),X).


start(media(o),'nra:312345krxsch:2ch:srm2:ts:n').
eq(media(o), choice = 'n:lg:ml2:2l:p1:1p:p2:1p:p4:1p:n').
eq(media(o), return = 'n:nsx;f2:n').
eq(media(o), command = 'n:e4:n').
eq(media(o), effects = 'n:ssf:n').
eq(media(o), objects = 'n:p0:3p:n').
eq(media(o), meta = nts).
eq(media(o), cmd:meta = text). %% the display name
program(media(o),9).
%%video(media(o),X) :- camera(video:clip = X).
video(media(o),X) :- X from [ balls ].
video(media(o),X) :- X from [ art(vasulka) ].
video(media(o),X):-
  member(N,[nano,process(5),stripes,vegter]),
  clip(sonic(N),X).
video(media(o),X) :- clip(lips,X).
video(media(o),X) :- clip(stem,X).

%% media(c)


start(media(v),'nra:312345krxsch:2ch:srm2:ts:n').
eq(media(c), choice = 'n:lp:ml2:2l:n').

program(media(c),9).
%%video(media(c),X) :- camera(video:clip = X).
%%video(media(c),X) :- X from [ flash ].
video(media(c),X) :- X from [ coldplay ].
video(media(c),X) :- X from [ tube(web20) ].
video(media(c),X) :- X from [ tube(9/11) ].
%%video(media(c),X) :- X from [ edgecodes ].
video(media(c),X) :- X from [ art(rgbxyz) ].
%%video(media(c),X) :- X from [ sonic(nano) ].
video(media(c),X) :- X from [ sonic(stripes) ].
video(media(c),X) :- X from [ art(beautiful) ].
video(media(c),X) :- X from [ shout(strangest) ].
video(media(c),X) :- X from [ tube(content) ].


%% clima futura -- cf

start(media(cf),'nra:312345krxsch:2ch:srm2:ts:n').
eq(media(cf), choice = 'n:lg:ml2:2l:p1:1p:p2:1p:p4:1p:n').
eq(media(cf), return = 'n:nsx;f2:n').
eq(media(cf), command = 'n:e4:n').
eq(media(cf), effects = 'n:ssf:n').
eq(media(cf), objects = 'n:p0:3p:n').
eq(media(cf), meta = nts).
eq(media(cf), cmd:meta = text). %% the display name
program(media(cf),9).
%%video(media(cf),X) :- camera(video:clip = X).
video(media(cf),X) :- X from [ balls, game(over) ].
video(media(cf),X) :- X from [ cf(jaarprijs) ].
video(media(cf),X) :- X from [ cf(dijk) ].
video(media(cf),X) :- X from [ sl(vu) ].
video(media(cf),X) :- clip(cf(short),X).
video(media(cf),X) :- clip(cf(vu),X).
video(media(cf),X) :- clip(cf(journaal),X).

%% creative technology -- ct

start(media(ct),'nra:312345krxsch:2ch:srm2:ts:n').
eq(media(ct), choice = 'n:lg:ml2:2l:p1:1p:p2:1p:p4:1p:n').
eq(media(ct), return = 'n:nsx;f2:n').
eq(media(ct), command = 'n:e4:n').
eq(media(ct), effects = 'n:ssf:n').
eq(media(ct), objects = 'n:p0:3p:n').
eq(media(ct), meta = nts).
eq(media(ct), cmd:meta = text). %% the display name
program(media(ct),9).
%%video(media(ct),X) :- camera(video:clip = X).
video(media(ct),X) :- X from [ balls, game(over) ].
video(media(ct),X) :- X from [ tube(cf) ].
%% video(media(ct),X) :- X from [ tube(calligraphy) ].
video(media(ct),X) :- X from [ tube(doll-face) ].
video(media(ct),X) :- X from [ art(netzhammer) ].
video(media(ct),X) :- clip(art(beautiful),X).
video(media(ct),X) :- clip(primetime,X).
%% video(media(ct),X) :- clip(tube(web20),X).
video(media(ct),X) :- clip(tube(hello-world),X).



lst(media(create),x/text = particle/text).
eq(media(create),l:c = lecture/create).
eq(media(create),s:f = slides/final).
eq(media(create), choice = 'n:lc:2l:ml2:mbcwhf:b0:n').
eq(media(create),x:t = particle/text).
eq(media(create),t:f = text/fed).
eq(media(create),t:p = particle/text).
eq(media(create),x:p = particle/try).
eq(media(create),s:d = slides/final).

program(media(create),9).
%%video(media(create),X) :- camera(video:clip = X).
%%video(media(create),X) :- X from [ 1 ].
video(media(create),X) :- X from [ tube(strings) ].
%%video(media(create),X) :- X from [ flash ].
video(media(create),X) :- X from [ sl(climb) ].
%%video(media(create),X) :- X from [ game(over) ].
%%video(media(create),X) :- X from [ tube(9/11) ].
video(media(create),X) :- X from [ tube(shark) ].
%%video(media(create),X) :- X from [ netzhammer ].
video(media(create),X) :- X from [ tube(doll-face) ].
video(media(create),X) :- X from [ sonic(nano) ].
video(media(create),X) :- X from [ art(beautiful) ].
video(media(create),X) :- X from [ tube(fall) ].
video(media(create),X) :- X from [ tube(citroen) ].

lst(media(game),x/text = particle/text).
eq(media(game),l:c = lecture/game).
eq(media(game),s:f = slides/final).
eq(media(game), choice = 'n:lc:2l:ml2:mbcwhf:b0:n').
eq(media(game),x:t = particle/text).
eq(media(game),t:f = text/fed).
eq(media(game),t:p = particle/text).
eq(media(game),x:p = particle/try).
eq(media(game),s:d = slides/final).

program(media(game),9).
%%video(media(game),X) :- camera(video:clip = X).
%%video(media(game),X) :- X from [ 1 ].
video(media(game),X) :- X from [ tube(strings) ].
%%video(media(game),X) :- X from [ flash ].
video(media(game),X) :- X from [ game(over) ].
%%video(media(game),X) :- X from [ tube(9/11) ].
video(media(game),X) :- X from [ tube(shark) ].
%%video(media(game),X) :- X from [ netzhammer ].
video(media(game),X) :- X from [ sl(climb) ].
%%video(media(game),X) :- X from [ tube(doll-face) ].
video(media(game),X) :- X from [ sl(vu) ].
video(media(game),X) :- X from [ vu(1) ].
video(media(game),X) :- X from [ animatrix(1) ].
%%video(media(game),X) :- X from [ cf(jaarprijs) ].
video(media(game),X) :- X from [ animatrix(2) ].
