%% panorama

%%start(panorama(_),nra:a12345kxshvbuw:c).

ds(panorama(_),frame=0).

eq(panorama(_),p:0 = particles/0).
eq(panorama(_),p:1 = particles/1).
eq(panorama(_),p:2 = particles/2).
eq(panorama(_),p:3 = particles/3).
eq(panorama(_),p:4 = particles/4).
eq(panorama(_),p:5 = particles/5).
eq(panorama(_),p:6 = particles/6).
eq(panorama(_),p:7 = particles/7).
eq(panorama(_),p:8 = particles/8).
eq(panorama(_),p:9 = particles/9).

eq(panorama(_),c:f = n:f4:c).
eq(panorama(_),c:h = n:ssm4h:c).
eq(panorama(_),c:l = n:ld:cmf:c).
eq(panorama(_),c:m = n:ml4:mv4l:c).
eq(panorama(_),c:p = n:p0:mv3p:c).
eq(panorama(_),c:r = n:ran:c).
eq(panorama(_),c:s = n:svm4ssh:c).
eq(panorama(_),c:t = n:tv:c).
eq(panorama(_),c:v = n:v34569:c).
eq(panorama(_),c:x = n:sdm7ssh:c).
eq(panorama(_),c:z = n:csx:e4:c).

eq(panorama(_),c:0 = n:f0:c).
eq(panorama(_),c:1 = n:f0:p1:c).
eq(panorama(_),c:2 = n:f0:p2:c).
eq(panorama(_),c:3 = n:f0:p3c).
eq(panorama(_),c:4 = n:f0:p4:c).
eq(panorama(_),c:5 = n:f0:p5:c).
eq(panorama(_),c:6 = n:f0:p6:c).
eq(panorama(_),c:7 = n:f0:p7:c).
eq(panorama(_),c:8 = n:f0:p8:c).
eq(panorama(_),c:9 = n:f0:p9:c).

eq(panorama(_), choice = 'n:ld:ml3:3:l:n').
eq(panorama(_), command = 'n:sm3hs:n').
eq(panorama(_), effects = 'n:sh:e3:za:n').
eq(panorama(_), objects = ':xo:ao:').
eq(panorama(_), meta = ntd).
eq(panorama(_), cmd:meta = text). %% the display name

eq(panorama(_), t:d = text/panorama). 
eq(panorama(_), l:d = lecture/panorama/persons). 
eq(panorama(_), t:c = text/camera). 
eq(panorama(_), l:c = lecture/camera/persons). 
eq(panorama(_), t:v = text/events). 
eq(panorama(_), l:v = lecture/panorama/things). 
%%eq(panorama(_), s:v = slides/master). 
%%eq(panorama(_), l:v = lecture/master). 
eq(panorama(_), t:p = text/media). 
eq(panorama(_), l:p = lecture/panorama/media). 

eq(panorama(_), t:0 = text/panorama/0). 
eq(panorama(_), t:1 = text/panorama/1). 
eq(panorama(_), t:2 = text/panorama/2). 
eq(panorama(_), t:3 = text/panorama/3). 
eq(panorama(_), t:4 = text/panorama/4). 
eq(panorama(_), t:5 = text/panorama/5). 
eq(panorama(_), t:6 = text/panorama/6). 
eq(panorama(_), t:7 = text/panorama/7). 

eq(panorama(_), t:s = text/panorama/song). 

eq(panorama(_), l:0 = lecture/panorama/0). 
eq(panorama(_), l:1 = lecture/panorama/1). 
eq(panorama(_), l:2 = lecture/panorama/2). 
eq(panorama(_), l:3 = lecture/panorama/3). 
eq(panorama(_), l:4 = lecture/panorama/4). 
eq(panorama(_), l:5 = lecture/panorama/5). 
eq(panorama(_), l:6 = lecture/panorama/6). 
eq(panorama(_), l:7 = lecture/panorama/7). 

eq(panorama(_), l:s = lecture/panorama/song). 

eq(panorama(_), s:c = slides/camera/persons). 
eq(panorama(_), s:d = slides/panorama/persons). 
eq(panorama(_), s:v = slides/panorama/things). 


opt(panorama(_), speed:1 = 4).
opt(panorama(_), speed:2 = 7).

opt(panorama(_), text:head = 'panorama field test (x)').
opt(panorama(_), text:scroll:1 = 'social awareness in the work environment ').
opt(panorama(_), text:scroll:2 = 'self reflections    casual encounters    occasional battles ').


ds(panorama(_), walk:speed = 40).
%% ds(panorama(_), total = 9 ).
%% ds(panorama(_), shift:10 = 1 ).
%% ds(panorama(_), '10=0' ).


%%start(panorama(x),'nran').
start(panorama(x),'nra:mce:612345kxshvbuw:p1:6p:p2:7p:7o:p3:3p:nran:1hf:blwc0:3ctr:z').
%%start(panorama(x),'nra:612345kxshvbuw:p1:6p:p2:7p:7o:p3:3p:2hf:blwc:8ctr:z').
%%start(panorama(x),'nra:612345kxshvbuw:7ohf:xo:bw:sdm7:8ctr:n').
%%eq(panorama(x), start = 'nra:612345kxshvbuw:7ohf:xo:bw:sdm7:8ctr:n').
eq(panorama(x), choice = 'n:xo:bc:lv:ml3:3l:n').
eq(panorama(x), command = 'n:7p:n').
eq(panorama(x), effects = 'n:p0:3p:n').
eq(panorama(x), objects = 'n:za:3h:lv:bw:xr:n').
%%eq(panorama(x), objects = 'n:za:3h:lv:bw:xr:n').
eq(panorama(x), meta = ntv).
eq(panorama(x), cmd:meta = text). %% the display name


program(panorama(x),10).
run(panorama(x),X) :- member(X,[1,3,4,5,6,8, 10]).
%%run(panorama(x),X) :- member(X,[1]).
video(panorama(x),X) :- camera(video:clip = X).
video(panorama(x),X) :- X from [ dummy ]. %% odyssey(1) ].
%%video(panorama(x),X) :- X from [ bleep(1) ].
video(panorama(x),X) :- X from [ balls ].
%%video(panorama(x),X) :- X from [ color ].
video(panorama(x),X) :- X from [ vu(1) ].
video(panorama(x),X) :- clip(panorama(imse),X).
video(panorama(x),X) :- clip(vu(campus),X).
video(panorama(x),X) :- X from [ dummy ].
video(panorama(x),X) :- clip(flash,X).
video(panorama(x),X) :- X from [ dummy ].
video(panorama(x),X) :- X from [ color ].
video(panorama(x),X) :- X from [ dummy ].
video(panorama(x),X) :- X from [ dummy ].


eq(panorama(v), choice = 'n:lv:ml2:2:l:n').
eq(panorama(v), command = 'n:sm3hs:n').
eq(panorama(v), effects = 'n:sh:e3:za:n').
eq(panorama(v), objects = ':xo:ao:').
eq(panorama(v), meta = ntd).
eq(panorama(v), cmd:meta = text). %% the display name

program(panorama(v),10).
%%run(panorama(v),X) :- member(X,[1,3,4,5,6,8, 10]).
%%run(panorama(v),X) :- member(X,[1]).
video(panorama(v),X) :- camera(video:clip = X).
video(panorama(v),X) :- X from [ dummy ]. %% odyssey(1) ].
video(panorama(v),X) :- X from [ balls ].
%%video(panorama(v),X) :- X from [ color ].
video(panorama(v),X) :- X from [ vu(1) ].
video(panorama(v),X) :- clip(panorama(imse),X).
video(panorama(v),X) :- clip(vu(campus),X).
video(panorama(v),X) :- X from [ dummy ].
video(panorama(v),X) :- clip(flash,X).
video(panorama(v),X) :- X from [ dummy ].
video(panorama(v),X) :- X from [ color ].
video(panorama(v),X) :- X from [ dummy ].
video(panorama(v),X) :- X from [ dummy ].



opt(panorama(c), speed:1 = 4).
opt(panorama(c), speed:2 = 7).

opt(panorama(c), text:head = 'launch CAMeRA (2/11/07)').
opt(panorama(c), text:scroll:1 = 'CAMeRA (2/11/07) -- Center for Advanced Media Research Amsterdam ').
opt(panorama(c), text:scroll:2 = 'media research     communication(s)   focus on the future   serious game(s)     Clima Futura      social science(s)   zooming in on society     Second Life     computer & information science(s)     climate research     cross media').


ds(panorama(c), walk:speed = 40).
%% ds(panorama(c), total = 9 ).
%% ds(panorama(c), shift:10 = 1 ).
%% ds(panorama(c), '10=0' ).


start(panorama(c),'nra:mce:612345kxshvbuw:p1:4p:p2:7p:7o:p3:3p:nran:1hf:bwc0:3ctr:z').

eq(panorama(c), choice = 'n:bc:lc:ml4:4l:n').
eq(panorama(c), command = 'n:7p:n').
eq(panorama(c), effects = 'n:p0:3p:n').
eq(panorama(c), objects = 'n:za:3h:lv:bw:xr:n').
%%eq(panorama(x), objects = 'n:za:3h:lv:bw:xr:n').
eq(panorama(x), meta = ntc).
eq(panorama(c), cmd:meta = text). %% the display name


program(panorama(c),10).
%%run(panorama(c),X) :- member(X,[1,3,4,5,6,8, 10]).
%%run(panorama(c),X) :- member(X,[1]).
video(panorama(c),X) :- camera(video:clip = X).
video(panorama(c),X) :- X from [ odyssey(1) ].
video(panorama(c),X) :- X from [ balls ].
video(panorama(c),X) :- X from [ tube(camera) ].
video(panorama(c),X) :- clip(sl(vu),X).
video(panorama(c),X) :- clip(clima,X).
video(panorama(c),X) :- X from [ dummy ].
video(panorama(c),X) :- clip(flash,X).
video(panorama(c),X) :- X from [ sl(climb) ].
video(panorama(c),X) :- X from [ color ].
video(panorama(c),X) :- X from [ dummy ].
video(panorama(c),X) :- X from [ dummy ].
