%% party

%%start(party(_),nra:mba12345kxshvbuw:n).
start(party(_),nra:mgce:ax12345bcosmrt:n).

eq(party(_),c:s = n:xtr:za:mr:c).

eq(party(0),c:0 = n:z0:bc:n).
eq(party(0),c:1 = n:z1:e4:xx23:bc:n).
eq(party(0),c:2 = n:z2:e1:xsxxr:n).
eq(party(0),c:3 = n:z3:e2:xmst:n).
eq(party(0),c:4 = n:z4:xmo:n).
eq(party(0),c:5 = n:z5:xo135:n).
eq(party(0),c:6 = n:z6:e3:xm21:n).
eq(party(0),c:7 = n:z7:e4:xrt:n).
eq(party(0),c:8 = n:z8:xr:n).
eq(party(0),c:9 = n:z9:x1:n).

eq(party(x),c:0 = n:z0:bc:n).
eq(party(x),c:1 = n:z1:r1:e1:f0:xx23:bc:n).
eq(party(x),c:2 = n:z2:r2:e2:f0:xsxxr:n).
eq(party(x),c:3 = n:z3:r3:e3:f0:xmst:n).
eq(party(x),c:4 = n:z4:r4:e4:f0:xmo:n).
eq(party(x),c:5 = n:z5:r5:e5:f0:xo135:n).
eq(party(x),c:6 = n:z6:r6:e6:f0:e3:xm21:n).
eq(party(x),c:7 = n:z7:r6:e7:f0:e4:xrt:n).
eq(party(x),c:8 = n:z8:r8:e8:f0:xr:n).
eq(party(x),c:9 = n:z9:r9:e9:f0:x1:n).

eq(party(ae),c:0 = n:ra:z0:2h:bc:n).
eq(party(ae),c:1 = n:ra:z1:r1:f0:f5:x123:bc:n).
eq(party(ae),c:2 = n:ra:z2:r2:f0:xsrm:n).
eq(party(ae),c:3 = n:ra:z3:r3:f0:f5:n).
eq(party(ae),c:4 = n:ra:z4:2h:f0:xmo:n).
eq(party(ae),c:5 = n:ra:z5:ah:f0:xo135:n).
eq(party(ae),c:6 = n:ra:z6:r6:f0:f2:xm:n).
eq(party(ae),c:7 = n:ra:z7:ah:f0:f2:xd:n).
eq(party(ae),c:8 = n:ra:z8:2h:f0:f5n).
eq(party(ae),c:9 = n:ra:z9:2h:f0:n).

eq(party(_), choice = c:s ).
eq(party(_), command = c:s ).
eq(party(_), effects = n:ss:exz:).
eq(party(_), objects = n:xo:ao:n).
eq(party(_), meta = ntd).
eq(party(_), cmd:meta = text). %% the display name

program(party(0),4).
%%run(party(0),X) :- member(X,[1,2,3,4]).
%%video(party(0),1).
video(party(0),X) :- camera(video:clip = X).
video(party(0),X) :- X from [ anim(balls), sanguo(0), sonic(vegter) ].

program(party(x),9).
run(party(x),X) :- member(X,[1,2,3,4,5,6,7,8,9]).
%%video(party(x),1).
video(party(x),X) :- camera(video:clip = X).
video(party(x),X) :- X from [ anim(balls), sanguo(0) ].
video(party(x),X):- member(N,[3,4]), clip(animatrix(N),X).
video(party(x),X) :- X from [ sanguo(1) ].
video(party(x),X) :- X from [ anim(feet) ].
video(party(x),X) :- clip(sonic(vegter),X).
video(party(x),X) :- clip(oxygen,X).

eq(party(ae), choice = 'n:ld:2l:ml2:mbcwhf:b0:n').

program(party(ae),9).
video(party(ae),X) :- camera(video:clip = X).
%%run(party(ae),X) :- member(X,[1,2]).
run(party(ae),X) :- member(X,[1,2,3,4,5,6,7,8,9]).
video(party(ae),X) :- X from [ relation(ae) ].
video(party(ae),X) :- X from [ tube(calligraphy) ].
%%video(party(ae),X) :- X from [ sanguo(1) ].
%%video(party(ae),X) :- X from [ flash ].
%%video(party(ae),X) :- X from [ game(over) ].
video(party(ae),X) :- X from [ tube(9/11) ].
%%video(party(ae),X) :- X from [ sanguo(1) ].
video(party(ae),X) :- X from [ netzhammer ].
video(party(ae),X) :- X from [ sonic(nano) ].
%%video(party(ae),X) :- X from [ tube(strings) ].
video(party(ae),X) :- X from [ art(beautiful) ].
video(party(ae),X) :- X from [ shout(strangest) ].
video(party(ae),X) :- X from [ oxygen ].
