#include <hush/source.h>
#include <vip.h>

//#include <scene/character.h>
#include <scene/character.h>


#include <scene/dossier.h>
#include <scene/party.h>
#include <scene/display.h>
#include <scene/game.h>

#include <panorama/try.h>
#include <panorama/panorama.h>
#include <panorama/camera.h>



#include <hush/io.h>


static int initialized = 0;


extern "C" {

int HUSH_API load_panorama() {

	
	if (initialized) return 1;
	initialized = 1;
	//scene* sc;



	scene::declare("panorama/try",new vip_try());
	scene::declare("panorama/0",new vip_panorama("type=0"));
	scene::declare("panorama/1",new vip_camera("type=1"));
	

	//scene::declare("vip/panorama",new panorama());
	
	//if (session::_trace)
		cerr << "Loading (vip) panorama " << endl;
	return 1;
	}

};
