#include <hush/source.h>
#include <vip.h>

//#include <scene/character.h>
#include <scene/character.h>

#include <dx/tam/try.h>
#include <dx/tam/tam.h>
#include <dx/tam/morph.h>




#include <hush/io.h>


static int initialized = 0;


extern "C" {

int HUSH_API load_tam() {

	
	if (initialized) return 1;
	initialized = 1;
	scene* sc;

	scene::declare("vip/tam",new vip_try());
	scene::declare("tam/tam",new vip_tam());
	scene::declare("tam/morph",new vip_morph());
	
	
	//if (session::_trace)
		cerr << "Loading (vip) tam " << endl;
	return 1;
	}

};
