#include <hush/source.h>

#include "game.h"
#include <scene/mesh.h>
#include <scene/shader.h>
#include <scene/background.h>
//#include <scene/character.h>
//#include "mesh.h"
#include "scene/character.h"


//#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>

//#include <ch/extern/embedch.h>
//#include "sampclass.h"


//static CCharacter* _tiny = 0;






//static char* _help = "tamtam";
static char* _help = "game";

static scene* dolphin;


int vip_game::ch(char* x) {
int status = 0;
	return status;

}


int vip_game::handle(char* type, char* ev) {
	if (_scene) return _scene->handle(type,ev);

	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[4];
			if (!x) {
				_exclude[4] = 1;
				_exclude[5] = 0;
				txdur = 7;
			} else {
				_exclude[4] = 0;
				_exclude[5] = 1;
				txdur = 12;
			}
		}
	} else if (check(type,ev,"key","0")) {
		state = 0;
	} else if (check(type,ev,"key","1")) {
		state = 1;
	} else if (check(type,ev,"key","2")) {
		state = 2;
	} else if (check(type,ev,"key","3")) {
		state = 3;
	} else if (check(type,ev,"key","4")) {
		state = 4;
	} else if (check(type,ev,"key","5")) {
		state = 5;
	} else if (check(type,ev,"key","6")) {
		state = 6;
	} else if (check(type,ev,"key","7")) {
		state = 7;
	} else if (check(type,ev,"key","8")) {
		state = 8;
	} else if (check(type,ev,"key","9")) {
		state = 9;

	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int vip_game::operator()()
{
  

//state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

vip_game::vip_game(char* opts) 
{
	txdur = 15;
	count = 12;
	//state = 2;

	ch();

_size = 20; //size;
wsprintf(_type,"dossier");
_display = _type;
_stack = 1;

_sim->passivate(this);
_sim -> schedule(this,0.0);


end(20);
loop = 1;

//_tiny = new CCharacter();



//scenes[1] = new satelite();
//scenes[0] = new shader(new background(),"fx=back");
//scenes[0]->opt("shaders","material");

scene* scx = new mesh("knot");
//sc->_shader = "red";
//scenes[1] = sc;
//scenes[1] = new shader(sc,"fx=red"); 
scenes[1] = new shader(scx,"fx=red"); 
//scenes[1]->rotation(0.1,-0.1,0,1.0);
scenes[1]->translation(-3,-2,0);
scenes[1]->scale(5,5,5);

scenes[2] = new mesh("yt");
scenes[2] = new shader(new mesh("raven"),"fx=blue");
//scenes[2] = new shader(new mesh("poser-ae"),"fx=blue");
scenes[2]->translation(2.5,-2,-2);
scenes[2]->rotation(0,-2.57,0.2,1);
scenes[2]->scale(0.9,0.9,0.9);


//scenes[3] = new mesh("nana");
scenes[3] = new mesh("poser");
//scenes[3] = new vip_mesh();
//scenes[3]->translation(0,-2,0);
scenes[3]->scale(1.5,1.5,1.5);
scenes[3]->rotation(0.0,1,0,0.5 * 3.14);

scenes[4] = sc("vip/morph")->create("text=text/casus");
scenes[5] = sc("text/casus")->create();

scenes[7] = sc("vip/trio");

_scene = sc("vip/donuts");

_exclude[0] = 1;
_exclude[1] = 1;
_exclude[2] = 1;
_exclude[3] = 1;
_exclude[4] = 1;
_exclude[5] = 1;
_exclude[6] = 1;
_exclude[7] = 1;



//scenes[2]->scale(0.3,0.3,0.3);




//scale(0.8,0.8,0.8);



 

 
  
}




vip_game::~vip_game()
{
//delete scenes[];
}

int 
vip_game::_load()
{
    int hr = S_OK;

	dolphin = ((dxscene*) dvscene::lookup("menu/dots"))->scenes[10];


	hr = scene::init(_device); // loops through scenes

	
    return hr;
}

int
vip_game::_restore()
{
    HRESULT hr = S_OK;
    float txtime = txdur;
	if (state == 2) {
	static float tm = dxtime();
	if ((dxtime() - tm) > txtime) { tm = dxtime(); _main()->iopt("flip",2);  }
	}

	


    return hr;
}


int
vip_game::_render( ) 
{
HRESULT hr = S_OK;
   
   
    dolphin->state = 1;
	
	//_tiny->Compose((DWORD) 1000 * fraction());
	scenes[1]->rotation(sin(dxtime()),sin(dxtime()),cos(dxtime()),1);
   

	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
  
	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (1) {
		
		if (iopt("message")) message(100,_y-200,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	if (iopt("info")) display(_display);
    //dolphin->state = hold;
	render_end(_device);

 

    return hr;
}

