#include <hush/source.h>
#include "menu-vip.h"

// sub scenes

//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
#include "lectures/lecture-eca.h"
#include "lectures/lecture-imm.h"
#include "lectures/lecture-vip.h"
#include "lectures/lecture-old-vip.h"
#include "lectures/lecture-effects.h"
#include "lectures/lecture.h"
//#include "lectures/scene-test.h"
#include "objects/background-scene.h"
#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"
#include "main/menu-effects.h"
#include "main/menu-tutorial.h"
#include "extra/object-dolphin.h"


#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 6;
static int enable = 0;

static int testmode = 0;
static msg_array msg;

menu_vip::menu_vip() 
{

_msg = &msg;

_selection = preset;
_enabled = enable;
_exclusive = 1;

clear(&msg);

msg[1][0] = "option(s)";
msg[1][1] = "odyssee";
msg[1][2] = "promotion";
//msg[1][3] = "codecs and standards";

msg[1][3] = "tutorial(s)";
msg[1][4] = "...";
msg[1][5] = "example(s)";
msg[1][6] = "  ";
msg[1][6] = "panorama";
msg[1][7] = "dossier";

//msg[1][4] = "models";
//msg[1][5] = "scenes";
//msg[1][6] = "effects";
//msg[1][8] = "media";

scenes[11] = new object_dolphin();
poption("dolphin",scenes[11]);
_exclude[11] = 1;

_states = 9;
state = 1;

_display = "ViP 2006";

//count =  states + 2;

char* ptype;
 

scenes[1] = new scene_odyssee();
scenes[2] = sc("lecture/vip"); //new lecture("lecture=vip");
//scenes[2]->propagate("speed=10");
//scenes[2]->speed(2);
//scenes[2]->process("lecture=vip");
//scenes[3] = new lecture_eca();
scenes[4] = sc("lecture/party"); //new scene_odyssee();
scenes[3] = sc("menu/tutorial"); //new menu_tutorial();
//scenes[4] = 0; //new lecture_vipx();
scenes[5] = sc("x");
int panorama_index = ds("panorama");
//scenes[6] = sc(fm("vip/panorama/%d",panorama_index));
_tk->eval("X:panorama(X)");  ptype = _tk->result();
scenes[6] = sc(ptype);
_tk->eval("X:dossier(X)");  ptype = _tk->result();
scenes[7] = sc(ptype);
_tk->eval("X:party(X)");  ptype = _tk->result();
scenes[8] = sc(ptype);


}

menu_vip::~menu_vip()
{
//delete scenes[];
}


/*
HRESULT 
menu_vip::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

	//restore(device);

    for (int i = 1; i < count; i++) _exclude[i] = 1;
	_handler = _menu;
	_menu->exclude(0);

    if (!_enabled || _selection == 0) {
		_handler = _menu;
		_exclude[count-1] = 0;
		//_menu->state = state;
		//_menu->exclude(0);
	} else if (_enabled && _selection > 0) {
		//scenes[_selection]->exclude(0);
		_handler = scenes[_selection];
		_exclude[_selection] = 0;
		_exclude[count-1] = 1;
		//_menu->exclude(1);
	} else _enabled = 0;

	render_begin(device);


	hr = scene::render(device,texture); // calls restore, compose, render
   

	if (!_selection) display(_display);
	render_end(device);

 
    return hr;
}

*/