

#include "scene-test.h"

// sub scenes

#include "objects/cylinder-scene.h"
#include "objects/plane-scene.h"
#include "objects/background-scene.h"
#include "objects/image-scene.h"
#include "objects/sub-scene.h"
#include "odyssee/scene-1.h"
#include "objects/movie-scene.h"
#include "scene/image.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


scene_test::scene_test() 
{

_end = 60;
loop = 0;
//scale(0.9f,0.9f,0.9f);
//translation(100,100,0);
//rotation(1.0f,0.0f,0.0f,0.5f);
_x = 400; _y = 400;

count = 4;
_exclude[0] = 1; //0
_exclude[1] = 1; //0
_exclude[2] = 0; 
_exclude[3] = 0; //0 
_exclude[4] = 0;
_exclude[5] = 0;
_exclude[6] = 0;


//scenes[0] = new background_scene();

scenes[0] = new image();
scenes[0]->translation(0.0f,0.61f,1.0f);
scenes[0]->scale(1.5,1.5,1.5);

scenes[1] = new image();// cylinder_scene();
//scenes[1] = new movie_scene("C:\\AE\\media\\pictures\\storm","storm",1,19,"jpg");
scenes[2] = new image(".\\present\\imm-intro","img0",1,6,"jpg");
//scenes[1] = new movie_scene(".\\pictures\\storm","storm",1,5,"jpg");
//scenes[2]->mode(0); // 0 = absolute
scenes[2]->translation(0.0f,1.2f,0.0f);
    //scenes[1]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[2]->scale(1.0f,1.0f,1.0f);  
scenes[2]->rate(3.0);  
_slides = scenes[2];

scenes[3] = new image();
scenes[3]->translation(0.0f,1.2f,-0.2f);
    //scenes[1]->rotation(1.0f,1.0f,0.0f,0.5f); // this is naive rotation
scenes[3]->scale(1.0f,1.0f,1.0f);  
//scenes[1]->rate(3.0); 
//scenes[1]->mode(0); // 0 = absolute
scenes[2]->_x = 500;
scenes[2]->_y = 450;




}

scene_test::~scene_test()
{
//delete scenes[];
}

HRESULT 
scene_test::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	// anything else ?

	hr = scene::init(device); // loops through scenes

		 // Turn off culling
    device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    // Turn off D3D lighting
    device->SetRenderState( D3DRS_LIGHTING, FALSE );

    // Turn on the zbuffer
    //device->SetRenderState( D3DRS_ZENABLE, TRUE );

    return hr;
}

HRESULT 
scene_test::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;





    return hr;
}


HRESULT 
scene_test::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

	
	

	
    float f = fraction();
	scenes[2]->scale(f,f,0.5 + 0.5 * f);
	scenes[3]->scale(1.0-2.0*f,1.0-2.0*f,1.0 - 2.0 * f * 0.5);
	//scenes[2]->rotation(1,0,0,f);

	render_begin(device);
	

    // begin the scene_test


	hr = scene::render(device,texture); // calls restore, compose, render

    
	char buf[256];
	sprintf(buf,"fraction: %1.2f",f);
	//message(_x,_y,0xff1ff1ff0,buf);
	render_end(device);

 

    return hr;
}

