

#include <hush/source.h>

#include "particle-skel.h"

#include <scene/shader.h>
#include <scene/background.h>
#include <scene/face.h>


#include <streams.h>
#include <scene/satelite.h>
#include <hush/scanner.h>

#include <hush/sim/sim.h>




//#include "shader.h"


static char* _help = "particle";



int particle_skel::ch(char* x) {
int status = 0;


	return status;

}


int particle_skel::handle(char* type, char* ev) {
	if (check(type,ev,"shift","down")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","a")) {
		if (_ctrl()) {
			int x = _exclude[0];
			_exclude[0] = 1 - x;
		}
	} else if (check(type,ev,"key","0")) {
		int s = 0;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","1")) {
		int s = 1;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	} else if (check(type,ev,"key","2")) {
		int s = 2;
		if (_ctrl()) {
			int x = _exclude[s];
			_exclude[s] = 1 - x;
		}
	
	} else 	return scene::handle(type,ev);
	wsprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}



int particle_skel::operator()()
{
  

state = random(0,2);

_sim->passivate(this);
float t = 5.0;
 
_sim->schedule(this,_gn->exponential(t));
return 0;
 
  
}

particle_skel::particle_skel(char* opts) 
{
	
	count = 12;


_size = 20; //size;
wsprintf(_type,"particle_skel");
_display = _type;

end(100);
loop = 1;

	m_pParticleBuffer  = NULL;
	m_kParticleList    = NULL;
	m_iMaxParticles    = 0;
	m_iNumParticles    = 0;
	m_fAccumulatedTime = 0.0f;

	choice = 0;

 
  
}




particle_skel::~particle_skel()
{
//delete scenes[];
}

int 
particle_skel::_load()
{
    int hr = S_OK;

	m_iMaxParticles = 150;
	m_vOrigin		= D3DXVECTOR3(0.0f,0.0f,0.0f);
	m_vForce		= D3DXVECTOR3(0.0f, -1.0f, 0.0f);

	/* Create vertex buffer */
	hr = _device->CreateVertexBuffer(m_iMaxParticles * sizeof(PointSprite),
                                            D3DUSAGE_DYNAMIC | D3DUSAGE_WRITEONLY | D3DUSAGE_POINTS, 
											D3DFVF_ParticleVertex,
                                            D3DPOOL_DEFAULT, &m_pParticleBuffer, NULL);

    m_kParticleList = new Particle[m_iMaxParticles];
	
	ZeroMemory(&info, sizeof(ParticleInfo));

	info.m_vPositionVariation   = D3DXVECTOR3(0.0f, 0.0f, 3.0f);
	info.m_vStandardVelocity    = D3DXVECTOR3(1.5f, 2.0f, 1.5f);
	info.m_vVelocityVariation   = D3DXVECTOR3(-3.0f, 0.5f, -3.0f);
	info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
	info.m_cStandardStartColor  = D3DCOLOR_RGBA(0, 0, 0, 0);
	info.m_cStartColorVariation = D3DCOLOR_RGBA(255, 255, 255, 50);
	info.m_cStandardEndColor    = D3DCOLOR_RGBA(0, 0, 0, 255);
	info.m_cEndColorVariation   = D3DCOLOR_RGBA(255, 255, 255, 255);
	info.m_fStandardEnergy      = 15.0f;
	info.m_fSize		        = 1.5f;
	info.m_fStandardWeight      = 0.01f;
	info.m_iParticlesPerSecond  = 66;

    m_pParticleInfo = &info;
	
	hr = scene::init(_device); // loops through scenes

	int choice = 2;
	if 	(choice == 1) { //fountain
	Reset();
		SetOrigin(D3DXVECTOR3(0.0f, -3.0f, -3.0f));
		SetForce(D3DXVECTOR3(0.0f, -1.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(1.5f, 2.0f, 1.5f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-3.0f, 0.5f, -3.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(0, 150, 0, 0);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(255, 255, 255, 50);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(0, 0, 0, 255);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(255, 255, 255, 255);
		info.m_fStandardEnergy      = 15.0f;
		info.m_fSize		        = 1.5f;
		info.m_fStandardWeight      = 0.01f;
		info.m_iParticlesPerSecond  = 66;
	} else if (choice == 2) {
		Reset();
		SetOrigin(D3DXVECTOR3(5.0f, 5.0f, 5.0f));
		SetForce(D3DXVECTOR3(0.0f, -1.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(-10.0f, 0.0f, -10.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(0.5f, -1.0f, 0.5f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-1.0f, 0.5f, -1.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 15.0f;
		info.m_fSize		        = 1.5f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 20;

	} else if (choice == 3) { // fire
    Reset();
		SetOrigin(D3DXVECTOR3(0.0f, -3.0f, 0.0f));
		SetForce(D3DXVECTOR3(0.0f, 0.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(3.0f, 0.0f, 3.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(0.2f, 0.5f, 0.0f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-0.4f, 0.5f, 0.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 50, 0, 155);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 200, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 0, 0, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 2.0f;
		info.m_fSize		        = 1.0f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 50;
	} else if (choice == 4) {
       Reset();
		SetOrigin(D3DXVECTOR3(0.0f, -3.0f, 0.0f));
		SetForce(D3DXVECTOR3(-1.0f, 0.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(1.0f, 1.0f, 1.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(0.5f, 0.5f, 0.0f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-1.0f, 0.0f, 0.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 0.2f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 255, 255, 0);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 20.0f;
		info.m_fSize		        = 20.0f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 25;
	} else if (choice == 5) {
		info.m_vPositionVariation   = D3DXVECTOR3(0.0f, 0.0f, 3.0f);
	info.m_vStandardVelocity    = D3DXVECTOR3(1.5f, 2.0f, 1.5f);
	info.m_vVelocityVariation   = D3DXVECTOR3(-3.0f, 0.5f, -3.0f);
	info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
	info.m_cStandardStartColor  = D3DCOLOR_RGBA(0, 0, 0, 0);
	info.m_cStartColorVariation = D3DCOLOR_RGBA(255, 255, 255, 50);
	info.m_cStandardEndColor    = D3DCOLOR_RGBA(0, 0, 0, 255);
	info.m_cEndColorVariation   = D3DCOLOR_RGBA(255, 255, 255, 255);
	info.m_fStandardEnergy      = 15.0f;
	info.m_fSize		        = 1.5f;
	info.m_fStandardWeight      = 0.01f;
	info.m_iParticlesPerSecond  = 66;

	}
	
    return hr;
}

int
particle_skel::_restore()
{
    HRESULT hr = S_OK;
	if (iopt("reset")) {
		Reset();
		iopt("reset",0);
	}

	if (iopt("choice") && (iopt("choice") != choice)) {
	choice = iopt("choice");

	if 	(choice == 1) { //fountain
	Reset();
		SetOrigin(D3DXVECTOR3(0.0f, -3.0f, -3.0f));
		SetForce(D3DXVECTOR3(0.0f, -1.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(1.5f, 2.0f, 1.5f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-3.0f, 0.5f, -3.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(0, 150, 0, 0);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(255, 255, 255, 50);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(0, 0, 0, 255);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(255, 255, 255, 255);
		info.m_fStandardEnergy      = 15.0f;
		info.m_fSize		        = 1.5f;
		info.m_fStandardWeight      = 0.01f;
		info.m_iParticlesPerSecond  = 66;
	} else if (choice == 2) {
		Reset();
		SetOrigin(D3DXVECTOR3(5.0f, 5.0f, 5.0f));
		SetForce(D3DXVECTOR3(0.0f, -1.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(-10.0f, 0.0f, -10.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(0.5f, -1.0f, 0.5f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-1.0f, 0.5f, -1.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 15.0f;
		info.m_fSize		        = 1.5f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 20;

	} else if (choice == 3) { // fire
    Reset();
		SetOrigin(D3DXVECTOR3(0.0f, -3.0f, 0.0f));
		SetForce(D3DXVECTOR3(0.0f, 0.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(3.0f, 0.0f, 3.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(0.2f, 0.5f, 0.0f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-0.4f, 0.5f, 0.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 0.0f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 50, 0, 155);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 200, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 0, 0, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 2.0f;
		info.m_fSize		        = 1.0f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 10;
	} else if (choice == 4) {
       Reset();
		SetOrigin(D3DXVECTOR3(0.0f, -3.0f, 0.0f));
		SetForce(D3DXVECTOR3(-1.0f, 0.0f, 0.0f));
		info.m_vPositionVariation   = D3DXVECTOR3(1.0f, 1.0f, 1.0f);
		info.m_vStandardVelocity    = D3DXVECTOR3(0.5f, 0.5f, 0.0f);
		info.m_vVelocityVariation   = D3DXVECTOR3(-1.0f, 0.0f, 0.0f);
		info.m_vForceVariation      = D3DXVECTOR3(0.0f, 0.2f, 0.0f);
		info.m_cStandardStartColor  = D3DCOLOR_RGBA(255, 255, 255, 0);
		info.m_cStartColorVariation = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_cStandardEndColor    = D3DCOLOR_RGBA(255, 255, 255, 155);
		info.m_cEndColorVariation   = D3DCOLOR_RGBA(0, 0, 0, 0);
		info.m_fStandardEnergy      = 20.0f;
		info.m_fSize		        = 20.0f;
		info.m_fStandardWeight      = 0.001f;
		info.m_iParticlesPerSecond  = 25;
	} else if (choice == 5) {
		Reset();
    info.m_vPositionVariation   = D3DXVECTOR3(0.0f, 0.0f, 3.0f);
	info.m_vStandardVelocity    = D3DXVECTOR3(1.5f, 2.0f, 1.5f);
	info.m_vVelocityVariation   = D3DXVECTOR3(-3.0f, 0.5f, -3.0f);
	info.m_vForceVariation      = D3DXVECTOR3(0.0f, 1.0f, 0.0f);
	info.m_cStandardStartColor  = D3DCOLOR_RGBA(0, 0, 0, 0);
	info.m_cStartColorVariation = D3DCOLOR_RGBA(255, 255, 255, 50);
	info.m_cStandardEndColor    = D3DCOLOR_RGBA(0, 0, 0, 255);
	info.m_cEndColorVariation   = D3DCOLOR_RGBA(255, 255, 255, 255);
	info.m_fStandardEnergy      = 15.0f;
	info.m_fSize		        = 1.5f;
	info.m_fStandardWeight      = 0.01f;
	info.m_iParticlesPerSecond  = 66;
	}
	}

	//Update(delta());
	Update(0.01);


    return hr;
}


int
particle_skel::_render( ) 
{
HRESULT hr = S_OK;

    _texture = _capture;
	if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
  
	render_begin(_device);
	
	_device->SetTexture( 0, _texture );
       //int i = 0;

 if (m_iNumParticles == 0)
	{
		return -1; //noError;
	}

	/* Create point sprites */
	PointSprite *sprites = new PointSprite[m_iNumParticles];

	/* Set sprite properties */
	for (u_int32 i=0; i < m_iNumParticles; i++)
	{
		/* Set position */
		sprites[i].x = m_kParticleList[i].m_vPosition.x;
		sprites[i].y = m_kParticleList[i].m_vPosition.y;
		sprites[i].z = m_kParticleList[i].m_vPosition.z;

		sprites[i].u = 0;
		sprites[i].v = 1;




		/* Set color */
		sprites[i].color = m_kParticleList[i].m_cEndColor - ((m_kParticleList[i].m_fEnergy/m_kParticleList[i].m_fTotalEnergy) * (m_kParticleList[i].m_cEndColor - m_kParticleList[i].m_cStartColor));
	}

	/* Fill vertex buffer */
	PointSprite *ptr;

	/* Lock the vertex buffer */
	if(FAILED(m_pParticleBuffer->Lock(0, m_iNumParticles * sizeof(PointSprite), (void**)&ptr, 0)))
	{
		return -1; //errorLockBuffer;
	}

	/* Here we copy the vertex data into the vertex buffer */
	memcpy(ptr, sprites, m_iNumParticles * sizeof(PointSprite));

	/* Unlock when done copying data into the buffer. */
	m_pParticleBuffer->Unlock();

	/* free memory */
	delete [] sprites;

	/* Set texture */
	//m_kParticleTexture.SetActiveTexture();

	/* Set render states */
	
	_device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
	_device->SetRenderState(D3DRS_ZENABLE, D3DZB_FALSE);
	_device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_ONE);
	
    _device->SetRenderState(D3DRS_POINTSPRITEENABLE, TRUE);
    _device->SetRenderState(D3DRS_POINTSCALEENABLE, TRUE);
	
    _device->SetRenderState(D3DRS_POINTSIZE, FtoDW(m_kParticleList[m_iNumParticles-1].m_fSize));
    _device->SetRenderState(D3DRS_POINTSIZE_MIN, FtoDW(1.0f));
    _device->SetRenderState(D3DRS_POINTSCALE_A, FtoDW(0.0f));
    _device->SetRenderState(D3DRS_POINTSCALE_B, FtoDW(0.0f));
    _device->SetRenderState(D3DRS_POINTSCALE_C, FtoDW(1.0f));

	_device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
	//_device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_SELECTARG1 );

	/* Draw point sprites */
	_device->SetStreamSource(0, m_pParticleBuffer, 0, sizeof(PointSprite));
    _device->SetFVF(D3DFVF_ParticleVertex);
    _device->DrawPrimitive(D3DPT_POINTLIST, 0, m_iNumParticles);

	/* Restore render states */
    _device->SetRenderState(D3DRS_POINTSPRITEENABLE, FALSE);
    _device->SetRenderState(D3DRS_POINTSCALEENABLE, FALSE);
    _device->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
	_device->SetRenderState(D3DRS_ZENABLE, D3DZB_TRUE);
	

	hr = scene::_render(); // calls compose, restore,  render


    
    //_selection = 0;

	
	if (0) {
		
		message(300,500,argb(255,255,120,120),fm("%s [%d]",_help,state));
	} 
	
	

	//display(_display);
   
	render_end(_device);

 

    return hr;
}

void particle_skel::Update (real32 fTimePassed)
{
	/* Calculate current force */
	D3DXVECTOR3 vCurrentForce = m_vForce + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vForceVariation;

	/* Loop through all particles */
	for (u_int32 i=0; i < m_iNumParticles; )
	{
		/* Calculate current weight */
		m_kParticleList[i].m_fWeight = m_kParticleList[i].m_fStartWeight + (m_kParticleList[i].m_fEnergy/m_kParticleList[i].m_fTotalEnergy) * m_kParticleList[i].m_fWeightDelta;

		/* Calculate new velocity */
		m_kParticleList[i].m_vVelocity += vCurrentForce * m_kParticleList[i].m_fWeight;

		/* Update the particle position */
		m_kParticleList[i].m_vPosition = m_kParticleList[i].m_vPosition + (m_kParticleList[i].m_vVelocity * fTimePassed);

		/* Check for reasons to kill it */
		m_kParticleList[i].m_fEnergy -= fTimePassed;
		if(m_kParticleList[i].m_fEnergy <= 0.0)
		{
			/* Move last particle to current position */
			m_kParticleList[i] = m_kParticleList[m_iNumParticles-1];

			/* Decrease nr of particles */
			m_iNumParticles--;
		}
		else
		{
			i++;
		}
	}

	/* Store accumulated time */
	m_fAccumulatedTime += fTimePassed;

	/* Calculate nr of particles needed */
	u_int32 iNewParticles = (u_int32) ((float)m_pParticleInfo->m_iParticlesPerSecond * m_fAccumulatedTime);

	/* Save remaining time */
	m_fAccumulatedTime -= 1.0f / (float) m_pParticleInfo->m_iParticlesPerSecond * iNewParticles;

	/* Emit new particles */
	Emit(iNewParticles);
}

/* Create a couple of new particles */
int particle_skel::Emit (u_int32 iNrOfParticles)
{
	while (iNrOfParticles != 0 && m_iNumParticles < m_iMaxParticles)
	{
		/* Initialize new particle */
		InitializeParticle(m_iNumParticles);

		/* Increase number of particles */
		m_iNumParticles++;

		/* Decrease nr of particles to create */
		iNrOfParticles--;
	}

	/* Return nr of uncreated particles */
	return iNrOfParticles;
}

/* Particle initialization */
void particle_skel::InitializeParticle (u_int32 index)
{
	/* Determine starting position */
	m_kParticleList[index].m_vPosition.x = m_vOrigin.x + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vPositionVariation.x;
	m_kParticleList[index].m_vPosition.y = m_vOrigin.y + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vPositionVariation.y;
	m_kParticleList[index].m_vPosition.z = m_vOrigin.z + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vPositionVariation.z;

	/* Set the velocity */
	m_kParticleList[index].m_vVelocity.x = m_pParticleInfo->m_vStandardVelocity.x + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vVelocityVariation.x;
	m_kParticleList[index].m_vVelocity.y = m_pParticleInfo->m_vStandardVelocity.y + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vVelocityVariation.y;
	m_kParticleList[index].m_vVelocity.z = m_pParticleInfo->m_vStandardVelocity.z + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_vVelocityVariation.z;

	/* Set size */
	m_kParticleList[index].m_fSize = m_pParticleInfo->m_fSize;

	/* Set weight */
	m_kParticleList[index].m_fStartWeight = m_kParticleList[index].m_fWeight = m_pParticleInfo->m_fStandardWeight + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_fWeightVariation;
	m_kParticleList[index].m_fWeightDelta = m_pParticleInfo->m_fStandardWeightDelta + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_fWeightDeltaVariation;

	/* Set color */
	m_kParticleList[index].m_cStartColor.a = m_pParticleInfo->m_cStandardStartColor.a + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.a;
	m_kParticleList[index].m_cStartColor.r = m_pParticleInfo->m_cStandardStartColor.r + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.r;
	m_kParticleList[index].m_cStartColor.g = m_pParticleInfo->m_cStandardStartColor.g + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.g;
	m_kParticleList[index].m_cStartColor.b = m_pParticleInfo->m_cStandardStartColor.b + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cStartColorVariation.b;

	m_kParticleList[index].m_cEndColor.a = m_pParticleInfo->m_cStandardEndColor.a + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.a;
	m_kParticleList[index].m_cEndColor.r = m_pParticleInfo->m_cStandardEndColor.r + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.r;
	m_kParticleList[index].m_cEndColor.g = m_pParticleInfo->m_cStandardEndColor.g + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.g;
	m_kParticleList[index].m_cEndColor.b = m_pParticleInfo->m_cStandardEndColor.b + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_cEndColorVariation.b;
	
	/* Set energy */
	m_kParticleList[index].m_fTotalEnergy = m_kParticleList[index].m_fEnergy = m_pParticleInfo->m_fStandardEnergy + ((float)rand()/RAND_MAX) * m_pParticleInfo->m_fEnergyVariation;
}



/* Reset the particle system */
void particle_skel::Reset (void)
{
	m_iNumParticles = 0;
}

/* Move the particle system */
void particle_skel::Move (D3DXVECTOR3 vDirection)
{
	m_vOrigin += vDirection;
}

/* Set new origin */
void particle_skel::SetOrigin (D3DXVECTOR3 vOrigin)
{
	m_vOrigin = vOrigin;
}

/* Change force */
void particle_skel::SetForce (D3DXVECTOR3 vForce)
{
	m_vForce = vForce;
}

/* Get current origin */
D3DXVECTOR3 particle_skel::GetOrigin (void)
{
	return m_vOrigin;
}

/* Get current force */
D3DXVECTOR3 particle_skel::GetForce (void)
{
	return m_vForce;
}

/* Get current origin */
u_int32 particle_skel::GetNrOfParticles (void)
{
	return m_iNumParticles;
}