#include <hush/source.h>
#include "main.h"

#include <hush/scanner.h>
#include <hush/grammar/converter.h>
#include <hush/grammar/attribute.h>

// sub scenes

//#include "stdafx.h"
//#include "objects/scene-text-3d.h"
//#include "lectures/lecture-eca.h"
//#include "lectures/lecture-imm.h"
//#include "lectures/lecture-vip.h"
//#include "odyssee/scene-test.h"
#include "scene/background.h"
//#include "odyssee/scene-odyssee.h"
//#include <string.h>
#include "scene/menu.h"
//#include "main/menu-media.h"
//#include "main/menu-present.h"
//#include "main/menu-dots.h"
//#include "main/menu-vip.h"
//#include "extra/object-dolphin.h"
//#include "extra/object-water.h"
//#include "extra/object-spectrum.h"
#include "scene/video.h"
#include <scene/dossier.h>

#include <atlbase.h>


//static msg_array msg; //[12][12];


static int preset = 6;
static int enable = 0;

static int testmode =  0; // change this on delivery
static msg_array msg;

main_scene::main_scene() 
{

	scene::declare("main",this);

//width = 1280;
//fullscreen = 0;
//fullscreen = 0;
//_embedded = 1;
_parent = _main();
//_stack = 1;
//_lazy = 0;
_msg = &msg;

_selection = preset;
_enabled = enable;

clear(&msg);
char* sc;

//msg[1][1] = "visualpoetry.tv";

if (1) {
msg[1][2] = "multimedia";
//scenes[2] = (dxscene*) dvscene::lookup("menu/media");
scenes[2] = (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,main:media = X)"));
} else {
	//_tk->source("http://localhost/hush/menu.pl");
	_tk->source("menu.pl");
//msg[1][2] = "multimedia";
msg[1][2] = _tk->strvalue("X:menu(_,main,2,X,_)");
sc = _tk->strvalue("X:menu(_,main,2,_,X)");
//msg[1][2] = sc;
scenes[2] = (dxscene*) dvscene::lookup(sc);
}
msg[1][3] = "presentation(s)";
msg[1][4] = "    ...";

if (!_embedded) {
msg[1][6] = "creative technology";
msg[1][7] = "virtualpoetry.tv";
} else {
msg[1][6] = "creative technology";
msg[1][7] = "virtualpoetry.tv";
}
_states = 9;
//count = 12;

_display = "ViP";

//_tk->load("text");


//scenes[0] = (dxscene*) dvscene::lookup("background");
//scenes[0] = new background();

         

//count =  12;//states + 2;
if (_embedded || testmode) {

_exclude[0] = 1;
//iopt("tx",1);
} else {
_exclude[0] = 0;
}

//_exclude[0] = 0;

if (__video) _scene = __video; else __video = this;



/*
scenes[3] = (dxscene*) dvscene::lookup("menu/present");
scenes[6] = (dxscene*) dvscene::lookup("menu/vip");

scenes[4] = (dxscene*) dvscene::lookup("menu/dots");
*/

scenes[3] = (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,main:present = X)"));
//scenes[6] = (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,main:vip = X)"));
scenes[4] = (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,main:dots = X)"));
scenes[6] = (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,main:create = X)"));
//scenes[6] = (dxscene*) dvscene::lookup("menu/create");
scenes[7] = (dxscene*) dvscene::lookup(_tk->strvalue("X:menu(_,main:vip = X)"));


//scenes[8] = (dxscene*) dvscene::lookup("dossier/0");//new dossier();
//declare("vip/dossier",scenes[7]);
//declare("this",(dxscene*) dvscene::lookup(_tk->strvalue("X:type(X)")));
//_exclude[8] = 1;

if (0) {

	char* k = "dossier";
	char* cat =  _tk->strvalue("X:category(X)");
	char* sel = _tk->strvalue("X:selection(X)");

	_flt = parser::lookup("dossier-ml");
	

	char* q;

	_tk->eval(fm("X:ds(%s,X)",sel));
	if (1) while (q = _tk->result()) {
		attribute p(q);
		ds(p.key(),atoi(p.value()));
		if (ds("debug:ds")) debug(fm("ds:  %s = %d",p.key(),atoi(p.value())),1);
	    }

	//if (_flt) _flt->soinc(loc("/vip/cfg/startup/text/dossier.txt"));
	if (_flt) _flt->soinc(loc("/vip/cfg/vip.cfg"));
	}

//AE/sebas
//scenes[4] = new party();

//scenes[10] = new object_water();
//scenes[10] = new object_dolphin();

//scenes[10]->state = 1;

//for(int i = 1;i <= 7; i++ ) { msg[1][i] = ""; scenes[i] = scenes[4]; }

if (1 && !scene::ds("limited")) // && !scene::ds("restricted"))
	//&& strcmp(scene::_main()->opt("machine"),"tablet") )
{
	scenes[10] = (dxscene*) dvscene::lookup("object/dolphin");
	_exclude[10] = 1;
	//scenes[10]->state = 2;
	
}




scenes[6] = (dxscene*) dvscene::lookup("menu/create");
//scenes[8] = (dxscene*) dvscene::lookup("dossier/0");
//scenes[5] = (dxscene*) dvscene::lookup("dossier/0");

}

main_scene::~main_scene()
{
//delete scenes[];
}

HRESULT 
main_scene::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

    scene::ptr("device","VP",(void*) device);

	// anything else ?

	hr = menu::init(device); // loops through scenes
	if (_scene) rectangle(_scene->_tu,_scene->_tv);

	ds("neutral",1);

    return hr;
}


HRESULT 
main_scene::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    
	_exclude[10] = 0;
	//scenes[10]->state = 1;
	//scenes[10]->iopt("full",1);
	//ds("nopreview",0);
	if (!_enabled) {
	cm("bgcolor","(100,100,100)");
    ds("noenv",1);
	scene::ds("nopreview",0); //XX
	} else if (_enabled ) { 
		ds("noenv",0);
		_exclude[10] = 1;
	    }
	

	//scale(100,100,1);
	set_mode(0);

	    //device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_SELECTARG1);
	    //device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_MODULATE);
	device->SetTextureStageState(0, D3DTSS_ALPHAOP, D3DTOP_DISABLE);
	//DISABLE
	if (1) {
	
	D3DXMATRIXA16 matWorld;
	D3DXMatrixIdentity( &matWorld );
	device->SetTransform(D3DTS_WORLD,&matWorld);
    //scale(150,150,150);

    // Set up our view matrix. A view matrix can be defined given an eye point,
    // a point to lookat, and a direction for which way is up. Here, we set the
    // eye five units back along the z-axis and up three units, look at the
    // origin, and define "up" to be in the y-direction.
    
	if (1) {
	//D3DXVECTOR3 vEyePt( 0.0f, 3.0f,-5.0f );
	D3DXVECTOR3 vEyePt( 0.0f, 3.0f,-4.0f );

    D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
    D3DXMATRIXA16 matView;
    D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
    device->SetTransform( D3DTS_VIEW, &matView );

    // For the projection matrix, we set up a perspective transform (which
    // transforms geometry from 3D view space to 2D viewport space, with
    // a perspective divide making objects smaller in the distance). To build
    // a perpsective transform, we need the field of view (1/4 pi is common),
    // the aspect ratio, and the near and far clipping planes (which define at
    // what distances geometry should be no longer be rendered).
    D3DXMATRIXA16 matProj;
    D3DXMatrixPerspectiveFovLH( &matProj, D3DX_PI/4, 1.0f, 1.0f, 100.0f );
    device->SetTransform( D3DTS_PROJECTION, &matProj );
    }
	}

//device->SetRenderState( D3DRS_ZENABLE, FALSE );

    return hr;
}



HRESULT 
main_scene::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;
    
if (_scene) {
	_texture = texture = _scene->_texture;
	__main->_texture = texture;
	scene::load_captures(_texture);
	//texture = tx(opt("tx"));

}
	//_texture = texture;

    //ds("wall",0);
	//ds("movie",0);


	hr = menu::render(device,texture); // calls restore, compose, render
   

 
    return hr;
}

/*

  // don t bother, is inherited as is

void
main_scene::rectangle( float fTU, float fTV )
{
	m_fTU = fTU;
	m_fTV = fTV;
    
	for (int i=0; i < count; i++) {
            scenes[i]->rectangle(fTU,fTV);
	}
	

}
*/
