
#include <hush/source.h>
#include "menu.h"


#include "scene/text.h"

//#include <atlbase.h>



menu::menu() 
{
_exclusive = 1;
_enabled = 0;
state = 1;
_states = 0;
count = 12;

for (int i = 1; i < MAX_SCENE; i++) _exclude[i] = 1;

/*
   scenes[count-1] = _menu = new text(_msg,0,"menu",_display);
    _menu->state = 1;
    _menu->_selection = _selection;
*/

loop = 1;
end(120);
}

menu::~menu()
{
//delete scenes[];
}

HRESULT 
menu::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	
    scenes[_states] = _menu = new text(_msg,0,"menu",_display);
	//scenes[9] = _menu = new text(_msg,0,"menu",_display);
    _menu->state = 1;
    _menu->_selection = _selection - 1; // because of lazy, do t ask me why

	hr = scene::init(device); // loops through scenes
    return hr;
}



HRESULT 
menu::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

    if (opt("tx") && tx(opt("tx"))) _texture = tx(opt("tx"));
    if (_texture) texture = _texture;

	//restore(device);

    if (_exclusive) for (int i = 1; i < _states+1; i++) _exclude[i] = 1;
	//hndler = _menu;
	//xclude[count-1] = 0;
	//_menu->exclude(0);

    if (!_enabled || _selection == 0) {
		__handler = _menu;
		//if (this != scene::_main->_scene) _menu->_parent = _parent;
		_exclude[_states] = 0;
		//_menu->_enabled = 1;
		//_menu->state = state;
		//_menu->exclude(0);
	} else if (_enabled && _selection > 0 && scenes[_selection]) {
		//scenes[_selection]->exclude(0);
		__handler = scenes[_selection];
		_exclude[_selection] = 0;
		scenes[_selection]->exclude(0);
		_exclude[_states] = 1;
		//_menu->exclude(1);
	} else _enabled = 0;

	render_begin(device);


	hr = scene::render(device,texture); // calls restore, compose, render
   

	if (!_enabled  && __handler == _menu) display(_display);
	render_end(device);

 
    return hr;
}

