#include <hush/source.h>
#include <windows.h>
#include "scene/video.h"

//#undef _UNICODE
//#undef _MBCS
//#include <atlbase.h>
#include "video/dshowtextures.h"

#include <comutil.h>

//#include <assert.h>




/*
// A structure for our custom vertex type. We added texture coordinates.
struct CUSTOMVERTEX
{
    D3DXVECTOR3 position; // The position
    D3DXVECTOR3 n;        // Referenced as v3 in the vertex shader
    D3DCOLOR    color;    // The color
    FLOAT       tu, tv;   // The texture coordinates
};

// Our custom FVF, which describes our custom vertex structure
#define D3DFVF_CUSTOMVERTEX (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX1)
#define CLASSNAME   TEXT("DShow CaptureTex9 Sample")

#define TIMER_ID    100
#define TIMER_RATE  20      // milliseconds



const int   g_nWaves   = 1;     // number of waves on the "flag" -- we used flag-like 3D model
const int   g_nWaveN   = 100;   // number of vertices per wave (wave is a sin from 0 to 2 pi)
                                // we have g_nWaves * g_nWaveN for the top of the flag and
                                // the same number for the bottom, so we have (2 * g_nWaves * g_nWaveN )
                                // vertices for our 3D model

*/

int video::handle(char* type, char* ev) {

	if (0) {
	} else return scene::handle(type,ev);
	sprintf(_key(),"%s: %s", type, ev);
    return _event = _condition;
}




video::video(scene* x) : // m_hwnd( NULL )
 m_dwROTReg( 0xfedcba98 )
, m_d3dcolorBackground( D3DCOLOR_XRGB(50, 100, 150) )
, m_dwStartTime( 0L)
, m_HAR( 1.f )
, m_VAR( 1.f )
, m_Width( 0)
, m_Height( 0)
{

    ZeroMemory( &m_TextureFormat, sizeof(D3DFORMAT));
	count = 3;
	if (x) {
		_lazy = 0;
		scenes[1] = x;
		_exclude[1] = 0;
	}

}


video::~video()
{
	Cleanup();
//delete scenes[];
}

HRESULT 
video::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;

	
	if (_once > 0) return hr;
	_once++;
	

	_device = device;
	m_pd3dDevice = _device;

	/*
	srand( timeGetTime());
    m_dwStartTime = timeGetTime();

	

	CUSTOMVERTEX* pVertices = NULL;
    DWORD N = g_nWaves * g_nWaveN;
*/
    
        // DirectShow: Set up filter graph with our custom renderer.
  
		hr = InitDShowTextureRenderer();
  /*     
        // Create the vertex buffer.
        hr = device->CreateVertexBuffer(  g_nWaves * g_nWaveN * 2 * sizeof(CUSTOMVERTEX),
                                                0, D3DFVF_CUSTOMVERTEX,
                                                D3DPOOL_DEFAULT, &m_pVB, NULL );
        if( FAILED( hr ) )
        {
            Msg(TEXT("Could not create a vertex buffer.  hr=0x%x"), hr);
            return hr;
        }
		

        // Fill the vertex buffer. We are setting the tu and tv texture
        // coordinates, which range from 0.0 to 1.0
        if ( FAILED( hr = m_pVB->Lock( 0, 0, (void**)&pVertices, 0 ) ) )
        {
            Msg(TEXT("Could not lock the vertex buffer.  hr=0x%x"), hr);
            return hr;
        }

        for( DWORD i=0; i<N; i++ )
        {
            // m_HAR and m_VAR recognize the fact that allocated surface
            // can be larger than requested (due to alignment, HW specific)

            // we are not going to change color for upper part of the flag                                    
            pVertices[2*i+0].color    = D3DCOLOR_ARGB(0xFF, 0xFF, 0xFF, 0xFF); 
            pVertices[2*i+0].tu       = m_HAR *(1.f - ((FLOAT)i)/(N-1));
            pVertices[2*i+0].tv       = m_VAR;

            pVertices[2*i+1].tu       = m_HAR *(1.f - ((FLOAT)i)/(N-1));
            pVertices[2*i+1].tv       = 0.0f;
        }

        m_pVB->Unlock();
		

        // call CalculateVertices that changes other parameters of vertices dynamically,
        // depending on the time (animation)
        hr = CalculateVertices();
        if( FAILED(hr))
        {
            return hr;
        }
    
        // set up D3D world, view and perspective matrices 
        // (this function is called only once because we change object's coordinates
        // and do not change point of view)
        //hr = SetupMatrices();
        if( FAILED(hr))
        {
            return hr;
        }

        // set up lights (if HW supports it). Since we do not change the lights 
        // during presentation, call it only once
        //hr = SetupLights();
        
    //Msg(TEXT("Could  create a vertex buffer.  hr=0x%x"), hr);
   */

	hr = scene::init(device); // loops through scenes

    return hr;
}

HRESULT 
video::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
   // Setup render states
	
	hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSU,  D3DTADDRESS_WRAP );
        hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSV,  D3DTADDRESS_WRAP );

	/*
	if (0) {
	 hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSU,  D3DTADDRESS_CLAMP );
        hr = device->SetSamplerState( 0, D3DSAMP_ADDRESSV,  D3DTADDRESS_CLAMP );

        // Set linear filtering quality
        hr = device->SetSamplerState( 0, D3DSAMP_MINFILTER, D3DTEXF_LINEAR );
        hr = device->SetSamplerState( 0, D3DSAMP_MAGFILTER, D3DTEXF_LINEAR );

        // set maximum ambient light
        hr = device->SetRenderState(D3DRS_AMBIENT,RGB(255,255,255));

        // Turn off culling
        hr = device->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

        // Turn on the zbuffer
        hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );

        // Turn off lights
        hr = device->SetRenderState(D3DRS_LIGHTING,FALSE);

        // Enable dithering
        hr = device->SetRenderState(D3DRS_DITHERENABLE, TRUE);

        // disable stencil
        hr = device->SetRenderState(D3DRS_STENCILENABLE, FALSE);

        // manage blending
        hr = device->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);

        hr = device->SetRenderState(D3DRS_SRCBLEND, D3DBLEND_SRCALPHA);

        hr = device->SetRenderState(D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);

        hr = device->SetRenderState(D3DRS_ALPHATESTENABLE, TRUE);

        hr = device->SetRenderState(D3DRS_ALPHAREF, 0x10);

        hr = device->SetRenderState(D3DRS_ALPHAFUNC, D3DCMP_GREATER);


        // Set texture states:

        // Modulate diffuse color of the vertex with texture color (50% and 50%)
        // then when we set color of lower vertices of the flag to background color,
        // it blends with texture and gives coloring of the lower part of the flag
        // correspondent to the background
        hr = device->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE );
        hr = device->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE );

        // turn off alpha operation
        hr = device->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_DISABLE );

}
 
		hr = SetupLights();
*/
    return hr;
}


HRESULT video::compose(IDirect3DDevice9* device,DWORD t) {
	//return S_OK;
	
    return S_OK;
}


HRESULT 
video::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;

    //_device = device;

    CAutoLock lock(&m_cs);

	render_begin(device);
	

        /*	    

        hr = CalculateVertices();
       

        

        // Setup our texture. Using textures introduces the texture stage states,
        // which govern how textures get blended together (in the case of multiple
        // textures) and lighting information. In this case, we are modulating
        // (blending) our texture with the diffuse color of the vertices.
        hr = device->SetTexture( 0, m_Texture );
		//device->SetTexture( 0, texture );
       
        // Render the vertex buffer contents
        hr = device->SetStreamSource( 0, m_pVB, 0, sizeof(CUSTOMVERTEX) );
        
        // we use FVF instead of pixel shader
        //hr = device->SetVertexShader( NULL );
       
        hr = device->SetFVF( D3DFVF_CUSTOMVERTEX );
        
        // draw flaf
        hr = device->DrawPrimitive( D3DPT_TRIANGLESTRIP, 0, 2 * g_nWaveN * g_nWaves -4 );
        

       */

        // Check to see if we need to restart the movie
        CheckMovieStatus();
        hr = S_OK;
   
	  
     
	_texture = m_pTexture;

    //tx("1",_texture);
	hr = scene::render(device,_texture); // calls compose, restore,  render

	_texture = scenes[1]->_texture; // m_pTexture;
	//tx("1",_texture);

    //  device->SetVertexShader(0 );
    
    //_selection = 0;

	hr = device->SetRenderState( D3DRS_ZENABLE, D3DZB_TRUE );
    
	render_end(device);

 

    return hr;
}


void video::Cleanup(void)
{
#ifdef REGISTER_FILTERGRAPH
    // Remove graph from Running Object Table
    RemoveFromROT();
#endif

    // Shut down the graph
    if( m_pMC )
    {
        m_pMC->Stop();
    }
}





//-----------------------------------------------------------------------------
// Name: video::InitD3D()
// Desc: Initializes Direct3D
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Name: video::InitGeometry()
// Desc: Create the textures and vertex buffers
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Name: video::InitDShowTextureRenderer 
// Desc: Create and run DirectShow capture filter graph
//-----------------------------------------------------------------------------
HRESULT video::InitDShowTextureRenderer()
{
    HRESULT hr = S_OK;

    CComPtr<IBaseFilter>    pRenderer;      // Texture Renderer Filter
    CComPtr<IBaseFilter>    pFSrc;          // Source Filter
    CComPtr<IPin>           pFSrcPinOut;    // Source Filter Output Pin   
    CTextureRenderer        *pCTR=0;        // DShow Texture renderer
    
    try
    {
        // Create the filter graph
        //hr = m_pGB.CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC);
		hr = m_pGB.CoCreateInstance(CLSID_FilterGraph);
        if( FAILED(hr))
        {
            Msg(TEXT("Failed to create filter graph. hr = 0x%08x"), hr);
            return hr;
        }

        // Get the graph's media control and media event interfaces
        m_pGB.QueryInterface(&m_pMC);
        m_pGB.QueryInterface(&m_pME);
    
        // Create the Texture Renderer object
        pCTR = new CTextureRenderer(this, NULL, &hr);
        if (FAILED(hr) || !pCTR)
        {
            Msg(TEXT("Could not create texture renderer object.  hr=0x%x"), hr);
            return hr;
        }
    
        // Get a pointer to the IBaseFilter interface on the TextureRenderer
        // and add it to the existing graph
        pRenderer = pCTR;
        
		static int instance = 0;
		char buf[512];
		sprintf(buf,"render (%d)",instance++);
		_bstr_t xbuf = buf;

		// hr = CaptureVideo( pRenderer );

        hr = m_pGB->AddFilter(pRenderer, _T(xbuf));
        if (FAILED(hr))
        {
            Msg(TEXT("Could not add renderer filter to graph.  hr=0x%x"), hr);
            return hr;
        }

        // Initialize the first attached video capture device and set
        // our 3D renderer to render the incoming video    
        hr = CaptureVideo( pRenderer );


        if (FAILED(hr))
        {
            // CaptureVideo will display an appropriate error message
            return hr;
        }
  
  
#ifdef REGISTER_FILTERGRAPH
        // Register the graph in the Running Object Table (for debug purposes)
        AddToROT(m_pGB);
#endif
    
        // Start the graph running
        hr = m_pMC->Run();
        if (FAILED(hr))
        {
            Msg(TEXT("Could not run the DirectShow graph.  hr=0x%x"), hr);
            return hr;
        }
    }// try
    catch(...)
    {
        Msg(TEXT("Application encountered an unexpected error.\r\n\r\n")
            TEXT("This sample is attempting to build a DirectShow graph with\r\n")
            TEXT("a custom TextureRenderer. You may want to check video capture\r\n")
            TEXT("functionality on your system and try to run this sample again."));
        hr = E_UNEXPECTED;  
    }
    return hr;
}

HRESULT video::CaptureVideo(IBaseFilter *pRenderer)
{
    HRESULT hr = S_OK;
    CComPtr<IBaseFilter> pSrcFilter;

    try
    {
        // Create the capture graph builder object to assist in building
        // the video capture filter graph
		// CLSCTX_INPROC_SERVER
		
        
        hr = CoCreateInstance (CLSID_CaptureGraphBuilder2 , NULL, CLSCTX_INPROC_SERVER,
			//CoCreateInstance (CLSID_CaptureGraphBuilder2 , NULL, CLSCTX_INPROC,
                               IID_ICaptureGraphBuilder2, (void **) &(m_pCapture.p));
        if (FAILED(hr))
        {
            Msg(TEXT("Could not create the capture graph builder!  hr=0x%x\0"), hr);
            return hr;
        }
    
        // Attach the existing filter graph to the capture graph
        hr = m_pCapture->SetFiltergraph(m_pGB);
        if (FAILED(hr))
        {
            Msg(TEXT("Failed to set capture filter graph!  hr=0x%x\0"), hr);
            return hr;
        }

        // Use the system device enumerator and class enumerator to find
        // a video capture/preview device, such as a desktop USB video camera.
       //hr = FindCaptureDevice(&pSrcFilter);
       

        static instance = 0;
		// load_video
        char buf[512];
		sprintf(buf,"video (%d)",instance++);
		_bstr_t xbuf = buf;
		//hr = find_capture(&pSrcFilter);
        char* path = 0;
		int vtype = iopt("type");
		char* vname = opt("name");
		int vnum = iopt("num");
		//path = machine::find_video(vtype, vname,&pSrcFilter, 0, vnum,buf);
		path = machine::find_video(ds("video:type"), cm("video:name"),&pSrcFilter, 0, ds("video:device"),buf);
		
		if (path) {
			//IBaseFilter *fSource = 0;
		_bstr_t xpath = path;
		//xpath = "d:\\vip\\media\\isabell.avi";
		//Msg(TEXT("video: %s"), (char*) xpath);
        //hr = m_pGB->AddSourceFilter(_T(xpath), _T(xbuf), &fSource);
		hr = m_pGB->AddSourceFilter(_T(xpath), _T(xbuf), &pSrcFilter);
		} else {
   
        // Add the returned capture filter to our graph.
        //hr = m_pGB->AddFilter(pSrcFilter, L"Video Capture");
		hr = m_pGB->AddFilter(pSrcFilter, _T(xbuf));
		}


        if (FAILED(hr))
        {
            Msg(TEXT("Could not ADD the capture filter to the graph.  hr=0x%x\r\n\r\n")
                TEXT("Make sure that a video capture device is connected and functional\n")
                TEXT("and is not being used by another capture application.\0"), hr);
            return hr;
        }

        // Render the preview pin on the video capture filter.
        // This will create and connect any necessary transform filters.
        // We pass a pointer to the IBaseFilter interface of our CTextureRenderer
        // video renderer, which will draw the incoming video onto a D3D surface.

		if (!path) {
        hr = m_pCapture->RenderStream (&PIN_CATEGORY_PREVIEW, &MEDIATYPE_Video,
                                     pSrcFilter, NULL, pRenderer);
		//Msg(TEXT("Could  RENDER"));
		} else {
		hr = m_pCapture->RenderStream (0, 0,
                                       pSrcFilter, NULL, pRenderer);
		int _audio = iopt("audio");
		if (_audio)
		hr = m_pCapture->RenderStream(0, &MEDIATYPE_Audio, pSrcFilter, 0, NULL);
		// pBuild->RenderStream(0, 0, pSource, 0, g_filter);
		}
		if ( FAILED(hr))
        {
            Msg(TEXT("Could not RENDER the capture stream.  hr=0x%x\r\n\r\n")
                TEXT("Make sure that a video capture device is connected and functional\n")
                TEXT("and is not being used by another capture application.\0"), hr);
            return hr;
        }
    }// try
    catch(...)
    {
        Msg(TEXT("Application encountered an unexpected error when trying to render the graph."));
        hr = E_UNEXPECTED;
    }

    return S_OK;
}

HRESULT video::FindCaptureDevice(IBaseFilter ** ppSrcFilter)
{
    HRESULT hr = S_OK;
    CComPtr <IMoniker> pMoniker;
    CComPtr <ICreateDevEnum> pDevEnum;
    CComPtr <IEnumMoniker> pClassEnum;

    IBaseFilter * pSrc = NULL;
    ULONG cFetched;

    if (!ppSrcFilter)
        return E_POINTER;

    try
    {
        // Create the system device enumerator
        hr = CoCreateInstance (CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
                            IID_ICreateDevEnum, (void **) &pDevEnum);
        if (FAILED(hr))
        {
            Msg(TEXT("Couldn't create system device enumerator.  hr=0x%x"), hr);
            return hr;
        }

        // Create an enumerator for the video capture devices
        hr = pDevEnum->CreateClassEnumerator (CLSID_VideoInputDeviceCategory, &pClassEnum, 0);
        if (FAILED(hr))
        {
            Msg(TEXT("Couldn't create class enumerator for video input device category.  hr=0x%x"), hr);
            return hr;
        }

        // If there are no enumerators for the requested type, then 
        // CreateClassEnumerator will succeed, but pClassEnum will be NULL.
        if (pClassEnum == NULL)
        {
            MessageBox(NULL,TEXT("No video capture device was detected.\r\n\r\n")
                    TEXT("This sample requires a video capture device, such as a USB WebCam,\r\n")
                    TEXT("to be installed and working properly.  The sample will now close."),
                    TEXT("No Video Capture Hardware"), MB_OK | MB_ICONINFORMATION);
            return E_FAIL;
        }

        // Use the first video capture device on the device list.
        // Note that if the Next() call succeeds but there are no monikers,
        // it will return S_FALSE (which is not a failure).  Therefore, we
        // check that the return code is S_OK instead of using SUCCEEDED() macro.
        if (S_OK == (pClassEnum->Next (1, &pMoniker, &cFetched)))
        {
            // Bind Moniker to a filter object
            hr = pMoniker->BindToObject(0,0,IID_IBaseFilter, (void**)&pSrc);
            if (FAILED(hr))
            {
                Msg(TEXT("Couldn't bind moniker to filter object.  hr=0x%x"), hr);
                return hr;
            }
        }
        else
        {
            Msg(TEXT("Unable to access video capture device."));   
            return E_FAIL;
        }

        // Copy the found filter pointer to the output parameter.
        // Do NOT Release() the reference, since it will still be used
        // by the calling function.
        *ppSrcFilter = pSrc;

    }// try
    catch(...)
    {
        Msg(TEXT("Application encountered an unexpected error when trying to find capture device."));
        hr = E_UNEXPECTED;
    }
    return hr;
}

//-----------------------------------------------------------------------------
// Name: SetupMatrices()
// Desc: Sets up the world, view, and projection transform matrices.
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
// Name: video::SetupMatrices()
// Desc: Sets up two lights: one is white directed from viewer's left, 
//       the other is pale yellow directed from viewer to the flag
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// Name: video::CalculateVertices()
// Desc: Calculates vertices of the flag to provide animation
//       DShow clock is animation parameter
//-----------------------------------------------------------------------------
/*
HRESULT video::CalculateVertices()
{
    HRESULT hr=S_OK;
    FLOAT theta;
    FLOAT arg;
    FLOAT dt = (timeGetTime() - m_dwStartTime)/500.f;

    static DWORD N = g_nWaveN * g_nWaves;
    static FLOAT pi3_4 = 3.0f*D3DX_PI/4.0f;
    FLOAT waveHeight = 0.4f + 0.1f * (cosf( 2.f*dt )+1.f);

    CUSTOMVERTEX* pVertices = NULL;
   
        hr = m_pVB->Lock( 0, 0, (void**)&pVertices, 0 );
        if ( FAILED( hr ) )
        {
            Msg(TEXT("Could not lock the vertex buffer.  hr=0x%x"), hr);
            return hr;
        }
    
        for( DWORD i=0; i<N-1; i++ )
        {
            // theta runs from -(2 pi) to zero
            theta = (2*D3DX_PI*i)/(N-1);
            arg = theta * (N-1) / (FLOAT)g_nWaveN + dt;
            theta -= D3DX_PI;
            
            //  only z-coord changes
            pVertices[2*i+0].position = D3DXVECTOR3( theta, +pi3_4, waveHeight * sinf(arg) );

            // we use normal to calculate shadows
            // since (x,y,z) = (t,C,A sin( B t + c)),
            //      n(x,y,z) = (1,0,- B A cos( B t + c)) (partial derivatives by t... or close to this ;-) )
            pVertices[2*i+0].n        = D3DXVECTOR3( 1.f, 0.f, -waveHeight * (N-1) / (FLOAT)g_nWaveN * cosf(arg) );

            // lower part delayed by pi/2 so that waves would not be completely vertical
            pVertices[2*i+1].position = D3DXVECTOR3( theta,  -pi3_4, waveHeight * sinf(arg + D3DX_PI/2.f) );
            pVertices[2*i+1].n        = D3DXVECTOR3( 1.f, 0.f, -waveHeight * (N-1) / (FLOAT)g_nWaveN * cosf(arg + D3DX_PI/2.f) );

            // we have to update color every time because user can toggle background color by 
            // hitting 'space' or 'enter'
            pVertices[2*i+1].color    = m_d3dcolorBackground;
        }

        m_pVB->Unlock();

   
    return hr;
}
*/
//-----------------------------------------------------------------------------
// Name: CheckMovieStatus
// Desc: Wait for capture events like device removal
//-----------------------------------------------------------------------------
void video::CheckMovieStatus(void)
{
    long lEventCode;
    long lParam1;
    long lParam2;
    HRESULT hr = S_OK;

    if (!m_pME)
    {
        return;
    }
        
    // Check for completion events
    hr = m_pME->GetEvent(&lEventCode, (LONG_PTR *) &lParam1, (LONG_PTR *) &lParam2, 0);
    if (SUCCEEDED(hr))
    {
        // Free any memory associated with this event
        hr = m_pME->FreeEventParams(lEventCode, lParam1, lParam2);
    }
}

void video::SetColor( D3DCOLOR color )
{
    m_d3dcolorBackground = color;
}

IDirect3DDevice9 * video::GetDevice()
{
    if( _device )
    {
        return _device;
    }
    return NULL;
}


HRESULT video::CreateTexture( UINT Width, UINT Height, D3DFORMAT format)
{

		    HRESULT hr = S_OK;
    D3DSURFACE_DESC ddsd;

	// hr = m_pCP->CreateTexture( m_lVidWidth, m_lVidHeight, D3DFMT_A8R8G8B8);

    try
    {
        hr = m_pd3dDevice->CreateTexture( Width, Height, 1, 0, format, 
                                          D3DPOOL_MANAGED, &m_pTexture, NULL);
        if( FAILED(hr))
        {
            Msg(TEXT("Failed to create IDirect3DTexture9."), hr);
            return hr;
        }

        hr = m_pTexture->GetLevelDesc( 0, &ddsd );
        if( FAILED(hr))
        {
            Msg(TEXT("Failed to get level description of IDirect3DTexture9."), hr);
            return hr;
        }

        if (ddsd.Format != D3DFMT_A8R8G8B8
			)
			//&& ddsd.Format != D3DFMT_A1R5G5B5) 
        {
            Msg(TEXT("Texture has a format we can't handle. Format = 0x%x"), ddsd.Format);
            return VFW_E_TYPE_NOT_ACCEPTED;
        }

        m_TextureFormat = ddsd.Format;
        m_Width = ddsd.Width;
        m_Height = ddsd.Height;
        m_HAR = (FLOAT)Width  / (FLOAT)ddsd.Width;
        m_VAR = (FLOAT)Height / (FLOAT)ddsd.Height;
		rectangle(m_HAR,m_VAR);
    }
    catch(...)
    {
        Msg(TEXT("Application excountered unexpected error when trying to allocate IDirect3DTexture9."), 
            E_UNEXPECTED);
        hr = E_UNEXPECTED;
    }
    return hr;
  
}

HRESULT video::BltToTexture(IDirect3DSurface9 *lpSurfSrc, UINT Width, UINT Height)
{
    HRESULT hr = S_OK;

    CAutoLock lock(&m_cs);
    CComPtr< IDirect3DSurface9> lpSurfDst;

    RECT rcDst;
    RECT rcSrc;

    if( !lpSurfSrc )
    {
        return E_POINTER;
    }
    try
    {
        hr = m_pTexture->GetSurfaceLevel( 0, &lpSurfDst);
        if( FAILED(hr))
        {
            Msg(TEXT("Cannot get IDirect3DSurface9 interface. hr = 0x%08x"), hr);
            return hr;
        }

        rcDst.left = rcDst.top = 0;
        rcDst.right = m_Width;
        rcDst.bottom = m_Height;

		rcDst.left = 0; 
		rcDst.top = m_Height;
        rcDst.right = m_Width;
        rcDst.bottom = 0;

        ZeroMemory( &rcSrc, sizeof(RECT));
        rcSrc.right = Width;
        rcSrc.bottom = Height;
        
        hr = D3DXLoadSurfaceFromSurface( lpSurfDst, NULL, &rcDst, lpSurfSrc, NULL, &rcSrc, D3DX_DEFAULT, 0xFF000000);
        if( FAILED(hr))
        {
            Msg(TEXT("Cannot Blt onto texture surface. hr = 0x%08x"), hr);
            return hr;
        }
    }
    catch(...)
    {
        Msg(TEXT("Application excountered unexpected error when trying to Blt onto texture."), 
            E_UNEXPECTED);
        hr = E_UNEXPECTED;
    }
    return hr;
}

HRESULT video::CopyMediaSample( IMediaSample *pSample, LONG lSamplePitch )
{
    HRESULT hr = S_OK;
    CAutoLock lock(&m_cs);

    BYTE * pSampleBuffer = NULL;
    BYTE * pTextureBuffer = NULL;
    BYTE * pbS = NULL;

    DWORD * pdwS = NULL;
    DWORD * pdwD = NULL;

    UINT row;
    UINT col;

    D3DLOCKED_RECT d3dlr;
    LONG  lTexturePitch;     // Pitch of texture

    if( !pSample )
        return E_POINTER;

    if( !m_pTexture )
        return E_UNEXPECTED;

    try
    {
        // Get the video bitmap buffer
        hr = pSample->GetPointer( &pSampleBuffer );
        if( FAILED(hr))
        {
			Msg(TEXT("pointer"));
            return hr;
        }

        // Lock the Texture
        hr = m_pTexture->LockRect( 0, &d3dlr, 0, 0 );
        if( FAILED(hr))
        {
			//Msg(TEXT("lock"));
            return E_FAIL;
        }

        // Get the texture buffer & pitch
        pTextureBuffer = static_cast<byte *>(d3dlr.pBits);
        lTexturePitch = d3dlr.Pitch;

		_width = m_Width;
		_height =m_Height;

        if( m_TextureFormat == D3DFMT_A1R5G5B5 )
        {
			pTextureBuffer += (m_Height-1) * lTexturePitch;
            for(row = 0; row < m_Height; row++ ) 
			//for(row = m_Height-1; row >= 0; row-- ) 
            {
                BYTE *pBmpBufferOld = pTextureBuffer;
                BYTE *pTxtBufferOld = pSampleBuffer;   
				//pTextureBuffer += lTexturePitch;

                for (col = 0; col < m_Width; col++) 
                {
                    *(WORD *)pTextureBuffer = (WORD)
                        (0x8000 +
                        ((pSampleBuffer[2] & 0xF8) << 7) +
                        ((pSampleBuffer[1] & 0xF8) << 2) +
                        (pSampleBuffer[0] >> 3));

                    pTextureBuffer += 2;
                    pSampleBuffer += 3;
                }
                pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                pTextureBuffer = pTxtBufferOld - lTexturePitch;
            }
        } else
        if( m_TextureFormat == D3DFMT_A8R8G8B8 )
        {
			static char* xbuf[800*600*4];
			_buffer = (void*) xbuf; 
			BYTE* pb = (BYTE*) _buffer;
			
            pTextureBuffer += (m_Height-1) * lTexturePitch;
            for(row = 0; row < m_Height; row++ ) 
            {
                BYTE *pBmpBufferOld = pSampleBuffer;
                BYTE *pTxtBufferOld = pTextureBuffer;  
				//pTextureBuffer += lTexturePitch;
				//assert(1!=1);

                for (col = 0; col < m_Width; col++) 
                {
                    pb[0] = pTextureBuffer[0] = pSampleBuffer[0];
                    pb[1] = pTextureBuffer[1] = pSampleBuffer[1];
                    pb[2] = pTextureBuffer[2] = pSampleBuffer[2];
                    pb[3] = pTextureBuffer[3] = 0xFF;//(BYTE)(0xFF * y / (m_lVidHeight-1));

                    pb += 4; 

                    //pTextureBuffer += 4;
					pTextureBuffer += 4;
                    pSampleBuffer  += 3;
                }

                pSampleBuffer  = pBmpBufferOld + lSamplePitch;
                pTextureBuffer = pTxtBufferOld - lTexturePitch;
            }

        } else Msg(TEXT("wrong format"));

        hr = m_pTexture->UnlockRect(0);

    }
    catch(...)
    {
        hr = m_pTexture->UnlockRect(0);
        ASSERT(0);
    }
	
	return hr;
}


//-----------------------------------------------------------------------------
// Name: video::MsgProc()
// Desc: The window's message handler
//-----------------------------------------------------------------------------
/*
LRESULT WINAPI MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
    switch( msg )
    {
        case WM_DESTROY:
            PostQuitMessage( 0 );
            return 0;

        case WM_TIMER:
        case WM_PAINT:
            if (g_pPresentation)
                g_pPresentation->Render();       // Update the main window when needed
            break;

        case WM_CHAR:
        {
            video *pP = NULL;
            D3DCOLOR color;
            pP = (video*)GetWindowLongPtr( hWnd, GWLP_USERDATA);

            // Close the app if the ESC key is pressed
            if (wParam == VK_ESCAPE)
            {
                PostMessage(hWnd, WM_CLOSE, 0, 0);
            }
            else if(wParam == VK_SPACE)
            {
                color = D3DCOLOR_XRGB(rand()%0xFF, rand()%0xFF, rand()%0xFF);
                if(pP)
                {
                    pP->SetColor(color);
                }
            }
            else if(wParam == VK_RETURN)
            {
                color = D3DCOLOR_XRGB(0, 0, 0);
                if(pP)
                {
                    pP->SetColor(color);
                }
            }
        }
        break;

        case WM_SYSCOMMAND:
        {
            switch (wParam)
            {
                case ID_HELP_ABOUT:
                    // Create a modeless dialog to prevent rendering interruptions
                    CreateDialog(hInstance, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, 
                                (DLGPROC) AboutDlgProc);
                    return 0;
            }
        }
        break;
    }

    return DefWindowProc( hWnd, msg, wParam, lParam );
}
*/

//-----------------------------------------------------------------------------
// Running Object Table functions: Used to debug. By registering the graph
// in the running object table, GraphEdit is able to connect to the running
// graph. This code should be removed before the application is shipped in
// order to avoid third parties from spying on your graph.
//-----------------------------------------------------------------------------
#ifdef REGISTER_FILTERGRAPH

HRESULT video::AddToROT(IUnknown *pUnkGraph) 
{
    HRESULT hr = S_OK;
    IMoniker * pmk = NULL;
    IRunningObjectTable *pROT = NULL;
    WCHAR wsz[256];
    
    if (FAILED(GetRunningObjectTable(0, &pROT))) 
    {
        return E_FAIL;
    }

    wsprintfW(wsz, L"FilterGraph %08x  pid %08x\0", (DWORD_PTR) 0, GetCurrentProcessId());

    hr = CreateItemMoniker(L"!", wsz, &pmk);
    if (SUCCEEDED(hr)) 
    {
        // Use the ROTFLAGS_REGISTRATIONKEEPSALIVE to ensure a strong reference
        // to the object.  Using this flag will cause the object to remain
        // registered until it is explicitly revoked with the Revoke() method.
        //
        // Not using this flag means that if GraphEdit remotely connects
        // to this graph and then GraphEdit exits, this object registration 
        // will be deleted, causing future attempts by GraphEdit to fail until
        // this application is restarted or until the graph is registered again.
        hr = pROT->Register(ROTFLAGS_REGISTRATIONKEEPSALIVE, pUnkGraph, 
                            pmk, &m_dwROTReg);
        pmk->Release();
    }

    pROT->Release();
    return hr;
}


void video::RemoveFromROT(void)
{
    IRunningObjectTable *pirot=0;

    if (SUCCEEDED(GetRunningObjectTable(0, &pirot))) 
    {
        pirot->Revoke(m_dwROTReg);
        pirot->Release();
    }
}

#endif


