#include <hush/source.h>
#include "shader.h"
#include <streams.h>


#include <comutil.h>



shaderx::shaderx(scene* x, char* opts) 
//shaderx::shaderx(char* opts) 
{

	process("shaderx=basic");
	if (opts) process(opts);

//_stack = 1;
//_size = 20; //size;
wsprintf(_type,"shaderx");
//_letterset = "Times New Roman";
_display = _type;


	if (x) _scene = x;
	if (opt("scene")) _scene = scopt("scene");

}



shaderx::~shaderx()
{
//delete scenes[];
}

int
shaderx::_load()
{
    HRESULT hr = S_OK;
	

	
	
    hr = load_effect(opt("fx"));
	effect("fx",_effect);
	hr = scene::_load(); // loops through scenes

	_stack = 1;

    return hr;
}

int
shaderx::_restore()
{
    HRESULT hr = S_OK;
	
	char* fx = opt("fx");
	if (fx) _effect = effect(fx);
	//_effect = effect(opt("effect"));
	
	if (1) {
	  // Set effect variables as needed
    D3DXCOLOR colorMtrlDiffuse(1.0f, 1.0f, 1.0f, 1.0f);
    D3DXCOLOR colorMtrlAmbient(0.35f, 0.35f, 0.35f, 0);
    _effect->SetVector("g_MaterialAmbientColor", (D3DXVECTOR4*)&colorMtrlAmbient);
    _effect->SetVector("g_MaterialDiffuseColor", (D3DXVECTOR4*)&colorMtrlDiffuse);
	_effect->SetVector("ambient", (D3DXVECTOR4*)&colorMtrlAmbient);
    _effect->SetVector("diffuse", (D3DXVECTOR4*)&colorMtrlDiffuse);

	
	}

	
	if (1) {
	//_effect->SetTechnique( * efx["RenderScene"] );
    //_effect->SetTechnique( m_hTechniqueRenderScene );
	//_effect->SetTechnique( "RenderScenePS" );
	

  // Update the effect's variables 
	    _effect->SetMatrix( "g_mWorldViewProjection", _wvp()); //  &mWorldViewProjection );
        _effect->SetMatrix( "g_mWorld", _world()); //&mWorld );
        _effect->SetFloat( "g_fTime",dxtime() );
		_effect->SetTexture("g_MeshTexture",_texture);

		 _effect->SetMatrix( "wvp", _wvp()); //  &mWorldViewProjection );
        _effect->SetMatrix( "world", _world()); //&mWorld );
        _effect->SetFloat( "time",dxtime() );
		_effect->SetTexture("tex",_texture);
		_effect->SetTexture("tex0",_texture);
		_effect->SetTexture("tex1",_texture);
        }

    return hr;
}


int
shaderx::_render(  ) 
{
HRESULT hr = S_OK;

    UINT iPass, cPasses;
    
	render_begin(_device);
	
	_device->SetTexture( 0, _texture );

	

		hr = _effect->Begin(&cPasses, 0);
		
        
        for (iPass = 0; iPass < cPasses; iPass++)
        {
          hr = _effect->BeginPass(iPass);
           
		   if (1) hr = scene::_render();

		   _effect->EndPass();
		}

		
        _effect->End();
	   
    
	
    
	render_end(_device);

 

    return hr;
}

