#include <hush/source.h>
#include <scene/text.h>
#include <scene/sim.h>
#include <scene/slides.h>

#include "help.h"


int text_help::operator()() {

if (state != 5) state = 5; 
else state = random(0,5);

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
_sim->schedule(this,_gn->exponential(t));
return 0;

}

scene* text_help::create(char* opts) { return new text_help(opts); }

text_help::text_help(char* opts) 
{
  
	clear(&msg);

	//opt("style","plain");
	opt("display","help help");
	opt("text(title)","  help help ");
	opt("text(sub)","    toneelgroep                        amsterdam");
	opt("space","vip/morph");

	//opt("text(authors)","A. Eliens, Z. Huang, J.F. Hoorn, C.T. Visser");
	

	opt("slides","d:\\vip\\media\\helphelp.jpg");

	opt("logo(3d)","...");
	opt("logo(3ds)","helphelp");
	opt("logo(vip)","helphelp");

	//sc("slides",new slides("..\\present\\help","img0",1,3,"jpg"));

	// --------------------------------------------------------

	msg[5][11] = "http://www.toneelgroepamsterdam.nl";

	msg[0][1] = "n/space:  normal mode";
	msg[0][3] = "                      ";
	msg[0][4] = "c (commands): s(tart) 1-9";
	
	msg[0][7] = "v (video):   1-4 (display)  b(ack) u(under) v(ideo)    ";
	msg[0][8] = "x (effects): m(orph)  s(pectrum)  k(not)  f(lag) ";
	msg[0][9] = "             r(unning) t(trio) u(under)  w(ater)  ";
	msg[0][10]= "t (text):    t(amtam) h(elp) d(isplay) m(essage)                    ";
	msg[0][11] = "                     ";
	


	msg[2][0] = "help help help help help help";
	msg[2][1] = " help";
	msg[2][2] = "help help help help help";
	msg[2][3] = " help help ";
	msg[2][4] = "help help help help ";
	msg[2][5] = " help help help";
	msg[2][6] = "help help help ";
	msg[2][7] = " help help help help";
	msg[2][8] = "help help";
	msg[2][9] = " help help help help help";
	msg[2][10] = "help";


	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];


	msg[3][0] = "                                                 help ";
	msg[3][3] = "                                        help  ";
	msg[3][4] = "                               help ";
	msg[3][7] = "                      help ";
	msg[3][8] = "            help ";
	msg[3][9] = "help ";
	msg[3][11] = "                                                 help  ";

	
	msg[4][1] = "      toneelgroep amsterdam";
	msg[4][4] = "      ism ...";	
	msg[4][9] = "      (c) vrije universiteit";
	//msg[4][9] = "                    (C) AE      ";



}

text_help::~text_help()
{
//delete scenes[];
}

int 
text_help::_load()
{
    HRESULT hr = S_OK;
    count = 4;

	_text = scenes[1] = new text(&msg);
    

	hr = scene::_load(); // loops through scenes

    return hr;
}

int
text_help::_restore()
{
    HRESULT hr = S_OK;
 

    return hr;
}


int
text_help::_render( ) 
{
int hr = S_OK;


    _text->state = state;

	render_begin(_device);

    
   

	hr = scene::_render(); // calls compose, restore,  render

	
    
	render_end(_device);

 

    return hr;
}

