#include <hush/source.h>
#include <scene/text.h>

#include <scene/sim.h>
#include <scene/slides.h>

#include "xtext.h"

int generic_text::next(int t) {

	int m = iopt("max");
	state = state + t;
	if (state > m+1) state = state - m - 1;
	return state;
}

int generic_text::operator()() {

if (iopt("random")) {
       if (state != 5) state = iopt("max"); 
       else state = random(0,iopt("max"));
}
	

_sim->passivate(this);
float t = 10.0;
if (state == 5) t = 5.0; 
//if (iopt("random")) 
_sim->schedule(this,_gn->exponential(t));

return 0;

}



scene* generic_text::create(char* opts) { return new generic_text(opts); }


generic_text::generic_text(char* opts) 
{
  
	clear(&msg);

	iopt("max",5);

    opt("display","ViP 2004");
	opt("text(title)","   ViP 2004 ");
	opt("text(sub)","webcams           video             images");

	//opt("slides","\\vip\\media\soutine.jpg");

	opt("logo(3d)","virtual");
	opt("logo(3ds)","poetry");
	opt("logo(vip)","ViP");

	if (opts) process(opts);



	// ----------------------------------------------------------------------------------

	/*
    msg[0][0] = "this is";
	msg[0][2] = "a first";
	msg[0][4] = "demonstration";
	msg[0][6] = "of the ViP system";
	msg[0][8] = "to enhance your party";
	msg[0][10] = "with";
	






	msg[2][0] = "it supports";
	msg[2][1] = " multiple webcams";
	msg[2][2] = "mixed with";
	msg[2][3] = " video";
	msg[2][4] = "and";
	msg[2][5] = " images";
	msg[2][6] = "enhanced by";
	msg[2][7] = " 3D animations";
	msg[2][8] = "and";
	msg[2][9] = " text";
	msg[2][10] = "in an integrated fashion";

		
	msg[1][1] = msg[2][1];
	msg[1][3] = msg[2][3];
	msg[1][5] = msg[2][5];
	msg[1][7] = msg[2][7];
	msg[1][9] = msg[2][9];

	msg[3][0] = "for your party ";

	msg[3][3] = "x we create a";
	msg[3][4] = "x ViP presentation";

	msg[3][7] = "x with your content";
	msg[3][8] = "xand special effects";

	msg[3][11] = "x to entertain your audience";


	msg[4][1] = "x       ViP 2004";


	msg[4][6] = "xinformation and licenses";
	
	msg[4][8] = "x info@virtualpoetry.tv";
	msg[4][9] = "x www.virtualpoetry.tv";
    
    */

}

generic_text::~generic_text()
{
//delete scenes[];
}

HRESULT 
generic_text::init(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
    count = 4;
    int lines = 18;
	for (int i = 0; i < 12; i++)
		for (int j = 0; j < lines; j++) 
			if (opt(fm("line(%d,%d)",i,j))) msg[i][j] = opt(fm("line(%d,%d)",i,j));

	_text = scenes[1] = new text(&msg);
	_text->iopt("lines",lines);
    

	hr = scene::init(device); // loops through scenes

	if (iopt("random")) _sim->schedule(this,_gn->exponential(5));

    return hr;
}

HRESULT 
generic_text::restore(IDirect3DDevice9* device)
{
    HRESULT hr = S_OK;
 

    return hr;
}


HRESULT 
generic_text::render( IDirect3DDevice9* device, IDirect3DTexture9* texture ) 
{
HRESULT hr = S_OK;


    _text->state = state;

	render_begin(device);

    
   

	hr = scene::render(device,texture); // calls compose, restore,  render

	
    
	render_end(device);

 

    return hr;
}

