#include <hush/source.h>

#include <hush/sys/bind.h>
//#include <iostream.h>
#include <string.h>

int binding::created = 0;
int binding::deleted = 0;

binding::binding() { _body = 0; _name = 0; binding::created++; }
binding::binding(char* s)  { _body = 0; rename(s); binding::created++; }
binding::binding(binding* x) { _body = x; _name=0; binding::created++; }

binding::~binding() { binding::deleted++; }

binding::binding(kit* , const char* name, int mode , void* ) {
    binding::created++;
    switch(mode) {
     default:
	_body = 0; rename(name);
	break;
     };
}

char* binding::name() const  { 
	return (_body && (_body != this))?_body->name():_name;
	}

void binding::rename(const char* s) {
	if (!_name) delete[] _name;
	_name = new char[strlen(s)+1];
	strcpy(_name,s);
	}

