#include <hush/sys/dlfcn.h>

//#ifdef DL_ENABLED
#ifndef WIN32
#include <dlfcn.h>
#else
#include <windows.h>
#endif
//#endif


void* hush_dlopen(const char* lib) {
//#ifdef DL_ENABLED
#ifndef WIN32
	return dlopen(lib,RTLD_LAZY);
#else
	return (void*) LoadLibrary(lib);
#endif
//	return (void*) 0;
//#endif
//	return (void*) 0;
	}
function hush_dlsym(void* handle, const char* cmd) {
//#ifdef DL_ENABLED
#ifndef WIN32
	return (function) dlsym(handle, cmd);
#else
	return (function) GetProcAddress((HINSTANCE)handle,cmd);
#endif
//	return (function) 0;
//#endif
//	return (function) 0;
	}

