#include <widgets/source.h>

#include <hush/widgets/chooser.h>
#include <hush/sys/bind.h>

char* filechooser::type() const { return "filechooser"; }

#define TYPE filechooser
#define ANCESTOR frame
#define OPTS "*"
#include "hush/widgets/create.i"


void filechooser::mask(const char* s) { 
	if (_exists()) _this()->mask(s); 
	else _error("mask");
	}

int filechooser::dirpath(const char* s) {
	if (_exists()) _this()->dirpath(s); 
	else return (int) _error("dirpath");
	}

const char* filechooser::mask() const { 
	if (_exists()) return _this()->mask(); 
	else return (char*) _error("mask");
	}

const char* filechooser::dirpath() const {
	if (_exists()) return _this()->dirpath(); 
	else return (char*) _error("dirpath");
	}

void filechooser::rescan() {
	if (_exists()) _this()->rescan(); 
	else _error("rescan");
	}

const char* filechooser::get() { 
	if (_exists()) return _this()->get(); 
	else return (char*) _error("get");
	}

void filechooser::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac, args);
	}
