#include <widgets/source.h>

#include <hush/widgets/glxwin.h>
#include <hush/sys/bind.h>

char* glxwin::type() const { return "glxwin"; }

#define TYPE glxwin
#include "hush/widgets/create.i"


void glxwin::configure(const char* x) { 
	if (_exists()) _this()->configure(x); 
	else _error("configure");
	}

void glxwin::geometry(int x, int y) { 
	if (_exists()) _this()->geometry(x,y); 
	else _error("geometry");
	}

void glxwin::draw() { 
	if (_exists()) _this()->draw(); 
	else _error("draw");
	}

void glxwin::redraw() { 
	if (_exists()) _this()->redraw(); 
	else _error("redraw");
	}

void glxwin::link() { 
	if (_exists()) _this()->link(); 
	else _error("link");
	}

void glxwin::swap() { 
	if (_exists()) _this()->swap(); 
	else _error("swap");
	}


void glxwin::install(binding* ac, const char* args) {
	if (_exists()) _this()->install(ac, args);
	}
