#include <hush/sim/entity.h>
#include <hush/session.h>
#include <hush/string.h>

#undef string

#include <hush/java.h>
#include <hush/io.h>

#include <native/hush_dv_sim_entity.h>

#define method(X) Java_hush_dv_sim_entity_##X

JNIEXPORT jint JNICALL method(init)(JNIEnv *env, jobject obj,
  jint kf) 
{
  java_vm<entity>* vmp = new java_vm<entity>(env,obj,"Entity");
  entity* result =  new entity(0,0,0,(int) kf);
  result->_vmp = vmp;
  result->_register(vmp);
  session::_default->_register(result);
  return (jint) result;
}


JNIEXPORT jint JNICALL method(getPhase)(JNIEnv *env, jobject obj)
{
  java_vm<entity> vm(env,obj);
  return (jint) vm->phase();
}

JNIEXPORT void JNICALL method(setPhase)(JNIEnv *env, jobject obj,
  jint ph)
{
  java_vm<entity> vm(env,obj);
  vm->phase((int)ph);
}
