#include <hush/source.h>

#include <hush/widgets/tk/check.h>
#include <string.h>

#include <stdio.h>

#define TYPE checkbutton
#define CLASS tk_checkbutton
#include <hush/widgets/tk/create.i>


void CLASS::variable(const char* name) {
	_name = new char[strlen(name)+1];
	strcpy(_name,name);
	sprintf(buf,"%s configure -variable %s",path(), name);
	tk->eval( buf );
	}

int CLASS::value() {
	int n = 0;
	if (_name) {
		sprintf(buf,"set %s",(char*) _name);
		sscanf(tk->evaluate( buf ),"%d",&n);
		}
	return n;
	}


void CLASS::toggle() {
	sprintf(buf,"%s toggle",path());
	tk->eval( buf );
	}

void CLASS::select() {
	sprintf(buf,"%s select",path());
	tk->eval( buf );
	}

void CLASS::deselect() {
	sprintf(buf,"%s deselect",path());
	tk->eval( buf );
	}
