#include <hush/source.h>
#include <hush/widgets/tk/scale.h>
#include <hush/sys/bind.h>


#define TYPE scale
#define CLASS tk_scale
#include <hush/widgets/tk/create.i>

#include <stdio.h>


void CLASS::text(const char* s) {
	sprintf(buf,"%s configure -label {%s}", path(), s);
	tk->eval( buf );
	}

void CLASS::from(int n) {
	sprintf(buf,"%s configure -from %d", path(), n);
	tk->eval( buf );
	}

void CLASS::to(int n) {
	sprintf(buf,"%s configure -to %d", path(), n);
	tk->eval( buf );
	}

int CLASS::get() {
	sprintf(buf,"%s get",path());
	int n = 0; sscanf(tk->evaluate(buf),"%d",&n);
	return n;
	}

void CLASS::set(int v) {
	sprintf(buf,"%s set %d",path(),v);
	tk->eval( buf );
	}


void CLASS::install(binding* ac, const char* args) {
	sprintf(buf,"%s configure -command {%s %s}",path(),ac->name(),args);
	tk->eval( buf );
	}
