%% vip

%% see startup

%% selection: demo media party design relation abramovic

choice(2).

selection(default(0)) :- choice(0).
selection(camera(1)) :- choice(1).

selection(demo(0)) :- choice(2).
selection(media(2)) :- choice(3).
selection(design(1)) :- choice(4).

screen(1).

screen(800,600):- screen(0).
screen(1024,768):- screen(1).
screen(1280,800):- screen(2).
screen(1440,880):- screen(3).
screen(1280,1024):- screen(4).

%% machine config -- careful!

drive('d:').
cache('d:/vip/cache/').

profile(0). %% 1 = limited
hardware(0). %% nop yet

%% system info -- dont mess!

interact(option(1)). %% 0 default, 1 script/key 

:- consult('../lib/hush/pl/hush.pl').

%%machine(toshiba) :- !.
%%machine(tablet) :- !.
%%machine(sony) :- !.
%%machine(acer):- !.


vip(toshiba,1024,768):- !.
vip(sony,1280,768):- !.
vip(acer,1280,800):- !.
vip(tablet,1224,768):- !.
vip(_,1024,768):- !.

%% startup (dossier)

:- use(cfg(startup)). %% cfg/startup/pl/startup.pl
