%% create

start(create(_),nra:mgce:ms:a12345kxshvbuw:p2:n).
%%start(create(_),nra:mgce:a12345kxshvbuw:n).

opt(create(_), speed:1 = 4).
opt(create(_), speed:2 = 7).

opt(create(_), text:head = 'creative technology / AE').
opt(create(_), text:scroll:1 = 'creative technology -- universiteit twente -- new media  -- smart technology -- netherlands').
opt(create(_), text:scroll:2 = 'design      -- convergence --       mathematics      -- literacy --       computing      -- immersion -- ').

eq(create(_),l:c = lecture/create/aesthetics).
eq(create(_),l:g = lecture/create/announce).
eq(create(_),l:f = lecture/create/inspire).

eq(create(_), choice = 'n:ld:2l:ml2:mbcwhf:b0:n').
eq(create(_), command = 'n:sm9hss:n').
eq(create(_), effects = ':ss:exz:').
eq(create(_), objects = ':xo:ao:').
eq(create(x), objects = ':p0:9p:tp:').
eq(create(_), meta = ntd).
eq(create(_), cmd:meta = text). %% the display name

eq(create(c), choice = 'n:lc:2l:ml2:mbcwhf:b0:n').


lst(create(x),x/text = particle/text).
eq(create(x),x:t = particle/text).
eq(create(x),t:f = text/fed).
eq(create(x),t:p = particle/text).
eq(create(x),x:p = particle/try).
eq(create(x),s:d = slides/create).

program(create(x),9).
video(create(x),X) :- camera(video:clip = X).
%%video(create(x),X) :- X from [ sanguo(1) ].
video(create(x),X) :- X from [ flash ].
video(create(x),X) :- X from [ game(over) ].
video(create(x),X) :- X from [ tube(9/11) ].
%%video(create(x),X) :- X from [ sanguo(1) ].
video(create(x),X) :- X from [ netzhammer ].
video(create(x),X) :- X from [ sonic(nano) ].
video(create(x),X) :- X from [ tube(strings) ].
video(create(x),X) :- X from [ shout(strangest) ].
video(create(x),X) :- X from [ oxygen ].

lst(create(c),x/text = particle/text).
eq(create(c),x:t = particle/text).
eq(create(c),t:f = text/fed).
eq(create(c),t:p = particle/text).
eq(create(c),x:p = particle/try).
eq(create(c),s:d = slides/create).

program(create(c),9).
video(create(c),X) :- camera(video:clip = X).
%% video(create(c),X) :- X from [ flash ].
video(create(c),X) :- X from [ tube(strings) ].
%%video(create(c),X) :- X from [ game(over) ].
%%video(create(c),X) :- X from [ art(rgbxyz) ].
%%video(create(c),X) :- X from [ tube(calligraphy) ].
video(create(c),X) :- X from [ tube(doll-face) ].
%%video(create(c),X) :- X from [ tube(9/11) ].
video(create(c),X) :- X from [ netzhammer ].
video(create(c),X) :- X from [ tube(shark) ].
%%video(create(c),X) :- X from [ sonic(nano) ].
video(create(c),X) :- X from [ tube(web20) ].
video(create(c),X) :- X from [ tube(book) ].
video(create(c),X) :- X from [ art(beautiful) ].
video(create(c),X) :- X from [ shout(strangest) ].
video(create(c),X) :- X from [ tube(content) ].
%%video(create(c),X) :- X from [ oxygen ].

lst(create(f),x/text = particle/text).
eq(create(f),l:d = lecture/create/announce).
eq(create(f),s:f = slides/final).
eq(create(f), choice = 'n:ld:2l:ml2:mbcwhf:b0:n').
eq(create(f),x:t = particle/text).
eq(create(f),t:f = text/fed).
eq(create(f),t:p = particle/text).
eq(create(f),x:p = particle/try).
eq(create(f),s:d = slides/final).

program(create(f),9).
video(create(f),X) :- camera(video:clip = X).
%%video(create(f),X) :- X from [ sanguo(1) ].
%%video(create(f),X) :- X from [ flash ].
video(create(f),X) :- X from [ tube(strings) ].
video(create(f),X) :- X from [ game(over) ].
video(create(f),X) :- X from [ tube(9/11) ].
%%video(create(f),X) :- X from [ sanguo(1) ].
video(create(f),X) :- X from [ netzhammer ].
video(create(f),X) :- X from [ sonic(nano) ].
%%video(create(f),X) :- X from [ tube(strings) ].
%%video(create(f),X) :- X from [ flash ].
video(create(f),X) :- X from [ shout(strangest) ].
video(create(f),X) :- X from [ art(beautiful) ].
video(create(f),X) :- X from [ oxygen ].

lst(create(m),x/text = particle/text).
eq(create(m),l:c = lecture/game).
eq(create(m),s:f = slides/final).
eq(create(m), choice = 'n:lc:2l:ml2:mbcwhf:b0:n').
eq(create(m),x:t = particle/text).
eq(create(m),t:f = text/fed).
eq(create(m),t:p = particle/text).
eq(create(m),x:p = particle/try).
eq(create(m),s:d = slides/final).

program(create(m),9).
video(create(m),X) :- camera(video:clip = X).
%%video(create(m),X) :- X from [ 1 ].
video(create(m),X) :- X from [ tube(strings) ].
%%video(create(m),X) :- X from [ flash ].
video(create(m),X) :- X from [ sl(climb) ].
%%video(create(m),X) :- X from [ game(over) ].
%%video(create(m),X) :- X from [ tube(9/11) ].
video(create(m),X) :- X from [ tube(shark) ].
%%video(create(m),X) :- X from [ netzhammer ].
video(create(m),X) :- X from [ tube(doll-face) ].
video(create(m),X) :- X from [ sonic(nano) ].
video(create(m),X) :- X from [ art(beautiful) ].
video(create(m),X) :- X from [ tube(fall) ].
video(create(m),X) :- X from [ tube(citroen) ].
