//-----------------------------------------------------------------------------
// negative.hlsl
//
// Negative filter
//
// Copyright (c) 2004 Neatware. All rights reserved.
//-----------------------------------------------------------------------------

sampler2D tex0;
sampler2D tex1;

struct v2p {
	float4 Position		: POSITION;
	float4 Color		: COLOR0;
	float2 Texcoord0	: TEXCOORD0;
	float2 Texcoord1	: TEXCOORD1;
};


void main(in v2p IN, out float4 OUT : COLOR)
{
	float Brightness = 1.1;

	float3 color = tex2D(tex0, IN.Texcoord0);

	OUT.rgb = Brightness * color;
	OUT.a = 0.5;
}
